//"diag_dk.sc","51dk : diagnostyka dokumentw handlowych",12004,0,1.2.2,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// 51dk : diagnostyka dokumentw handlowych
// diag_dk.sc
////////////////////////////
// Napisa: Sebastian Nowak
// data:    98.07.10


#ifdef HM
#define HMHL
#endif
#ifdef HL
#define HMHL
#endif
//rejestr naliczony FWZ
#define REJ_NAL_FWZ 103
#define TYPzzDKFW	0x97
///////////////////////////////////////////////////////////////////////////
// dokumenty sprzeday
#define ANUL    0
#define WZANUL  1
#define ARCH	2
#define PARANUL	3
#define FWS		116		//Faktura wewnetrzna sprzedaz
#define WKS		118		//Faktura korygujca wewntrzna (sprzeday)
#define DIM		72		//Dokument importowy
#define DKM		73		//Dokument importowy korekta
#define WNT		115		
#define WNK		121	
//...
#ifdef HMHL
///////////////////////////////////////////////////////////////////////////
// dokumenty zakupu
#define FWZ		117		//Faktura wewnetrzna zakupu
#define WKZ		119		//Faktura korygujca wewntrzna (zakupu)
//...
#endif

string RodzDokS(1), RodzDokZ(1), sTypDk, msg(1)
int iSp=1, iZa=1, znacznik=0, imsg=1

string NAZWA_PLIKU = "DIAG_DK.TXT"

string sRaportDescription

#include "Diagnostyka - funkcje"
UsunRekord_0("DK")

sDialogTitle += "dokumentw handlowych"

StageAddDesc("Raport odtwarza dokumenty ktrych brak w bazie dokumentw a dla ktrych s")
StageAddDesc("pozycje w bazie pozycji dokumentw oraz uaktualnia dane o rodzajach i")
StageAddDesc("katalogach.")
StageAddStage("Porwnanie z baz wzorcow")
//#ifdef HM
StageAddStage("Sprawdzenie integralnoci bazy DK oraz IDK")
//#else
//StageAddStage("X")
//#endif
StageAddStage("Sprawdzenie poprawnoci typw dokumentw")
StageAddStage("Sprawdzanie rodzajw oraz katalogw")
StageAddStage("Sprawdzanie dokumentw na podstawnie pozycji dokumentw")
StageAddStage("Sprawdzanie wartoci NETTO, VAT, WALNETTO, WALBRUTTO oraz WARTPRZYCHOD")
StageAddStage("Sprawdzanie poprawnoci wartoci kursw")
ChooseStages(400)

#define DOK_DIAG "DIAG"

int dp2,kh,pn,mg

baseAll dk
baseAll dk2
baseAll dk3
baseAll xt
baseNT nt
baseAll dp
baseAll zz
baseAll zz2
baseAll bm
BaseXT basXT
basXT.open()

int stGw,bylyGw,iTemp,iTemp2
long lTemp
long wszystkie, wKoszu
string sBezNapr,sErrNapr, sErrXtNapr, sTemp
sErrXtNapr = "Bd zapisu do bazy XT"
MapValue rejestry
MapValue formyPlatn

float netto,vat,wartosc,zyskDod, walNetto, walBrutto, wartPrzychod
int bezKontr,brakPN
long super,nextDiagDok
long korygowaneBrak(1), rooty(1)
long iloscKorBr
int bylyFlag 

sErrNapr=" :  NIE NAPRAWIONO - bd wstawiania nowego rekordu\n"

stGw = CopyFont ( "tytu", 1, 50 )

// *************   funkcje  *****************

int Sub GetTypDk(string typDk)
	basXT.SetKey("kod")
	basXT.SetKeySeg("typi", 32) // typ dokumentu
	basXT.SetKeySeg("kod", typDk)
	if !basXT.GetRec(GE) then
		GetTypDk = basXT.GetField("long")
	else
		GetTypDk = 0
	endif
EndSub

int sub ZapiszGwiazdki()
	int temp
	bylyGw=1
	temp=SetFont(stGw)
	TextOut(" *** ")
	SetFont(temp)
endsub

int sub SprawdzTypyDok(long sup)

	int podkat
	long zawart
  BaseXT lxt

	lxt.Open()

	lxt.SetKey("super")
	lxt.SetKeySeg("super",sup)
	err=lxt.GetRec(GE)
	while !err && lxt.GetKeySeg("super")==sup
		if lxt.GetField("subtypi")==26 then
			podkat+=1
			if sup == 7000 then
				select case lxt.GetField("id")
					case 7001 //dokumenty sprzedazy
						znacznik=1
					case 7009	//dokumenty zakupu
						znacznik=2
					case else //inne dokumenty
						znacznik=0
				endselect
			endif
			SprawdzTypyDok(lxt.GetField("id"))
		else
			dk.SetKeySeg("id",lxt.GetField("klient"))
			select case znacznik
				case 1
					RodzDokS(iSp)=lxt.GetField("kod")
					grow RodzDokS, 1
					iSp+=1
				case 2
					RodzDokZ(iZa)=lxt.GetField("kod")
					grow RodzDokZ, 1
					iZa+=1
			endselect
			if dk.GetKey(EQ) then
				ZapiszGwiazdki()
				if TextOutAndAsk(1,(using "Brak rekordu opisujcego typ dokumentu '%s'",lxt.GetField("kod")),". Czy naprawi?") then
					// odtworzenie rekordu typu dokumentu
					dk.Clear()
					dk.SetField("id",lxt.GetField("klient"))
					dk.SetField("typi",101)
					dk.SetField("katalog",lxt.GetField("super"))
					dk.SetField("kod",lxt.GetField("kod"))
					dk.SetField("nazwa",lxt.GetField("kod"))
					InsertRecB(dk)
				else
					TextOut(sNoRepair)
				endif
			endif		
		endif
		err=lxt.GetRec(NX)
	wend

	lxt.Close()

endsub

int sub pom1()
	if err then 
		TextOut("Istnienie tej informacji jest konieczne dla dalszego prawidowego dziaania raportu.\nPrzerwano...")
		end
	endif
endsub

int sub SprawdzRooty( long d_lRoot, string sNazDok )
	err=0
	if xt.GetRecById(d_lRoot) then Message( using "Brak gwnego katalogu dokumentw %s id=%l w bazie katalogw. Uruchom raport diagnostyczny bazy katalogw XT.",sNazDok,d_lRoot) : error ""

	// rodzaje
	if xt.GetRecById(d_lRoot+1000) then Message (using "Brak gwnego rodzaju dokumentw %s id=%l w bazie katalogw. Uruchom raport diagnostyczny bazy katalogw XT",sNazDok,d_lRoot+1000) : error ""

	if dk.GetRecByID(d_lRoot + 1000) then Message(using "Brak gwnego rodzaju dokumentw %s id=%l w bazie dokumentw. Rekord ten powinien zosta dodany wczeniej tym raportem. Uruchom go ponownie,",sNazDok,d_lRoot+1000) : error ""

	// drzewo katalogw
	if xt.GetRecById(d_lRoot+2000) then Message( using "Brak rekordu root katalogu dokumentw %s id=%l w bazie katalogw. Uruchom raport diagnostyczny bazy katalogw XT.",sNazDok,d_lRoot+2000) : error ""

endsub

int sub ZliczDlaRodzaju(long kat, int czyNaprawiac)

	long a,b,root
	// sprawdzenie czy jest w bazie dk
	if czyNaprawiac then

		// sprawdz czy instnieje rek.w bazie DK
		dk.SetKeySeg("id",xt.GetField("klient"))
		if dk.GetKey(EQ) then
			ZapiszGwiazdki()
			if TextOutAndAsk(2,(using "Brak danych o rodzaju '%s'",xt.GetField("kod")),". Czy naprawi?") then
				dk.Clear()
				dk.SetField("id",xt.GetField("klient"))
				dk.SetField("katalog",kat)
				dk.SetField("kod",xt.GetField("kod"))
				dk.SetField("nazwa",xt.GetField("kod"))
				dk.SetField("plattypi",255)
				dk.SetField("grupaceni",255)
				dk.SetField("rodzaj", xt.GetField("id") )
				dk.SetField("typi",99)
				dk.SetField("znaczniki", xt.GetField("subtypi"))

				InsertRecB(dk)
			else
				TextOut(sNoRepair)
			endif
		endif

	else

		// zliczenie
		root=xt.GetField("id")
		dk.SetKey("rodzaj")
		dk.SetKeySeg("rodzaj",root)
		dk.SetKeySeg("typi",0)
		dk.SetKeySeg("kod","")
		err=dk.GetRec(GE)
		while !err && dk.GetKeySeg("rodzaj")==root
			if dk.GetField("typi") != 99 then	a+=1
			err=dk.GetRec(NX)
		wend
		b=xt.GetField("zawartosc")
		if a!=b then
			xt.SetField("zawartosc",a)
			if xt.Update() then
				TextOut(using "NIE POPRAWIONO iloci dokumentw w rodzaju '%s' - %s\n",xt.GetField("kod"), sErrXtNapr)
			else	
				TextOut(using "Zmieniono ilo dokumentw z %d na %d dla rodzaju '%s'\n",b,a,xt.GetField("kod"))
			endif
		endif

	endif
endsub

int sub ZliczRodzaje( long root, int czyNaprawiac, string nap )

	int podkatalog

	dk.SetKey("id")
	xt.SetKey("id")
	xt.SetKeySeg("id",root)
	if xt.GetRec(EQ) then error using "Bd bazy XT: brak gwnego rekordu rodzajw (id=%l)", root

	// zliczenie dla gownego
	ZliczDlaRodzaju(root, czyNaprawiac)

	xt.SetKey("super")
	xt.SetKeySeg("super",root)
	err=xt.GetRec(GE)
	while !err && xt.GetKeySeg("super")==root
		podkatalog+=1
		ZliczDlaRodzaju(root, czyNaprawiac)
		err=xt.GetRec(NX)
	wend

	if !czyNaprawiac then
		// zapisanie ilosci rodzajw
		xt.GetRecById(root)	
		if xt.GetField("podkatalog")!=podkatalog then
			TextOut(using "Zmieniono ilo wszystkich rodzajw dokumentw %s.\n",nap)
			xt.SetField("podkatalog",podkatalog)
			if xt.Update() then error sErrXtNapr
		endif
	endif
endsub

int sub StworzRodzajwXT(long idwXt, long klient, string kod, long root,int subtyp)
	xt.Clear()
	xt.SetField("id",idwXt)
	xt.SetField("subtypi",subtyp)
	xt.SetField("super",root)
	xt.SetField("root",root)
	xt.SetField("kod",kod)
	select case root
		case 3600 
			xt.SetField("nazwa",":LSZK.TPL:?QRodzZK")
			xt.SetField("typi",66)
			xt.SetField("bazai",34)
		case 3300
			xt.SetField("nazwa",":LSDK.TPL:?QRodzDK")
			xt.SetField("typi",6)
			xt.SetField("bazai",16)
	endselect
	xt.SetField("klient",klient)
	StworzRodzajwXT=!xt.Insert()
endsub

int sub StworzRodzaj(long idwXt, int gdzie)
	long lTemp
	long root
	StworzRodzaj=0
	dk2.GetKey(LS)
	lTemp=dk2.GetKeySeg("id")+1
	dk2.Clear()
	dk2.SetField("id",lTemp)
	dk2.SetField("typi",99)
	dk2.SetField("plattypi",255)
	dk2.SetField("grupaceni",255)
	dk2.SetField("rodzaj", idwXt)
	select case gdzie
		case 0
			root=3300
		case 202
			root=3600
	endselect
	dk2.SetField("katalog",root)
	dk2.SetField("kod",(using "@ %l",idwXt))
	if !dk2.Insert() then
		if StworzRodzajwXT(idwXt,lTemp,(using "@ %l",idwXt),root,0) then
			StworzRodzaj=1
		else
			dk2.Delete()
		endif
	endif
endsub

int sub StworzKatalog(long idwXt, string subtyp, string exKod, int gdzie)
	xt.Clear()
	xt.SetField("id",idwXt)
	xt.SetField("subtypi",val(subtyp))
	xt.SetField("kod", (using "@%s %l",exKod,idwXt))
	xt.SetField("bazai",16)
	select case gdzie
		case 0,100
			xt.SetField("typi",14)
			xt.SetField("super",2300)
			xt.SetField("nazwa",":LSDK.TPL:?QKatDK")
		case 202,112
			xt.SetField("typi",62)
			xt.SetField("super",2600)
			xt.SetField("nazwa",":LSZK.TPL:?QKatZK")
	endselect
	xt.SetField("root",xt.GetField("super"))
	StworzKatalog=!xt.Insert()
endsub

int sub SprawdzKatalog(BaseAll xtBase)

	int dk2
  BaseAll lxt
	lxt.SetBase("XT")

	long zawartosc,id
	SprawdzKatalog=0
	dk2=OpenBase("dk")
	lxt.Open()

	id=xtBase.GetField("id")
	// zliczenie iloci dokumentw
	SetKey(dk2,"katalog")
	SetKeySeg(dk2,"katalog",id)
	err=GetRec(dk2,GE)
	while !err && GetKeySeg(dk2,"katalog")==id
		if GetField(dk2,"typi")==100 || GetField(dk2,"typi")==112 then
			wKoszu+=1
		else
			wszystkie+=1
		endif
		zawartosc+=1
		err=GetRec(dk2,NX)
	wend
	if xtBase.GetField("zawartosc")!=zawartosc then
		TextOut(using "Zmieniono ilo dokumentw z %d na %d w katalogu '%s'\n",xtBase.GetField("zawartosc"),zawartosc,xtBase.GetField("kod"))
		xtBase.SetField("zawartosc",zawartosc)
		SprawdzKatalog=1
	endif

	// sprawdzenie podkatalogw
	lxt.SetKey("super")
	lxt.SetKeySeg("super",id)
	err=lxt.GetRec(GE)
	while !err && lxt.GetKeySeg("super")==id
		if SprawdzKatalog(lxt) then
			if lxt.Update() then TextOut(using "NIE POPRAWIONO - %s\n", sErrXtNapr)
		endif
		err=lxt.GetRec(NX)
	wend

	close dk2
	lxt.Close()

endsub

int sub SprawdzDokumenty(long root, string nap)

	int podkatalog
	long temp
	xt.SetKey("id")
	xt.SetKeySeg("id",root)
	if xt.GetRec(EQ) then exit
	PopUp(1,(using "Sprawdzanie dokumentw %s\n",nap))
	WriteStatusBar(using "Sprawdzanie dokumentw %s",nap)

	PopUp(2,"Sprawdzanie katalogw")
	wszystkie=wKoszu=0
	if SprawdzKatalog(xt) then
		if xt.Update() then
			TextOut(using "NIE NAPRAWIONO - %s\n", sErrXtNapr)
			exit
		endif
	endif
	
	PopUp(2,"Sprawdzanie rodzajw")
	root+=1000

	ZliczRodzaje(root, 0, nap)		// 0 - bez sprawdzania istnienia rekordu w bazie DK

	// zapisanie wartoci wszystkich oraz w koszu
	if xt.GetRecById(root+1000) then error "Brak rekordu w bazie XT"
	if xt.GetField("zawartosc")!=wszystkie then
		TextOut(using "Poprawiono ilo wszystkich dokumentw z %d na %d\n",xt.GetField("zawartosc"),wszystkie)
		xt.SetField("zawartosc",wszystkie)
		if xt.Update() then error sErrXtNapr
	endif

	if ((firma.code != "HL") && (firma.code != "FL")) then
		if xt.GetRecById(root+1099) then error "Brak rekordu w bazie XT"
		if xt.GetField("zawartosc")!=wKoszu then
			TextOut(using "Poprawiono ilo wszystkich dokumentw w koszu z %d na %d\n",xt.GetField("zawartosc"),wKoszu)
			xt.SetField("zawartosc",wKoszu)
			if xt.Update() then error sErrXtNapr
		endif
	endif

endsub

int sub Pom2()
	xt.SetKey("kod")
	xt.SetKeySeg("typi",val(sTemp))
	xt.SetKeySeg("kod",dk.GetField("kod"))
	xt.SetKeySeg("super",0)
	Pom2 = (xt.GetRec(GE) || xt.GetField("typi")!=val(sTemp) || xt.GetField("kod")!=dk.GetField("kod") )
endsub

int sub CzyIstRodzaj()

	select case dk.GetField("katalog")
		case 3600
			sTemp = "66"
		case else
			sTemp = "6"
	endselect

	if ((firma.code == "HM") || (firma.code == "HL")) then
		xt.SetKeySeg( "id", dk.GetField( "rodzaj") )
		CzyIstRodzaj = xt.GetKey( EQ)

		if CzyIstRodzaj then

			CzyIstRodzaj = Pom2()

			if !CzyIstRodzaj then
				if TextOutAndAsk(3,(using "Rodzaj '%s' ma niewaciwe powizanie z rekordem w bazie XT", xt.GetField( "kod")),". Czy naprawi?" ) then
					dk.SetField( "rodzaj", xt.GetFIeld("id") )
					UpdateRecB(dk)
				else
					TextOut( sNoRepair )
					CzyIstRodzaj = 1
				endif
			endif
		endif

	else
		CzyIstRodzaj = Pom2()
	endif

	xt.SetKey("id")
endsub

int sub AskAndOdtworzRekPN(int typ,int baza, int askk)
	zz2.SetKeySeg("typi",typ)
	zz2.SetKeySeg("baza1",baza)
	zz2.SetKeySeg("id1",dk.GetField("id"))
	zz2.SetKeySeg("baza2",0)
	zz2.SetKeySeg("id2",0)
	if !zz2.GetRec(GE) && zz2.GetKeySeg("typi")==typ && zz2.GetKeySeg("baza1")==baza && zz2.GetKeySeg("id1")==dk.GetField("id") then exit
	buf="zakupu"
	if baza==0x10 then buf="sprzeday"
	if TextOutAndAsk3(askk,(using "Dokument '%s' id=%l nie posiada rekordu dokumentu %s nierozliczonego pininie w bazie ZZ",dk.GetField("kod"),dk.GetField("id"),buf)) then
		zz2.Clear()
		zz2.SetField("typi",typ)
		zz2.SetField("baza1",baza)
		zz2.SetField("id1",dk.GetField("id"))
		zz2.SetField("baza2",20)
		zz2.SetField("id2",dk.GetField("khid"))
		zz2.SetField("kod1",dk.GetField("kod"))
		zz2.SetField("kod2",dk.GetField("khkod"))
		zz2.SetField("data",dk.GetField("data"))
		zz2.SetField("termin",dk.GetField("plattermin"))
		zz2.SetField("cena",dk.GetField("netto")+dk.GetField("vat"))
		zz2.SetField("opis",dk.GetField("nazwa"))
		zz2.SetField("ilosc2",dk.GetField("netto")+dk.GetField("vat") - dk.GetField("wplaty"))
		InsertRecB(zz2)
	else
		TextOut(sNoRepair)
	endif
endsub

int sub AskAndOdtworzRekZZ(int typ,int baza, int askk, int flag)
	zz2.SetKeySeg("typi",typ)
	zz2.SetKeySeg("baza1",baza)
	zz2.SetKeySeg("id1",dk.GetField("id"))
	zz2.SetKeySeg("baza2",0)
	zz2.SetKeySeg("id2",0)
	if !zz2.GetKey(GE) && zz2.GetKeySeg("typi")==typ && zz2.GetKeySeg("baza1")==baza && zz2.GetKeySeg("id1")==dk.GetField("id") then exit
	buf="zakupu"
	if baza==0x10 then buf="sprzeday"
	if TextOutAndAsk3(askk,(using "Dokument '%s' id=%l nie posiada rekordu dokumentu %s nierozliczonego magazynowo w bazie ZZ",dk.GetField("kod"),dk.GetField("id"),buf)) then
		zz2.Clear()
		zz2.SetField("typi",typ)
		zz2.SetField("flag",flag)
		zz2.SetField("baza1",baza)
		zz2.SetField("id1",dk.GetField("id"))
		zz2.SetField("baza2",20)
		zz2.SetField("id2",dk.GetField("magazyn")*0x1000000+dk.GetField("khid"))
		zz2.SetField("kod1",dk.GetField("kod"))
		zz2.SetField("kod2",dk.GetField("khkod"))
		zz2.SetField("data",dk.GetField("data"))
		zz2.SetField("termin",dk.GetField("data"))
		zz2.SetField("cena",dk.GetField("netto")+dk.GetField("vat"))
		zz2.SetField("opis",dk.GetField("nazwa"))
		zz2.SetField("magazyn",dk.GetField("magazyn"))
		InsertRecB(zz2)
	else
		TextOut(sNoRepair)
	endif
endsub
int sub DodajKhZDokumentu( BaseAll baza, int handl)
	BaseKH kh2
	BaseZZ zz2

	kh2.Open()
	zz2.Open()	
	zz2.SetKey("id")
	
	kh2.Clear()

	kh2.SetField("id",baza.GetField("khid"))
	kh2.SetField("kod",baza.GetField("khkod"))
	kh2.SetField("nazwa",baza.GetField("khnazwa"))
	kh2.SetField("ulica",baza.GetField("khadres"))
	kh2.SetField("dom",baza.GetField("khdom"))
	kh2.SetField("lokal",baza.GetField("khlokal"))
	kh2.SetField("miejscowosc",baza.GetField("khmiasto"))
	kh2.SetField("kodpocz",baza.GetField("khkodpocz"))
	kh2.SetField("nip",baza.GetField("khnip"))
	kh2.SetField("rodzaj",3100)
	kh2.SetField("katalog",2100)
	kh2.SetField("grupaceni",255)
	if handl then 
		kh2.SetField("plattypi",baza.GetField("plattypi"))
		zz2.SetKeySeg("id",baza.GetField("formaplatn"))
		if !zz2.GetRec(EQ) && zz2.GetField("typi")==161 then kh2.SetField("formaplatn",zz2.GetField("id1"))
	else
		kh2.SetField("plattypi",255)
	endif

	if !kh2.InsRec() then
		TextOut(sRepaired)
	endif
	kh2.close()
	zz2.close()
endsub

int sub DodajKhOdZDokumentu( BaseAll baza, int handl)
	BaseKH kh2

	kh2.Open()

	kh2.Clear()
	
	kh2.SetField("id",baza.GetField("odid"))
	kh2.SetField("kod",baza.GetField("odkod"))
	kh2.SetField("nazwa",baza.GetField("odnazwa"))
	kh2.SetField("ulica",baza.GetField("odadres"))
	kh2.SetField("dom",baza.GetField("oddom"))
	kh2.SetField("lokal",baza.GetField("odlokal"))
	kh2.SetField("miejscowosc",baza.GetField("odmiasto"))
	kh2.SetField("kodpocz",baza.GetField("odkodpocz"))
	kh2.SetField("rodzaj",3100)
	kh2.SetField("katalog",2100)
	kh2.SetField("grupaceni",255)
	kh2.SetField("plattypi",255)
	
	if !kh2.InsRec() then
		TextOut(sRepaired)
	endif
	kh2.close()
endsub

int sub CopyIDKtoDK(int idkbase, BaseAll dkbase)
	dkbase.Clear()
	dkbase.SetField("id",GetField(idkbase,"id"))
	dkbase.SetField("subtypi",GetField(idkbase,"subtypi"))
	dkbase.SetField("typi",GetField(idkbase,"typi"))
	dkbase.SetField("znaczniki",GetField(idkbase,"znaczniki"))
	dkbase.SetField("rodzaj",GetField(idkbase,"rodzaj"))
	dkbase.SetField("katalog",GetField(idkbase,"katalog"))
	dkbase.SetField("osoba",GetField(idkbase,"osoba"))
	dkbase.SetField("kod",GetField(idkbase,"kod"))
	dkbase.SetField("typ_dk",GetField(idkbase,"typ_dk"))
	dkbase.SetField("seria",GetField(idkbase,"seria"))
	dkbase.SetField("data",GetField(idkbase,"data"))
	dkbase.SetField("plattermin",GetField(idkbase,"plattermin"))
	dkbase.SetField("khid",GetField(idkbase,"khid"))
	dkbase.SetField("khkod",GetField(idkbase,"khkod"))
	dkbase.SetField("odid",GetField(idkbase,"odid"))
	dkbase.SetField("odkod",GetField(idkbase,"odkod"))
	dkbase.SetField("oki",GetField(idkbase,"oki"))
	dkbase.SetField("wplaty",GetField(idkbase,"wplaty"))
	dkbase.SetField("netto",GetField(idkbase,"netto"))
	dkbase.SetField("vat",GetField(idkbase,"vat"))
	dkbase.SetField("wartoscSp",GetField(idkbase,"wartoscSp"))
	dkbase.SetField("zyskdod",GetField(idkbase,"zyskdod"))
	dkbase.SetField("rejestrVati",GetField(idkbase,"rejestrVati"))
	dkbase.SetField("magazyn",GetField(idkbase,"magazyn"))
	dkbase.SetField("rozlmgi",GetField(idkbase,"rozlmgi"))
	dkbase.SetField("info",GetField(idkbase,"info"))
	dkbase.SetField("dzial",GetField(idkbase,"dzial"))
	dkbase.SetField("okres",GetField(idkbase,"okres"))
	dkbase.SetField("serianr",GetField(idkbase,"serianr"))
	dkbase.SetField("opis",GetField(idkbase,"opis"))
endsub

int Sub CzyFaktWew(int iTyp)
	Select Case iTyp
		Case FWS, WKS
			CzyFaktWew = 1
#ifdef HMHL
		Case FWZ, WKZ
			CzyFaktWew = 1
#endif
			
		Case Else
			CzyFaktWew = 0
	EndSelect
EndSub

// dodany ze wzgldu na rozmiar pliku diag_dk.sc
#include "Sprawd baz dokumentw - include"

// ************** program *****************

OpenBaseB(xt,"XT")
kh = OpenBase("kh")
pn = OpenBase("pn")
OpenBaseB(dk,"DK")
OpenBaseB(dk2,"DK")
OpenBaseB(dp,"DP")
OpenBaseB(zz,"ZZ")
OpenBaseB(zz2,"ZZ")
zz2.SetKey("cross1")
if (firma.code == "HM") || (firma.code == "HL") then
	OpenBaseB(bm,"BM")
	bm.SetKey("idhandl")
endif

TextOut("Podsumowanie sprawdzania poprawnoci bazy dokumentw handlowych\n\n")


if StageT(1) then SprawdzWzorcowa()
StageSummary(1)
if StageT(2) then SprawdzIDK()
StageSummary(2)

PopUp(1,"Sprawdzanie opisw typw dokumentw")

// znalezienie rejestrw
rejestry.Type(int)
rejestry.Set("255",1)
xt.SetKey("super")
xt.SetKeySeg("super",3400)
xt.SetKeySeg("kod","")
err=xt.GetRec(GE)
while !err && xt.GetField("super")==3400
	rejestry.Set((using "%d",xt.GetField("klient")),1)
	err=xt.GetRec(NX)
wend

dk.SetKey("id")
if StageT(3) then SprawdzTypyDok(7000)
StageSummary(3)

SprawdzRooty(2300,"sprzeday")	// sprzeda
if ((firma.code == "HM") || (firma.code == "HL")) then SprawdzRooty(2600,"zakupu")

if StageT(4) then
	ZliczRodzaje(3300, 1, "sprzeday")
	if ((firma.code == "HM") || (firma.code == "HL")) then ZliczRodzaje(3600, 1, "zakupw")

	// sprawdzenie, czy kady dokument ma swj rodzaj i katalog

	SetKey(pn,"dkid")	
	SprawdzRodzKat()
	StageSummary(4)
endif

if StageT(5) then
	// sprawdzanie dokumentw na podstawnie pozycji dokumentw

	PopUp(1,"Sprawdzanie dokumentw:")

	OdzyskDok()

	PopUp(1,"")
	PopUp(2,"")

	// zliczenie iloci dokumentw w katalogach i rodzajach
	SprawdzDokumenty(2300,"sprzeday")		// sprzeda
	if ((firma.code == "HM") || (firma.code == "HL")) then SprawdzDokumenty(2600,"zakupw")		// zakup

	StageSummary(5)

endif

// sprawdzenie, czy zgadzaj si wartoci w dokumentach z sum pozycji


PopUp(1,"Sprawdzanie wartoci NETTO, VAT, WALNETTO, WALBRUTTO oraz WARTPRZYCHOD")
PopUp(2,"")
WriteStatusBar("Sprawdzanie wartoci NETTO, VAT, WALNETTO, WALBRUTTO oraz WARTPRZYCHOD")

if StageT(6) then

dp.SetKey("super")
dp.SetKeySeg("super",0)
dp.SetKeySeg("lp",0)
dk.SetKey("id")
do
	wartosc=netto=vat=walNetto=walBrutto=wartPrzychod=0
	zyskDod=0
	err=dp.GetRec(GE)
	if !err then
		super=dp.GetField("super")
		while !err && dp.GetKeySeg("super")==super
			if (!(dp.GetField("flag")&0x1000) && !(dp.GetField("flag")&0x2000)) then // komplet lub anulowano
				netto+=dp.GetField("wartNetto")
				vat+=dp.GetField("wartVat")
				wartosc += dp.GetField("wartTowaru")
				zyskDod += dp.GetField("iloscdorozl")*dp.GetField("zyskDod")
				walNetto+=dp.GetField("walNetto")
				walBrutto+=dp.GetField("walBrutto")
				wartPrzychod+=dp.GetField("wartPrzychod")
			endif
			err=dp.GetRec(NX)
		wend
		dp.SetKeySeg("lp",0)
		dp.SetKeySeg("super",super+1)
		dk.SetKeySeg("id",super)
		
		CheckWalBrutto(dk)

		if !dk.GetRec(EQ) && dk.GetField("subtypi")!=0 && dk.GetField("subtypi")!=1 && dk.GetField("subtypi")!=2 && dk.GetField("subtypi")!=3 then
			PopUp(2,dk.GetField("kod"))
			

	
			bylyFlag = 0
	
			if Sign(dk.GetField("netto")-netto,2)				then bylyFlag += 1
			if Sign(dk.GetField("vat")-Round(vat,2),2)			then bylyFlag += 2
			if Sign(dk.GetField("walNetto")-walNetto,2)			then bylyFlag += 4
			if Sign(dk.GetField("walBrutto")-walBrutto,2)		then bylyFlag += 8
//			if Sign(dk.GetField("wartPrzychod")-wartPrzychod,2)	then bylyFlag += 16

			if bylyFlag then
				ZapiszGwiazdki()
				TextOut("Nie zgadza si warto")
				if bylyFlag&1 then
					TextOut(" NETTO")
				endif
				if bylyFlag&2 then 
					if bylyFlag&1 && bylyFlag >=4 then TextOut(",")
					if bylyFlag&1 && bylyFlag <4 then TextOut(" oraz")
					TextOut(" VAT")
				endif
				if bylyFlag&4 then 
					if bylyFlag&3 && bylyFlag >=8 then TextOut(",")
					if bylyFlag&3 && bylyFlag <8 then TextOut(" oraz")
					TextOut(" WALNETTO")
				endif
				if bylyFlag&8 then 
					if bylyFlag&7 && bylyFlag >=16 then TextOut(",")
					if bylyFlag&7 && bylyFlag <16 then TextOut(" oraz")
					TextOut(" WALBRUTTO")
				endif
/*
				if bylyFlag&16 then 
					if bylyFlag&15 then TextOut(" oraz")
					TextOut(" WARTPRZYCHOD")
				endif
*/	
				TextOut(using " w dokumencie '%s' id=%l\n",dk.GetField("kod"),dk.GetField("id"))
			endif

			if (firma.code == "HM") || (firma.code == "HL") then
				if Sign(dk.GetField("wartoscSp")-wartosc) then
					buf = using "Nie zgadza si warto towaru rozliczonego magazynowo z sum pozycji w dokumencie '%s' id=%l",dk.GetField("kod"),dk.GetField("id")
					TextOut(buf)
					if Ask( 9, using "%s\njest: %.2f powinno by: %.2f\nCzy naprawi?",buf,dk.GetField("wartoscSp"),wartosc ) then
						dk.SetField("wartoscSp",wartosc)
						UpdateRecB(dk)
					else
						TextOut(sNoRepair)
					endif
				endif
				if Sign(dk.GetField("zyskDod")-zyskDod) then
					buf = using "Nie zgadza si kwota zysku w dokumencie '%s' id=%l\n",dk.GetField("kod"),dk.GetField("id")
					TextOut(buf)
					if Ask( 9, using "%sjest: %.2f powinno by: %.2f\nCzy naprawi?",buf,dk.GetField("zyskDod"),zyskDod ) then
						dk.SetField("zyskDod",zyskDod)
						UpdateRecB(dk)
					else
						TextOut(sNoRepair)
					endif
				endif
			endif

/*
			if bylyFlag&1 then
				buf = using "Nie zgadza si warto netto dokumentu z sum pozycji w dokumencie '%s' id=%l",dk.GetField("kod"),dk.GetField("id")
				TextOut(buf)
				if Ask( 21, using "%s\njest: %.2f powinno by: %.2f\nCzy naprawi?",buf,dk.GetField("netto"),netto ) then
					dk.SetField("netto",netto)
					UpdateRecB(dk)
				else
					TextOut(sNoRepair)
				endif
			endif

			if bylyFlag&2 then
				buf = using "Nie zgadza si warto VAT dokumentu z sum pozycji w dokumencie '%s' id=%l",dk.GetField("kod"),dk.GetField("id")
				TextOut(buf)
				if Ask( 22, using "%s\njest: %.2f powinno by: %.2f\nCzy naprawi?",buf,dk.GetField("vat"),Round(vat,2) ) then
					dk.SetField("vat",Round(vat,2))
					UpdateRecB(dk)
				else
					TextOut(sNoRepair)
				endif
			endif

			if bylyFlag&4 then
				buf = using "Nie zgadza si warto netto w walucie dokumentu z sum pozycji w dokumencie '%s' id=%l",dk.GetField("kod"),dk.GetField("id")
				TextOut(buf)
				if Ask( 23, using "%s\njest: %.2f powinno by: %.2f\nCzy naprawi?",buf,dk.GetField("walNetto"),walNetto ) then
					dk.SetField("walNetto",walNetto)
					UpdateRecB(dk)
				else
					TextOut(sNoRepair)
				endif
			endif

			if bylyFlag&8 then
				buf = using "Nie zgadza si warto brutto w walucie dokumentu z sum pozycji w dokumencie '%s' id=%l",dk.GetField("kod"),dk.GetField("id")
				TextOut(buf)
				if Ask( 24, using "%s\njest: %.2f powinno by: %.2f\nCzy naprawi?",buf,dk.GetField("walBrutto"),walBrutto ) then
					dk.SetField("walBrutto",walBrutto)
					UpdateRecB(dk)
				else
					TextOut(sNoRepair)
				endif
			endif
*/
			if (Sign(dk.GetField("wartPrzychod")-wartPrzychod,2)) then
				buf = using "Nie zgadza si warto przychodu dokumentu z sum pozycji w dokumencie '%s' id=%l",dk.GetField("kod"),dk.GetField("id")
				TextOut(buf)
				if Ask( 25, using "%s\njest: %.2f powinno by: %.2f\nCzy naprawi?",buf,dk.GetField("wartPrzychod"),wartPrzychod ) then
					dk.SetField("wartPrzychod",wartPrzychod)
					UpdateRecB(dk)
				else
					TextOut(sNoRepair)
				endif
			endif

		endif
	endif
	
loop until err

StageSummary(6)

endif	// stage
if imsg > 1 then
	for imsg = 1 to imsg == size(msg)
		print msg(imsg)
	next imsg
endif

if StageT(7) then
	// Sprawdzanie poprawnoci wartoci kursw

	PopUp(1,"Sprawdzanie poprawnoci wartoci kursw:")

	CheckKursy()

	PopUp(1,"")
	PopUp(2,"")

	StageSummary(7)

endif

TextOut("\nZakoczono.")

ShowFileInfo()
if bylyGw then
	TextOut("\nUWAGA!!! Odtworzone przez program dane mog by (i najprawdopodobniej s) NIEKOMPLETNE!\n")
	TextOut("Prosz wydrukowa powysze podsumowanie a nastpnie sprawdzi poprawno wszystkich odtworzonych danych wyrnionych w tym podsumowaniu przez ")
	ZapiszGwiazdki()
endif

close

buf = IIF( GetVError() == 0 , "" , "warnings" )