//"diag_dp.sci","Diagnostyka pozycji handlowych - include",12001,0,1.0.1,SYSTEM
//"System",2400,14,62
//////////////////////////////////////////////////////////////////////
// Diagnostyka pozycji handlowych - include
// diag_dp.sci
// 
// dodany ze wzgldu na rozmiar pliku diag_dp.sc

int Sub CzyDokVAT(int iTyp)
	Select Case iTyp
		Case FVS, FKS, RUS, RKS, FVW, FKW, FVM, FKM, FZS, KZS, ZKS, FWS, WKS, FVT, FTK, PAR, PRK
			CzyDokVAT = 1
#ifdef HM
		Case  DIM, DKM, WNT, WNK, ZVW, ZWK
			CzyDokVAT = 1
#endif
#ifdef HMHL
		case FVZ, FKZ, RUZ, RKZ,FZZ, KZZ, ZKZ, WKZ, FWZ
				CzyDokVAT = 1
#endif
		Case Else
			CzyDokVAT = 0
	EndSelect
EndSub

int Sub CzyFaktWew(int iTyp)
	Select Case iTyp
		Case FWS, WKS
			CzyFaktWew = 1
#ifdef HMHL
		Case FWZ, WKZ
			CzyFaktWew = 1
#endif
		Case Else
			CzyFaktWew = 0
	EndSelect
EndSub

int Sub CzyNumerNP(int stvat, int sTyp, int lp)
	Select Case sTyp
		case DEX, DXK, WDT, WDK		//dokumenty bez VAT'u ale nie bezvatowe!
			if ((stvat==VAT_NP) && (lp > 10000)) then
				CzyNumerNP = 1
			else
				CzyNumerNP = 0
			endif
		Case Else
			if CzyDokVAT(sTyp) && stvat==VAT_NP then
				CzyNumerNP = 1
			else
				CzyNumerNP = 0
			endif
	EndSelect
EndSub

int sub CopyIDPtoDP(int idpbase, BaseAll dpbase)
	dpbase.Clear()
	dpbase.SetField("id",GetField(idpbase,"id"))
	dpbase.SetField("typi", GetField(idpbase, "typi") & 0xfe )	// zmiana dokona si rwnie w bazie 'idp'
	dpbase.SetField("subtypi",GetField(idpbase,"subtypi"))
	dpbase.SetField("super",GetField(idpbase,"super"))
	dpbase.SetField("idkh",GetField(idpbase,"idkh"))
	dpbase.SetField("idtw",GetField(idpbase,"idtw"))
	dpbase.SetField("data",GetField(idpbase,"data"))
	dpbase.SetField("ilosc",GetField(idpbase,"ilosc"))
	dpbase.SetField("iloscwp",GetField(idpbase,"ilosc"))
	dpbase.SetField("stvati",GetField(idpbase,"stvati"))
	dpbase.SetField("wartNetto",GetField(idpbase,"wartNetto"))
	dpbase.SetField("wartVat",GetField(idpbase,"wartVat"))
	dpbase.SetField("wartTowaru",GetField(idpbase,"wartTowaru"))
	dpbase.SetField("rejestrVATi",GetField(idpbase,"rejestrVATi"))
	dpbase.SetField("magazyn",GetField(idpbase,"magazyn"))
	dpbase.SetField("osoba",GetField(idpbase,"osoba"))
endsub


int sub ShouldMirrorRec( BaseAll b )
	ShouldMirrorRec = 1
	if b.GetField("typi") & 0x01 then ShouldMirrorRec=0
endsub


int sub SprawdzIDP()
	float fCena,fIlosc
	BaseTW bTW
	BaseWL bWL

#ifdef HMHL
	BaseZZ bZZ
	bZZ.Open()
	bZZ.SetKey("termin")
#endif

	int idp,errpom
	idp=open KatalogFirmy()+"5idp.dat" for base "IDP"
	BaseError(idp,4)
	long pom
	bTW.Open()
	bWL.Open()
	bWL.SetKey("waluta")

	PopUp(1,"Sprawdzanie integralnoci bazy DP oraz IDP")
	PopUp(2,"")
	PopUp(3,"")
	dp.SetKey("id")
	SetKey(idp,"id")
	err2=GetRec(idp,FS)
	err=dp.GetRec(FS)
	progress.Reset(dp.GetRecordCount())
	while !err || !err2
		progress.NextOne()
		// przegldanie kolejnych rekordw IDP az do znalezienia o danym ID
		while !err2 && (err || GetField(idp,"id")<dp.GetField("id"))
			if err || dp2.GetRecById(GetField(idp,"id")) then
				if TextOutAndAsk(4,(using "Znaleziono rekord w bazie IDP id=%l ktry nie ma swojego odpowiednika w bazie DP",GetField(idp,"id")),sAskRepair) then
					// odtwarzanie rekordu z bazie DP na podstawie rekordu w bazie IDP
					CopyIDPtoDP(idp,dp)
					if !dk.GetRecById(dp.GetFIeld("super")) then
						dp.SetField("grupaceni",dk.GetField("grupaceni"))

						// ustawienie poczenia do korekty
						if dk.GetFIeld("iddokkoryg") then
							pom=dk.GetFIeld("id")
							errpom = dk.GetRecById(dk.GetField("iddokkoryg"))
							while !errpom && dk.GetField("idkorekt")!=pom
								errpom = dk.GetRecById(dk.GetField("idkorekt"))						
							wend
							if !errpom then
								dp2.SetKey("super")
								dp2.SetKeySeg("super",dk.GetField("id"))
								dp2.SetKeySeg("lp",0)
								errpom = dp2.GetRec(GE)
								while !errpom && dp2.GetField("super")==dk.GetField("id") && dp2.GetField("idtw")!=dp.GetField("idtw")
									errpom = dp2.GetRec(NX)
								wend
								if !errpom && dp2.GetFIeld("super")==dk.GetField("id") then
									dp.SetField("idpozkoryg",dp2.GetField("id"))
									// obliczenie ceny
									errpom = dp2.GetRecById(dp.GetField("idpozkoryg"))
									fCena = dp2.GetField("cena")
									fIlosc = dp2.GetField("ilosc")
									while !errpom && dp2.GetField("idpozkoryg")
										errpom=dp2.GetRecById(dp2.GetField("idpozkoryg"))
										fCena += dp2.GetField("cena")
										fIlosc += dp2.GetField("ilosc")
									wend
									if !errpom then
										if fIlosc+dp.GetField("ilosc") then dp.SetField("cena",(dp.GetField("wartNetto")-dp.GetField("ilosc")*fCena)/(fIlosc+dp.GetField("ilosc")))
									endif
								endif
							endif							
						endif
					endif

					if !dp.GetField("idpozkoryg") then
						if Sign(dp.GetField("ilosc"),4) then dp.SetField("cena",dp.GetField("wartNetto")/dp.GetFIeld("ilosc"))
					endif
					if ! bTW.GetRecById(dp.GetField("idtw")) then
						IF bTW.GetField("subtypi")==0 THEN
							dp.SetFIeld("flag",0x0200)
						ENDIF
						dp.SetFIeld("kod",bTW.GetField("kod"))
						dp.SetFIeld("opis",bTW.GetField("nazwa"))
						dp.SetFIeld("jm",bTW.GetField("jm"))
						dp.SetFIeld("jmwp",bTW.GetField("jm"))
						if !dk.GetRecById(dp.GetFIeld("super")) then
#ifdef HMHL
							bZZ.SetKeySeg("typi",96)	// rezerwacja
							bZZ.SetKeySeg("termin","")
							errpom=bZZ.GetRec(GE)
							while !errpom && bZZ.GetField("typi")==96 && !(bZZ.GetField("baza3")==16 && bZZ.GetField("id3")==dp.GetField("super") && bZZ.GetField("id3pos")==dp.GetField("id") && bZZ.GetField("baza1")==22 && bZZ.GetField("id1")==dp.GetField("idtw"))
								errpom = bZZ.GetRec(NX)
							wend
							if !errpom && bZZ.GetField("typi")==96 && bZZ.GetField("baza3")==16 && bZZ.GetField("id3")==dp.GetField("super") && bZZ.GetField("id3pos")==dp.GetField("id") && bZZ.GetField("baza1")==22 && bZZ.GetField("id1")==dp.GetField("idtw") then
								dp.SetField("rezerwacja",bZZ.GetField("id"))
							endif
#endif

							pom=dk.GetField("grupaceni")
							if pom>=2 && pom<=8 then
								dp.SetField("cenabaza",bTW.GetFIeld(using "cena%c",'a'-1+(pom&0xfe)/2))
								fCena=1
								if pom<8 && buf then
									buf = bTW.GetField(using "cena%cwal",'a'-1+(pom&0xfe)/2)
									bWL.SetKeySeg("waluta",buf)
									bWL.SetKeySeg("data",dk.GetField("data"))
									if !bWL.GetRec(EQ) then fCena=bWL.GetField("kurs")
								endif	
								dp.SetField("cenabazapl",dp.GetField("cenabaza")*fCena)
							endif
							if dk.GetField("grupaceni")==13 then dp.SetField("cenabaza",0) : dp.SetField("cenabazapl",0)
						endif
					endif

					if !InsertRecB(dp) then err=dp.GetRec(NX)

				else
					TextOut(sNoRepair)
				endif			
			endif		
			err2=GetRec(idp,NX)
		wend

		if err && err2 then exit

		pom = err2 || GetField(idp,"id")!=dp.GetField("id")
		if ShouldMirrorRec(dp) then
			if pom then
				if TextOutAndAsk(5,(using "Pozycja '%s' id=%l nie posiada swojego odpowiednika w bazie IDP",dp.GetField("kod"),dp.GetField("id")),sAskRepair) then
					UpdateRecB(dp)
				else
					TextOut(sNoRepair)
				endif
			endif
		else
			if !pom then
				if TextOutAndAsk(6,(using "Znaleziono pozycj '%s' id=%l w bazie DP ktry nie powinien posiada swojego odpowiednika w bazie IDP",dp.GetField("kod"),dp.GetField("id")),".\nCzy usun rekord z bazy IDP") then
					DeleteRec(idp,"IDP")
				else
					TextOut(sNoRepair)
				endif
			endif
		endif

		pom = GetFIeld(idp,"id")
		if (!err2 && GetField(idp,"id")==dp.GetField("id")) || err then err2=GetRec(idp,NX)
		if (!err && pom>=dp.GetField("id")) || err2 then err=dp.GetRec(NX)
	wend

	bTW.Close()
	bWL.Close()

#ifdef HMHL
	bZZ.Close()
#endif

	close idp
	WriteStatusBar("")
endsub



int sub PrzygotujPozycje(long id, string subtyp)
	BaseDP mdp
	BaseDP pdp

	if mdp.Open() then error "Bd otwierania bazy DP"
	if pdp.Open() then error "Bd otwierania bazy DP"

	pdp.SetKey("id")

	mdp.SetKey("super")
	mdp.SetKeySeg("super",id)
	mdp.SetKeySeg("lp",-32768)
	err=mdp.GetRec(GE)

	while !err && mdp.GetField("super")==id
		if CzyNumerNP(mdp.GetField("stvati"),Val(subtyp),mdp.GetField("lp")) then
			if mdp.GetField("lp")!=((mdp.GetField("id")%22768)+10000) then
				pdp.SetKeySeg("id",mdp.GetField("id"))
				if pdp.GetRec(EQ) then exit
				pdp.SetField("lp",((pdp.GetField("id")%22768)+10000))
				if pdp.Update() then exit
			endif
		else
			if mdp.GetField("lp")!=mdp.GetField("id")%32768 then
				pdp.SetKeySeg("id",mdp.GetField("id"))
				if pdp.GetRec(EQ) then exit
				pdp.SetField("lp",pdp.GetField("id")%32768)
				if pdp.Update() then exit
			endif
		endif
		err=mdp.GetRec(NX)
	wend
	mdp.Close()
	pdp.Close()
endsub


int sub Przenumeruj(long id, string subtyp)
	int mdk,mdp2, komplet=0, sukces=0, sukces2=0
	long curr_komplet=0
	BaseDP mdp
	BaseDP mdp3
	BaseDP mdp4
	BaseZZ mzz
	int nocont
	long curr=1
	long curr_NP=10001
	mdk=OpenBase("dk")
	mdp.Open()
	mdp3.Open()
	mdp4.Open()
	mzz.Open()
	mdp2=OpenBase("dp")

	PrzygotujPozycje(id,subtyp)
	SetKey(mdk,"id")
	SetKeySeg(mdk,"id",id)
	GetRec(mdk,EQ)
	SetKey(mdp2,"id")
	mzz.SetKey("cross1")
	mzz.SetKeySeg("typi",69)
	mzz.SetKeySeg("baza1",22)
	mzz.SetKeySeg("baza2",22)

	mdp.SetKey("super")
	mdp.SetKeySeg("super",id)
	mdp.SetKeySeg("lp",-32768)
	err=mdp.GetRec(GE)

	while !err && (mdp.GetField("super")==id)
		if (mdp.GetField("flag")&0x1000) || (mdp.GetField("flag")&0x4000) then
			if (mdp.GetField("flag")&0x1000) then
				if komplet then
					if CzyNumerNP(mdp.GetField("stvati"), Val(subtyp), mdp.GetField("lp")) then
						curr_NP+=1
					else
						curr+=1
					endif
				endif
				komplet=1
				curr_komplet=mdp.GetField("idtw")
				if mdp.GetField("lp")!=iif(CzyNumerNP(mdp.GetField("stvati"), Val(subtyp), mdp.GetField("lp")), curr_NP,curr) then
 					mdp4.GetRecById(mdp.GetField("id"))
					mdp4.SetField("lp",iif(CzyNumerNP(mdp4.GetField("stvati"), Val(subtyp), mdp.GetField("lp")), curr_NP,curr))
					if mdp4.Update() then nocont=1 : exit
				endif
			endif
			if (mdp.GetField("flag")&0x4000) && komplet then
				mzz.SetKey("cross1")
				mzz.SetKeySeg("typi",69)
				mzz.SetKeySeg("baza1",22)
				mzz.SetKeySeg("baza2",22)
				mzz.SetKeySeg("id1",curr_komplet)
				mzz.SetKeySeg("id2",mdp.GetField("idtw"))
				if mzz.GetRec(EQ) then
					sukces=0
					sukces2=0
					mzz.SetKey("cross1")
					mzz.SetKeySeg("typi",69)
					mzz.SetKeySeg("baza1",22)
					mzz.SetKeySeg("baza2",22)
					mzz.SetKeySeg("id1",0)
					mzz.SetKeySeg("id2",mdp.GetField("idtw"))
					err = mzz.GetRec(GE)
					while !err && mzz.GetField("id2")==mdp.GetField("idtw") && sukces==0
						mdp3.SetKey("super")
						mdp3.SetKeySeg("super",id)
						mdp3.SetKeySeg("lp",-32768)
						err=mdp3.GetRec(GE)
						while !err && mdp3.GetField("super")==id && sukces==0
							if mzz.GetField("id1")==mdp3.GetField("idtw") && (mdp3.GetField("flag")&0x1000) then
								sukces2=0
								mdp4.SetKey("super")
								mdp4.SetKeySeg("super",id)
								mdp4.SetKeySeg("lp",-32768)
								err=mdp4.GetRec(GE)
								while !err && mdp4.GetField("super")==id && sukces2==0
									if mdp4.GetField("lp")==mdp3.GetField("lp") && (mdp4.GetField("flag")&0x4000) && mdp4.GetField("idtw")==mdp3.GetField("idtw") then
										sukces2=1
									endif
									err=mdp4.GetRec(NX)
								wend
								if !sukces2 then
									mdp4.GetRecById(mdp.GetField("id"))
									mdp4.SetField("lp",mdp3.GetField("lp"))
									if mdp4.Update() then nocont=1 : exit
									sukces=1
								endif
							endif
							err=mdp3.GetRec(NX)
						wend	
						err=mzz.GetRec(NX)
					wend
					if !sukces then
						if sukces2 then
							mzz.SetKey("cross1")
							mzz.SetKeySeg("typi",69)
							mzz.SetKeySeg("baza1",22)
							mzz.SetKeySeg("baza2",22)
							mzz.SetKeySeg("id1",0)
							mzz.SetKeySeg("id2",mdp.GetField("idtw"))
							err = mzz.GetRec(GE)
							while !err && mzz.GetField("id2")==mdp.GetField("idtw") && sukces==0
								mdp3.SetKey("super")
								mdp3.SetKeySeg("super",id)
								mdp3.SetKeySeg("lp",-32768)
								err=mdp3.GetRec(GE)
								while !err && mdp3.GetField("super")==id && sukces==0
									if mzz.GetField("id1")==mdp3.GetField("idtw") && (mdp3.GetField("flag")&0x1000) then
										mdp4.GetRecById(mdp.GetField("id"))
										mdp4.SetField("lp",mdp3.GetField("lp"))
										if mdp4.Update() then nocont=1 : exit
										sukces=1
									endif
									err=mdp3.GetRec(NX)
								wend
							wend
						else
							mdp3.SetKey("super")
							mdp3.SetKeySeg("super",id)
							mdp3.SetKeySeg("lp",-32768)
							err=mdp3.GetRec(GE)
							while !err && mdp3.GetField("super")==id && sukces==0
								if (mdp3.GetField("flag")&0x1000) then
									mdp4.GetRecById(mdp.GetField("id"))
									mdp4.SetField("lp",mdp3.GetField("lp"))
									if mdp4.Update() then nocont=1 : exit
									sukces=1
								endif
								err=mdp3.GetRec(NX)
							wend
							if !sukces then
								mdp4.GetRecById(mdp.GetField("id"))
								mdp4.SetField("lp",iif(CzyNumerNP(mdp4.GetField("stvati"), Val(subtyp), mdp.GetField("lp")), curr_NP,curr))
								if mdp4.Update() then nocont=1 : exit
							endif
						endif
					endif
				else
					if mdp.GetField("lp")!=iif(CzyNumerNP(mdp.GetField("stvati"), Val(subtyp), mdp.GetField("lp")), curr_NP,curr) then
						mdp4.GetRecById(mdp.GetField("id"))
						mdp4.SetField("lp",iif(CzyNumerNP(mdp4.GetField("stvati"), Val(subtyp), mdp.GetField("lp")), curr_NP,curr))
						if mdp4.Update() then nocont=1 : exit
					endif
				endif
			endif
			if (mdp.GetField("flag")&0x4000) && !komplet then
				sukces=0
				sukces2=0
				mzz.SetKey("cross1")
				mzz.SetKeySeg("typi",69)
				mzz.SetKeySeg("baza1",22)
				mzz.SetKeySeg("baza2",22)
				mzz.SetKeySeg("id1",0)
				mzz.SetKeySeg("id2",mdp.GetField("idtw"))
				err = mzz.GetRec(GE)
				while !err && mzz.GetField("id2")==mdp.GetField("idtw") && sukces==0
					mdp3.SetKey("super")
					mdp3.SetKeySeg("super",id)
					mdp3.SetKeySeg("lp",-32768)
					err=mdp3.GetRec(GE)
					while !err && mdp3.GetField("super")==id && sukces==0
						if mzz.GetField("id1")==mdp3.GetField("idtw") && (mdp3.GetField("flag")&0x1000) then
							sukces2=0
							mdp4.SetKey("super")
							mdp4.SetKeySeg("super",id)
							mdp4.SetKeySeg("lp",-32768)
							err=mdp4.GetRec(GE)
							while !err && mdp4.GetField("super")==id && sukces2==0
								if mdp4.GetField("lp")==mdp3.GetField("lp") && (mdp4.GetField("flag")&0x4000) && mdp4.GetField("idtw")==mdp3.GetField("idtw") then
									sukces2=1
								endif
								err=mdp4.GetRec(NX)
							wend
							if !sukces2 then
								mdp4.GetRecById(mdp.GetField("id"))
								mdp4.SetField("lp",mdp3.GetField("lp"))
								if mdp4.Update() then nocont=1 : exit
								sukces=1
							endif
						endif
						err=mdp3.GetRec(NX)
					wend	
					err=mzz.GetRec(NX)
				wend
				if !sukces then
					if sukces2 then
						mzz.SetKey("cross1")
						mzz.SetKeySeg("typi",69)
						mzz.SetKeySeg("baza1",22)
						mzz.SetKeySeg("baza2",22)
						mzz.SetKeySeg("id1",0)
						mzz.SetKeySeg("id2",mdp.GetField("idtw"))
						err = mzz.GetRec(GE)
						while !err && mzz.GetField("id2")==mdp.GetField("idtw") && sukces==0
							mdp3.SetKey("super")
							mdp3.SetKeySeg("super",id)
							mdp3.SetKeySeg("lp",-32768)
							err=mdp3.GetRec(GE)
							while !err && mdp3.GetField("super")==id && sukces==0
								if mzz.GetField("id1")==mdp3.GetField("idtw") && (mdp3.GetField("flag")&0x1000) then
									mdp4.GetRecById(mdp.GetField("id"))
									mdp4.SetField("lp",mdp3.GetField("lp"))
									if mdp4.Update() then nocont=1 : exit
									sukces=1
								endif
							wend
							err=mdp3.GetRec(NX)
						wend	
					else
						mdp3.SetKey("super")
						mdp3.SetKeySeg("super",id)
						mdp3.SetKeySeg("lp",-32768)
						err=mdp3.GetRec(GE)
						while !err && mdp3.GetField("super")==id && sukces==0
							if (mdp3.GetField("flag")&0x1000) then
								mdp4.GetRecById(mdp.GetField("id"))
								mdp4.SetField("lp",mdp3.GetField("lp"))
								if mdp4.Update() then nocont=1 : exit
								sukces=1
							endif
							err=mdp3.GetRec(NX)
						wend
						if !sukces then
							mdp4.GetRecById(mdp.GetField("id"))
							mdp4.SetField("lp",iif(CzyNumerNP(mdp4.GetField("stvati"), Val(subtyp), mdp.GetField("lp")), curr_NP,curr))
							if mdp4.Update() then nocont=1 : exit
						endif
					endif
				endif
			endif
		else
			if komplet then
				if CzyNumerNP(mdp.GetField("stvati"), Val(subtyp), mdp.GetField("lp")) then
					curr_NP+=1
				else
					curr+=1
				endif
			endif
			komplet=0
			curr_komplet=0
			if mdp.GetField("lp")!=iif(CzyNumerNP(mdp.GetField("stvati"), Val(subtyp), mdp.GetField("lp")), curr_NP,curr) then
				mdp4.GetRecById(mdp.GetField("id"))
				mdp4.SetField("lp",iif(CzyNumerNP(mdp4.GetField("stvati"), Val(subtyp), mdp.GetField("lp")), curr_NP,curr))
				if mdp4.Update() then nocont=1 : exit
			endif			
			if CzyNumerNP(mdp.GetField("stvati"), Val(subtyp), mdp.GetField("lp")) then
				curr_NP+=1
			else
				curr+=1
			endif
		endif
		err=mdp.GetRec(NX)
	wend

	if nocont then
		TextOut(" - NIE NAPRAWIONO - bd zapisu do bazy DP\n")
	else
		while GetField(mdk,"idkorekt") && !nocont
			SetKeySeg(mdk,"id",GetFIeld(mdk,"idkorekt"))

			if GetRec(mdk,EQ) then TextOUT(" - nie naprawiono korekt do dokumentu z powodu niewaciwego ich dowizania\n") : nocont=1 : exit
			PrzygotujPozycje(GetField(mdk,"id"),(using "%d",GetField(mdk,"subtypi")))
			mdp.SetKey("super")
			mdp.SetKeySeg("super",GetField(mdk,"id"))
			mdp.SetKeySeg("lp",-32768)
			err=mdp.GetRec(GE)
			while !err && mdp.GetField("super")==GetField(mdk,"id")
				if mdp.GetField("idpozkoryg") then
					SetkeySeg(mdp2,"id",mdp.GetField("idpozkoryg"))
					if GetRec(mdp2,EQ) then
						TextOut(" - nie naprawiono korekt, gdy pozycje korekt s niewaciwie powizane z pozycjami dokumentu\n")
						nocont=1
						exit					
					else
						// przepisuje lp z pozycji korygowanej
						mdp.SetField("lp",GetField(mdp2,"lp"))
						if mdp.Update() then TextOut(" - nie naprawiono pozycji korekt z powodu bdu zapisu do bazy DP\n") : nocont=1 : exit
					endif
				else
					TextOut(" - nie naprawiono korekt, gdy pozycje korekt s niewaciwie powizane z pozycjami dokumentu\n")
					nocont=1
					exit
				endif
				err=mdp.GetRec(NX)
			wend
		wend
	endif
	
	if !nocont then TextOut(sRepaired)

	lpTypPozComm = 0
	TypPozComm = -1
	mvKomplet.Clear()
	SetKey(mdk,"id")
	SetKeySeg(mdk,"id",id)
	GetRec(mdk,EQ)

	mdp.SetKey("super")
	mdp.SetKeySeg("super",id)
	mdp.SetKeySeg("lp",-32768)
	err=mdp.GetRec(GE)
	while !err && mdp.GetField("super")==id
		if !CzyFaktWew(GetField(mdk,"subtypi")) && !(mdp.GetField("flag")&0x2000) then
			if (mdp.GetField("flag")&0x1000) || (mdp.GetField("flag")&0x4000) then
				if mdp.GetField("lp") != lpTypPozComm then
					lpTypPozComm = mdp.GetField("lp")
					if (mdp.GetField("flag")&0x1000) then
						TypPozComm =  mdp.GetField("typi")&0x01
						if TypPozComm then
							strKomplet = using "%d",lpTypPozComm
							mvKomplet.Set(strKomplet,mdp.GetField("id"))
						endif
					else
						mdp3.SetKey("super")
						mdp3.SetKeySeg("super",mdp.GetField("super"))
						mdp3.SetKeySeg("lp",mdp.GetField("lp"))
						err2 = mdp3.GetRec(EQ)
						while !err2 && mdp3.GetField("super")==mdp.GetField("super") && mdp3.GetField("lp")==mdp.GetField("lp") && !(mdp3.GetField("flag")&0x1000)
							err2 = mdp3.GetRec(NX)
						wend
						if mdp3.GetField("super")==mdp.GetField("super") && mdp3.GetField("lp")==mdp.GetField("lp") && (mdp3.GetField("flag")&0x1000) then
							TypPozComm =  val(mdp3.GetField("typi"))&0x01
						else
							TypPozComm = 1
						endif
					endif
				endif
				if (mdp.GetField("flag")&0x4000) then
					strKomplet = using "%d",lpTypPozComm
					if mvKomplet.Index(strKomplet) then
						mvKomplet.Del(strKomplet)
					endif							
				endif
				if (mdp.GetField("flag")&0x4000) && (!(mdp.GetField("typi")&0x01) != TypPozComm) then
					if mdp.GetField("typi")&0x01 then
						mdp.SetField("typi",mdp.GetField("typi")^0x01)
					else
						mdp.SetField("typi",mdp.GetField("typi")|0x01)
					endif
					mdp.Update()
				endif
			else
				if mdp.GetField("typi")&0x01 then
					mdp.SetField("typi",mdp.GetField("typi")^0x01)
					mdp.Update()
				endif
			endif
		else
			if !mdp.GetField("typi")&0x01 then
				mdp.SetField("typi",mdp.GetField("typi")|0x01)
				mdp.Update()
			endif
		endif
		err=mdp.GetRec(NX)
	wend
	while mvKomplet.Size()
		mdp.GetRecById(mvKomplet.Get(mvKomplet.Size()))
		mdp.SetField("typi",mdp.GetField("typi")^0x01)
		mdp.Update()
		mvKomplet.Del(mvKomplet.GetKey(mvKomplet.Size()))
	wend

	close mdk
	close mdp2
	mzz.Close()
	mdp3.Close()
	mdp4.Close()
endsub

int sub Usun_notatke( long id )
	nt.SetKeySeg("typi",16)
	nt.SetKeySeg("baza",18)
	nt.SetKeySeg("super",id)
	if !nt.GetRec(EQ) then nt.Delete()
endsub
int sub SprawdzKodTw()
	if dp.GetField("kod") && dp.GetField("subtypi")!=102 then
		if !dp.GetField("idtw") then
			TextOut(using "Pozycja 'id'=%l o kodzie '%s' ma niewypenione pole 'idtw'\n",dp.GetField("id"),dp.GetField("kod"))	
		else
			if !tw.GetRecById(dp.Getfield("idtw")) then
				if tw.GetField("kod")!=dp.GetField("kod") then
					TextOut(using "Pozycja 'id'=%l o kodzie '%s' poprzez pole 'idtw' jest powizana z towarem o innym kodzie '%s'\n",dp.GetField("id"),dp.GetField("kod"),tw.GetField("kod"))	
				endif
			else
				TextOut(using "Pozycja 'id'=%l o kodzie '%s' poprzez pole 'idtw'=%l jest powizana z nieistniejcym towarem\n",dp.GetField("id"),dp.GetField("kod"),dp.GetField("idtw"))
			endif
		endif	
	else
		if dp.Getfield("idtw") then
			if !tw.GetRecById(dp.Getfield("idtw")) then 
				TextOut(using "Pozycja 'id'=%l ma niewypenione pole kod, a poprzez pole 'idtw' jest powizana z towarem o 'id'=%l kodzie '%s' \n",dp.GetField("id"),dp.GetField("idtw"),tw.GetField("kod"))	
			else
				TextOut(using "Pozycja 'id'=%l ma niewypenione pole kod, a poprzez pole 'idtw'=%l jest powizana z nieistniejcym towarem\n",dp.GetField("id"),dp.GetField("idtw"))	
			endif
		endif
	endif	
endsub
#ifdef HMHL
mz.Open()
		 
int Sub UstawWszytskie(long idBazow, int WI)
//WI == 1 poprawiamy wartosc
//WI == 0 poprawiamy ilosc
//WI == 2 poprawiamy obydwa
	
	float vat,netto
	int err, err2

	BaseAll mdp
	BaseMZ mmz
	BaseAll mdp2

	OpenBaseB(mdp,"DP")
	if mmz.Open() then error "Bd otwierania bazy MZ"
	OpenBaseB(mdp2,"DP")

	err = mdp.GetRecById(idBazow)
	
	while !err
		netto = vat = 0
		mmz.SetKey("idhandl")
		mmz.SetKeySeg("idhandl",mdp.GetField("id"))
		mmz.SetKeySeg("data","")
		err=mmz.GetRec(GE)
		while !err && mmz.GetField("idhandl")==mdp.GetField("id")
			netto += mmz.GetField("wartNetto") + mmz.GetField("wartk")
			vat += mmz.GetField("ilosc")
			err=mmz.GetRec(NX)
		wend
		if mdp.GetField("idpozkoryg") then
			mdp2.SetKey("super")
			mdp2.SetKeySeg("super",mdp.GetField("super"))
			mdp2.SetKeySeg("lp",mdp.GetField("lp"))
			err2 = mdp2.GetRec(EQ)
			while !err2 && mdp2.GetField("super")==mdp.GetField("super") && mdp2.GetField("lp")==mdp.GetField("lp") &&  !(mdp2.GetField("typi") & 0x10)
				err2 = mdp2.GetRec(NX)
			wend
			if mdp2.GetField("super")==mdp.GetField("super") && mdp2.GetField("lp")==mdp.GetField("lp") && mdp2.GetField("id")!=mdp.GetField("id") && (mdp2.GetField("typi") & 0x10) then
				vat = ((-1)*mdp2.GetField("ilosc"))+vat
				netto = ((-1)*mdp2.GetField("wartTowaru"))+netto
			endif
		endif

		if WI==1 || WI == 2 then
			mdp.SetField("wartTowaru",netto)
			mdp.SetField("cenaBaza",0)
		endif
		if WI==0 || WI == 2 then
			mdp.SetField("iloscDoRozl",mdp.GetField("ilosc")-vat)
			mdp.SetField("rozlhandl",0)
		endif
		UpdateRecB(mdp)
		
		mdp.SetKey("idpozkoryg")
		mdp.SetKeySeg("idpozkoryg",mdp.GetField("id"))
		err=mdp.GetRec(EQ)
	wend
	
	mdp.Close()
	mmz.Close()
	
EndSub
#endif
int sub RozlKomplet()
    long id=dp.GetField("id") 
	int index
	int znak=1
	int lp=dp.GetField("lp")
	index=mrozlK.Index(using "%d",lp)
	if !index then 
		mrozlK.Set((using "%d",lp),1)
		index=mrozlK.Size()
		if index>1 then grow rRozlK,1
		rRozlK(index).lp=lp		
	endif
	if dp.GetField("flag")&0x1000 then
		 rRozlK(index).id=dp.GetField("id")
		 znak=-1
		 rRozlK(index).cena = dp.getfield("cena")
	   	 rRozlK(index).wartosc = dp.GetField("wartnetto")	
		 rRozlK(index).vat = dp.GetField("wartVat")		
		 rRozlK(index).iloscWp = dp.getField("iloscWp")
	else
		rRozlK(index).DodajPozycje(dp.getField("ilosc"),dp.getField("iloscWp"),dp.Getfield("cena"),dp.GetField("wartNetto"),dp.GetField("wartVat")	)
	endif		
	rRozlK(index).wartTow+=(dp.GetField("wartTowaru")*znak)
	rRozlK(index).iloscdoRozl+=(dp.GetField("iloscdorozl")*znak)
endsub

int sub CheckCenyKompletu(int i)
CheckCenyKompletu = 0
endsub
int sub CheckWartosciKompletu(int i)
CheckWartosciKompletu = 0
int j
float wartosc
	for j=1 to j>rRozlK(i).IlePoz()
		wartosc+=rRozlK(i).pozycje(j).wartosc
	next j	
	if sign(rRozlK(i).wartosc-wartosc,2) then CheckWartosciKompletu = 1
endsub

int sub KorektaDoArchiwum(long id)
	KorektaDoArchiwum=0
	if id then
		if !dko.GetRecById(id) && dko.GetField("subtypi")==2 then KorektaDoArchiwum=1
	endif
endsub

int Sub CzyWartOK(long idBazow)
	
	int err
	float wart = 0
	
	BaseAll mdp
	OpenBaseB(mdp,"DP")
	err = mdp.GetRecById(idBazow)
		
	while !err
		wart += mdp.GetField("cenaBaza")
		mdp.SetKey("idpozkoryg")
		mdp.SetKeySeg("idpozkoryg",mdp.GetField("id"))
		err=mdp.GetRec(EQ)
	wend
	
	mdp.Close()

	CzyWartOK = Sign(wart)
EndSub

int sub IsDIMOrWNT(int charakter)
	if charakter == DIM || charakter == DKM || charakter == WNT || charakter == WNK then
		IsDIMOrWNT = 1
	else
		IsDIMOrWNT = 0
	endif
endsub

int sub CheckWalBrutto(BaseDK basDK, BaseAll basDP)
//sprawdzamy czy dla pozycji, netto + vat == walBrutto - dla dokumentu zotwkowego	
	if !IsDIMOrWNT(basDK.GetField("subtypi")) && basDK.GetField("kurs") == 1 then
		if sign(basDP.GetField("walBrutto") - (basDP.GetField("wartNetto") + basDP.GetField("wartVat")), 2) != 0 then
			if TextOutAndAsk3(14,(using "Nie zgadza si warto pola walBrutto w pozycji dokumentu zotwkowego '%s' id=%l",basDP.GetField("kod"),basDP.GetField("id"))) then
				basDP.SetField("walBrutto", basDP.GetField("wartNetto") + basDP.GetField("wartVat"))
				UpdateRecB(basDP)
			else
				TextOut(sNoRepair)
			endif
		endif
	endif

	CheckWalBrutto = 0
endsub
