//"dokarch.sc","Dokumenty z archiwum",12010,0,1.0.1,SYSTEM
//"Pomocnicze",12001,14,16
////////////////////////////
// Dokumenty z archiwum
// dokarch.sc
////////////////////////////

#define NAZWA_PLIKU "DOKARCH.TXT"

String sRaportDescription = "Raport sprawdza czy w bazie danych istniej dokumenty importowane z archiwum."

#include "Diagnostyka - funkcje"

#define XTtypdkARCH		    2      
#define typiArch		    102   

Int  mainInfo , table, podzialBazy, tabElem, index
Long counter, counterSp, counterZk, counterMg
String tabSp(1), tabZk(1), tabMg(1)

Int Sub PrintInfo( String detailInfo, Long docCounter )
	
	If mainInfo && counter == 0 && detailInfo == "" Then
		TextOut( "W bazie danych nie znaleziono dokumentw z archiwum\n\n" )
		mainInfo = 0
	EndIf
	If docCounter Then
		TextOut( Using "%6l  -  %s\n" , docCounter , detailInfo )
	EndIf

EndSub

podzialBazy = 0

table = OpenBase("DK")
SetKey(table, "numer")
SetKeySeg(table, "typi", typiArch)
err = GetRec( table ,GE )
While !err && GetKeySeg(table, "typi") == typiArch
	if Mid(GetField(table,"nazwa"),1,12) == "Podzia bazy" then 
		podzialBazy = 1
	endif
	err = GetRec( table , NX )
Wend
Close(table)

mainInfo = 1
counter = 0
if podzialBazy then
	
	tabElem = 1
	table = OpenBase( "DK" )
	SetKey( table , "id" )
	SetKeySeg( table , "id", 0 )
	err = GetRec( table , GE )
	While !err
		if GetField( table , "subtypi" ) == XTtypdkARCH && GetField(table, "typi") == 0 then
			if counter then
				grow tabSp, 1
			endif
			tabSp(tabElem) = GetField(table, "kod")
			counter += 1
			tabElem += 1
		endif
		err = GetRec( table , NX )
	WEnd

	counterSp = counter
	IncreaseVError(counter)
	counter = 0

	tabElem = 1
	SetKeySeg( table , "id", 0 )
	err = GetRec( table , GE )
	While !err
		if GetField( table , "subtypi" ) == XTtypdkARCH && GetField(table, "typi") == 202 then
			if counter then
				grow tabZk, 1
			endif
			tabZk(tabElem) = GetField(table, "kod")
			counter += 1
			tabElem += 1
		endif
		err = GetRec( table , NX )
	WEnd

	counterZk = counter
	IncreaseVError(counter)
	counter = 0
	
	Close( table )
	
	tabElem = 1
	table = OpenBase( "MG" )
	SetKey(table, "id")
	SetKeySeg(table, "id", 0)
	err = GetRec(table, GE)
	While !err
		if GetField( table , "subtypi" ) == XTtypdkARCH && GetField(table, "typi") == 201 then
			if counter then
				grow tabMg, 1
			endif
			tabMg(tabElem) = GetField(table, "kod")
			counter += 1
			tabElem += 1
		endif
		err = GetRec( table , NX )
	WEnd

	counterMg = counter
	IncreaseVError(counter)
	counter = 0
	
	Close( table )
	Print "\n\n"
	if counterSp then 
		PrintInfo( "liczba dokumentw sprzeday zaimportowanych z archiwum", counterSp )
	endif
	if counterZk then
		PrintInfo( "liczba dokumentw zakupu zaimportowanych z archiwum", counterZk )
	endif
	if counterMg then
		PrintInfo( "liczba dokumentw magazynowych zaimportowanych z archiwum", counterMg )
	endif

	if tabSp(1) != "" then
		Print Using "\nDokumenty sprzeday: \n"
		for index = 1 to index > Size(tabSp)
			Print Using "%s, ", tabSp(index)
		next index
	endif
	if tabZk(1) != "" then
		Print Using "\n\nDokumenty zakupu: \n"
		for index = 1 to index > Size(tabZk)
			Print Using "%s, ", tabZk(index)
		next index
	endif
	if tabMg(1) != "" then
		Print Using "\n\nDokumenty magazynowe: \n"
		for index = 1 to index > Size(tabMg)
			Print Using "%s, ", tabMg(index)
		next index
	endif

endif

if !counterSp && !counterZk && !counterMg then
	PrintInfo( "" , counter)
endif

TextOut("\n\nZakoczono")

ShowFileInfo()

Close

buf = IIF( GetVError() == 0 , "" , "fromArchive" )