//"interofk.sci","Integracja rozrachunkw z FK - include",12016,0,2.1.0,SYSTEM
//"Integracja z FK-a",12015,14,62
/////////////////////////////////////////
// "Integracja rozrachunkw z FK - include"
// interofk.sci

#define TRUE						1

#define BAS_Pn  0x20

MapValue m_khidfk
m_khidfk.Clear()
m_khidfk.Type(long)

long sub GetKhIdFk(string strkhid)
	long khid	
	GetKhIdFk = 0	
	khid = Val(strkhid)
	if (!khid) then exit
	if (!m_khidfk.Index(strkhid)) then
		basKH.GetRecById(khid)
		 m_khidfk.Set(strkhid, basKH.GetField("idfk"))
	endif	
	GetKhIdFk = m_khidfk.Get(strkhid)	
endsub

record ProgressCounter
	int all, curr, last, new

	int sub Reset(int  a)
		if !a then a = 1
		all = a : curr = last = 0
		WriteStatusBar("")
	endsub

	int sub NextOne()
		curr += 1 : new = (curr*100)/all
		if new > last then last = new
		if last > 100 then last = 100 : curr = all
		WriteStatusBar(using "=%d%%%%", last)
	endsub
endrec

ProgressCounter progress
////////////////////////////////////////////////////////
MapValue Powiazania
Powiazania.Type(int)

int sub PowiazaniaClear()
	Powiazania.Clear()
	Powiazania.Type(int)
endsub

////////////////////////////////////////////////////////
MapValue Rejestry
Rejestry.Type(int)

int sub RejestryClear()
	Rejestry.Clear()
	Rejestry.Type(int)
endsub

////////////////////////////////////////////////////////
MapValue Kontrahenci
Kontrahenci.Type(int)

int sub KontrahenciClear()
	Kontrahenci.Clear()
	Kontrahenci.Type(int)
endsub

///////////////////////////////////////////////////
string strPow

float Sub ABS(float liczba)
	ABS=sign(liczba)*liczba
EndSub

int Sub KonwSubTyp(int subTyp)
	KonwSubTyp = -1
	select case subTyp
		case SUB_NULL
			KonwSubTyp = -1	
		case SUB_PRACOWNICY
			KonwSubTyp = khPRACOWNIK
		case SUB_KONTRAHENCI
			KonwSubTyp = khKONTRAHENT
		case SUB_URZEDY
			KonwSubTyp = khURZAD
		case khKONTRAHENT
			KonwSubTyp = SUB_KONTRAHENCI
		case khPRACOWNIK
			KonwSubTyp = SUB_PRACOWNICY
		case khURZAD
			KonwSubTyp = SUB_URZEDY
	endselect
EndSub

int Sub KonwTyp(int Typ)
	select case Typ
		case khPRACOWNIK
			KonwTyp = 0x001
		case khURZAD
			KonwTyp = 0x010
		case khKONTRAHENT
			KonwTyp = 0x100
	endselect
EndSub

int Sub RejestrWB(long rejestr)
	RejestrWB=0

	strPow = using "%l",rejestr
	if Rejestry.Index(strPow) then
		RejestrWB = Rejestry.Get(strPow)
	else
		//tak jak WB obsugiwane s wszystkie raporty oprcz tych "RK"
		if !basKH.GetRecById(rejestr) && basKH.GetField("imie") != "RK" then
			Rejestry.Set(strPow,1)
			RejestrWB = 1
		else
			Rejestry.Set(strPow,0)
			RejestrWB = 0
		endif
	endif
EndSub

int sub CzySynchr(long idKH)
	if (intCzyWdrozenieSymfonia) then
		CzySynchr = 1
	else
		CzySynchr = IsKhUsed(idKH)
	endif
endsub

float declare ZliczKwote( string k1, long id, long khidfk, int nWal)

record InfoPN
	string kodPN[41]
	string kodWB[41]
	string termin[20]
	string datapn[20]
	string waluta[10]
	string guid[40]
	string seria[50]
	string strkhid[20]
	int typkh
	int typkhfk
	int typ
	int flag
	int wyplata
	int mnozn
	int czyWal	
	long id
	long rejestr
	long dkid
	long khid
	long khidfk
	float kwotapn
	float kwotapnrozl
	float kwotapnwal
	float kwotapnrozlwal
	float kurs

	int moveState
	int moveStanType
	int moveType

	//funkcja wewntrzna
	int sub LoadFK(Dispatch rozr, string documentName)
		LoadFK = 0
		rozr.ClearParams
		rozr.StanType = moveStanType
		rozr.Type = moveType
		rozr.SubjectPoz = khidfk
		rozr.SubjectType = typkhfk
		rozr.DocumentName = documentName
		rozr.Load
		LoadFK = !rozr.MoveFirst
	endsub

	int sub GetAndSetState(Dispatch rozr)
		GetAndSetState = 0
		if(moveState == MOVE_NEXT_CLEAR) then
			moveState = MOVE_NEXT_GUID
#ifndef LITE
			if(CheckETransfersEnabled()) then
				if(guid != "") then
					if LoadFK(rozr, guid) then GetAndSetState = 1 : exit
					//nie znalaz - koczymy:
					moveState = MOVE_NEXT_END : exit
				endif
			endif
#endif
		endif

		if(moveState == MOVE_NEXT_GUID) then
			moveState = MOVE_NEXT_KOD
			if(LoadFK(rozr, kodPN)) then GetAndSetState = 1 : exit

			if(len(kodWB) > 0 && LoadFK(rozr, kodWB)) then GetAndSetState = 1 : exit
		endif

		moveState = MOVE_NEXT_END
	endsub

	int sub MoveFirst(Dispatch rozr, int stantype, int type, int startFrom)	
		moveStanType = stantype
		movetype = type
		moveState = startFrom
		MoveFirst = GetAndSetState(rozr)
	endsub

	int sub MoveNext(Dispatch rozr)
		MoveNext = 0
		if(moveState == MOVE_NEXT_END) then exit
		if !rozr.MoveNext then MoveNext = 1 : exit
		MoveNext = GetAndSetState(rozr)		
	endsub

	int sub UstalKod()
		//jesli pozycja raportu bankowego to kod taki jak raport kod WB
		kodWB = ""
		if ((typ==PLAT) || (typ==PLATROZL)) && rejestr && RejestrWB(rejestr) then
			basRP.SetKey("rejestr")
			basRP.SetKeySeg("idrj", rejestr)
			basRP.SetKeySeg("waluta", waluta)
			basRP.SetKeySeg("data", termin)
			if !basRP.GetRec(EQ) then kodWB = basRP.GetField("kod")
		else
			if dkid && (!basDK.GetRecById(dkid)) && (basDK.GetField("typi")==202) then
			//jesli dokument zakupu numer dokumentu w FK
				if basDK.GetField("kod_obcy") == "" then
					kodPN = using "[%s]", basDK.GetField("kod")
				else
					kodPN = using "%s [%s]", basDK.GetField("kod_obcy"), basDK.GetField("kod")
				endif
//				if(len(kodPN) > 40) then kodPN = Mid(kodPN, 1, 40)		
				datapn = basDK.GetField("datasp")
			endif		
		endif
		if seria == SERIA_FK then
			if len(kodPN) == 25 then				
				if (mid(kodPN, 25, 1) == A0CHAR) then
					kodPN = mid(kodPN, 1, 24) + " "
				endif
				buf = basPN2.GetField("schemat")
				arg A0CHAR, " "
				replace arg
				kodPN += buf
			endif
		endif
	endsub

	int sub Read(BasePN bPN)
		id 		= bPN.GetField("id")
		dkid 	= bPN.GetField("dkid")
		typkh 	= bPN.GetField("typkhi")
		typ 	= bPN.GetField("typi")
		kodPN 	= bPN.GetField("kod")
		termin 	= bPN.GetField("termin")
		datapn 	= bPN.GetField("data")
#ifndef LITE
		guid 	= bPN.GetField("guid")
#endif
		rejestr = bPN.GetField("rejestr")
		waluta 	= IIF(bPN.GetField("waluta") == "", "PLN", bPN.GetField("waluta"))
		czyWal = IIF(waluta == "PLN", 0, 1)
		seria	= bPN.GetField("seria")
		typkhfk = KonwSubTyp(typkh)
		khid 	= basPN.GetField("khid")
		strkhid = using "%l", khid
		khidfk 	= GetKhIdFk(strkhid)
		kwotapn	= bPN.GetField("kwota")
		kwotapnrozl = bPN.GetField("kwotarozl")
		kwotapnwal	= bPN.GetField("kwotawal")
		kwotapnrozlwal = bPN.GetField("kwotarozlwal")
		kurs = bPN.GetField("kurs")		
		wyplata = bPN.GetField("wyplatai") 
		mnozn 	= IIF(wyplata == 1, -1, 1)				
		//ustalenie kodu
		UstalKod()
	endsub	

	int sub CzyDopasowane(dispatch rozr)
			string dokSymbol
#ifndef LITE
			if CheckETransfersEnabled() then
				//jesli jeden z rozrachunkw (HM-FK) ma guida - to zwracamy wynik dopasowania(nie sprawdzamy nazwy)
				if (guid != "") || (rozr.Value("eGUID") != "") then CzyDopasowane = rozr.Value("eGUID") == guid: exit 
			endif
#endif
			//nie mozna dopasowa Guidw(oba s puste, lub FK | HM nie obsuguj Guidw
			dokSymbol =  rozr.Value("dokSymbol")

			CzyDopasowane = (((dokSymbol == kodPN) || (len(kodWB) > 0 && dokSymbol == kodWB)) && rozr.Value("pozycja") == khidfk && rozr.Value("subTyp") == typkhfk)		
	endsub

	int sub RozliczenieFK(dispatch rozr, int tryb)

		int stronahmfk
		int stronahm
		float fwKH
		float kwPN
		float kwPNRozl
		float kwFK
		float kursFK
		int TRYB_ROZNICA = TRYB_ROZLICZONYWFK | TRYB_ROZLICZONYWHM		
	
		RozliczenieFK = 0

		if (tryb & TRYB_SPRAWDZNAZWE) then
			//nie dopasowano ani guida ani nazwy - nie puszczamy
			if !CzyDopasowane(rozr) then exit
		endif

		stronahmfk = IIF(rozr.Value("kwota") < 0, !rozr.Value("strona"), rozr.Value("strona"))
		stronahm = IIF(typ & PLAT , !wyplata, wyplata)
	
		if stronahmfk == stronahm || dkid != 0 then
			if stronahmfk != stronahm && dkid != 0 then
				//jeli nie zgadza si strona ale jest to rozrachunek do dokumentu handlowego (dkid != 0), to wyjtkowo robimy magi:
				//rozrachunek w HM rozliczamy w caoci, rozrachunek z FK pozostawiamy do powizania z innym rozrachunkiem HM (brak RozliczenieFK = 1)
				tryb &= TRYB_ROZLICZONYWFK
			else
				RozliczenieFK = 1
			endif

			if(czyWal) then
				kwPN = kwotapnWal
				kwPNRozl = kwotapnRozlWal
				kwFK = rozr.Value("kwotaWal")
				kursFK = rozr.Value("kurs")
			else
				kwPN = kwotapn
				kwPNRozl = kwotapnRozl
				kwFK = rozr.Value("kwota")
			endif

			if(tryb & TRYB_ROZLICZONYWHM) then
				fwKH = 0.0
				kursFK = kurs
			else
				fwKH = Round( (kwPN - IIF( typ == PLAT, kwPNRozl, 0)), 2) * mnozn
			endif

			if(tryb & TRYB_ROZLICZONYWFK) then
				kwFK = 0.0
				kursFK = kurs
			endif		

			if (tryb & TRYB_ROZNICA) || Round(fwKH - kwFK, 2) then
				fwKH += ZliczKwote( IIF(stronahm, "1", "2"), id, khidfk, czyWal)
				if (tryb & TRYB_ROZNICA) || Round(fwKH - ABS(kwFK), 2) then
					if(czyWal) then
						RozliczFKWal(id, Round(fwKH - ABS(kwFK), 2), kursFK)
					else
						RozliczFK(id, Round(fwKH - ABS(kwFK), 2))
					endif
				endif
			endif		
		endif
	endsub

endrec

float sub ZliczKwote( string k1, long id, long khidfk, int nWal)
	InfoPN recPN
	long rejestr
	int err
	string k2, strPole
	Dispatch rozrpom2

	ZliczKwote = 0

	rozrpom2.Create(ObjectFK(".Rozrachunki"))
	rozrpom2.Open(dbd)

	k2 = IIF(k1 == "1", "2", "1")

	basRL.SetKey("cross" + k1)
	strPole="id" + k1
	basRL.SetKeySeg(strPole, id)
	basRL.SetKeySeg("id" + k2, 0)
	err=basRL.GetRec(GE)
	while !err && basRL.GetField(strPole)==id
		if !basPN2.GetRecById(basRL.GetField("id" + k2)) then
			recPN.Read(basPN2)	
			if !recPN.MoveFirst(rozrpom2, ROZ_STAN_ALL, ROZ_WSZYSTKO, MOVE_NEXT_CLEAR) then 
				if nWal then
					ZliczKwote += basRL.GetField("wartrozl" + k1)
				else
					ZliczKwote += basRL.GetField("wartosc")
				endif
			endif
		endif
		err=basRL.GetRec(NX)
	wend
endsub

int Sub SprawdzPlatnosciHandlu(int typ, long idKH, int checkRozrachFk)
int err, znaleziony, czyKH, succ
long khidfk	
string strPow
InfoPN recPN

	if  (idKH >= 65536) then
		basPN.SetKey("khid")
		basPN.SetKeySeg("khid", idKH)
		basPN.SetKeySeg("typi", typ)
		czyKH = 1
	else
		basPN.SetKey("platnosc")
		basPN.SetKeySeg("typi", typ)
		czyKH = 0
	endif

	err = basPN.GetRec(GE)
	while !err && basPN.GetField("typi")==typ && iif(czyKH,basPN.GetField("khid")==idKH,TRUE)
		if (typ == PLAT || iif(checkRozrachFk, basPN.GetField("seria") == SERIA_FK, basPN.GetField("seria") != SERIA_FK)) then
			if !(basPN.GetField("flag")&0x4000) then
				strPow = using "%l", basPN.GetField("khid")
				khidfk = GetKhIdFk(strPow)
				if !Kontrahenci.Index(strPow) then
					Kontrahenci.Set(strPow,CzySynchr(basPN.GetField("khid")))
				endif
				if (Kontrahenci.Get(strPow)) && khidfk && iif((!czyKH && (idKH != 0x111)), idKH&KonwTyp(basPN.GetField("typkhi")), TRUE) then
					recPN.Read(basPN)
					if !czykh then popup(2,using "Patno %s",recPN.kodPN)
					err = rozr.MoveFirst
					znaleziony=0
					While !err && !znaleziony
						strPow = using "%l", rozr.Value("idTrans")
						if !Powiazania.Get(strPow) then
							znaleziony = recPN.RozliczenieFK(rozr, TRYB_SPRAWDZNAZWE)
							if (znaleziony) then
								Powiazania.Set(strPow,1)
								progress.NextOne()
							endif
						endif
						err = rozr.MoveNext
					Wend				
					if !znaleziony then
						succ = 0
						err = !recPN.MoveFirst(rozrpom, ROZ_STAN_ROZ, ROZ_WSZYSTKO, MOVE_NEXT_CLEAR)
						while !err && !succ
							succ = recPN.RozliczenieFK(rozrpom, TRYB_ROZLICZONYWFK)
							err = !recPN.MoveNext(rozrpom)
						wend
						if !succ && recPN.seria == SERIA_FK then UsunDokument(recPN.id,BAS_Pn)
					endif
				endif
			endif
		endif
		err = basPN.GetRec(NX)
	wend
EndSub

int Sub ZnajdzPlatnoscHandlu(long idkhfk, long idkh, int typ, string konto, Dispatch rozr)

int err, stronahm
string strGuidFK
InfoPN recPN

	ZnajdzPlatnoscHandlu = 0
	stronahm = IIF( rozr.Value("strona") == ROZ_NALEZ, 1, -1)

#ifndef LITE
	if(CheckETransfersEnabled() && typ != PLATROZL) then
		if rozr.Value("eGUID") != "" then
			basPN.SetKey("guid")
			basPN.SetKeySeg("guid", rozr.Value("eGUID"))
			if(!basPN.GetRec(EQ)) then			
				ZnajdzPlatnoscHandlu = recPN.RozliczenieFK(rozr, TRYB_ROZLICZONYWHM) 			
			endif
		endif
	endif
#endif

    if(!ZnajdzPlatnoscHandlu) then
		basPN.SetKey("khid")
		basPN.SetKeySeg("khid", idkh)
		basPN.SetKeySeg("typi", typ)
	
		err = basPN.GetRec(GE)
		while !err && !ZnajdzPlatnoscHandlu && (basPN.GetField("khid") == idkh) && (basPN.GetField("typkhi") == KonwSubTyp(rozr.Value("subTyp"))) && (basPN.GetField("typi") == typ)
			recPN.Read(basPN)
			ZnajdzPlatnoscHandlu = recPN.RozliczenieFK(rozr, TRYB_SPRAWDZNAZWE | TRYB_ROZLICZONYWHM) 
			err = basPN.GetRec(NX)
		wend	
	endif


	if ((!ZnajdzPlatnoscHandlu) && (typ==PLATROZL)) then
		sukces=0
		for i=1 to i>size(RokFKRozr)
			if RokFKRozr(i).IdRok == dbd.firmainfo.GetRokByDate(rozr.Value("dokData")) && RokFKRozr(i).Zap == 1 then sukces=i
		next i
		if sukces then
			plkn=RokFKRozr(sukces).PlanKont
		else
			if !(size(RokFKRozr)==1 && RokFKRozr(1).Zap == 0) then grow RokFKRozr, 1
			sParam = using "%d", dbd.firmainfo.GetRokByDate(rozr.Value("dokData"))
			RokFKRozr(size(RokFKRozr)).PlanKont.Create(ObjectFK(".PlanKont"))
			RokFKRozr(size(RokFKRozr)).PlanKont.Open(sParam,dbd)
			if !RokFKRozr(size(RokFKRozr)).PlanKont.MoveFirst() then
				AddError("Brak planu kont.",0)
			endif
			RokFKRozr(size(RokFKRozr)).IdRok=dbd.firmainfo.GetRokByDate(rozr.Value("dokData"))
			RokFKRozr(size(RokFKRozr)).Zap=1
			plkn = RokFKRozr(size(RokFKRozr)).PlanKont
		endif

		//jesli nie ma konto, to tez tworzymy rozrachunek
		if(!plkn.MoveTo(konto) || ((plkn.Value("Typ") ==1 ) && (plkn.Rozrachunkowe > 0))) then 
#ifndef LITE
			if CheckETransfersEnabled() then strGuidFK = rozr.Value("eGUID")
			RozrachunekFK(rozr.Value("dokSymbol"), idkh, rozr.Value("dokData"), rozr.Value("termin"), stronahm*rozr.Value("kwota"), stronahm*rozr.Value("kwotaWal"), rozr.Value("kurs"), rozr.Value("waluta"), (using "Dokument FK: %s nr ewid. %l",rozr.Value("dokSkrot"), rozr.Value("dokNumer")), strGuidFK)
#else
			RozrachunekFK(rozr.Value("dokSymbol"), idkh, rozr.Value("dokData"), rozr.Value("termin"), stronahm*rozr.Value("kwota"), stronahm*rozr.Value("kwotaWal"), rozr.Value("kurs"), rozr.Value("waluta"), (using "Dokument FK: %s nr ewid. %l",rozr.Value("dokSkrot"), rozr.Value("dokNumer")))
#endif
		endif
	endif
EndSub

int Sub SprawdzRozrachunkiFK(int czykh)
int err
long idpn, idkh, idkhfk
string konto, strPow

	err = rozr.MoveFirst
	While !err
		strPow = using "%l",rozr.Value("idTrans")
		if !Powiazania.Get(strPow) then
			basKH.SetKey("fk")
			basKH.SetKeySeg("typi",KonwSubTyp(rozr.Value("subTyp")))
			basKH.SetKeySeg("idfk", rozr.Value("pozycja"))
			if !basKH.GetRec(EQ) then
				strPow = using "%l", basKH.GetField("id")
				if !Kontrahenci.Index(strPow) then
					Kontrahenci.Set(strPow, CzySynchr(basKH.GetField("id")))
				endif
				if Kontrahenci.Get(strPow) then
					idkh = basKH.GetField("id")
					idkhfk = rozr.Value("pozycja")
					if !czykh then popup(2,using "Rozrachunek %s",rozr.Value("dokSymbol"))
					konto=using "%d",rozr.Value("synt")
					if rozr.Value("poz1") then konto += using "-%d",rozr.Value("poz1")
					if rozr.Value("poz2") then konto += using "-%d",rozr.Value("poz2")
					if rozr.Value("poz3") then konto += using "-%d",rozr.Value("poz3")
					if rozr.Value("poz4") then konto += using "-%d",rozr.Value("poz4")
					if rozr.Value("poz5") then konto += using "-%d",rozr.Value("poz5")
					if !ZnajdzPlatnoscHandlu(idkhfk, idkh, NALROZL, konto, rozr) then
						ZnajdzPlatnoscHandlu(idkhfk, idkh, PLATROZL, konto, rozr)
					endif
				endif
			endif
			progress.NextOne()
		endif
		err = rozr.MoveNext
	Wend
EndSub

int Sub BeginProcessInt()
	isSyncroRunning = 1
	CreateObjRozr()
	if ( basKH.Open() ) then error "Bd otwarcia bazy KH"
	if ( basPN.Open() ) then error "Bd otwarcia bazy PN"
	if ( basPN2.Open() ) then error "Bd otwarcia bazy PN"
	if ( basRL.Open() ) then error "Bd otwarcia bazy RL"
EndSub

int Sub EndProcessInt(int czykh)
	basKH.close()
	basPN.close()
	basPN2.close()
	basRL.close()
	if !czykh	then popup(-1,"")
	progress.Reset(0)	
	isSyncroRunning = 0
EndSub

int Sub IntegrRozrachunki(long idKH)
	
if(isSyncroRunning) then exit

int err,count=0
long khidfk
int czykh = (idKH >= 65536)

	if !czykh then popup(0,"Synchronizacja rozrachunkw z FK")
	if !czykh then popup(1,"Tworzenie obiektw")

	BeginProcessInt()

	PowiazaniaClear()
	RejestryClear()
	KontrahenciClear()

	rozr.ClearParams
	rozr.StanType = ROZ_STAN_NROZ
	if czykh then
		basKH.GetRecById(idKH)
		khidfk=basKH.GetField("idfk")
		if !khidfk || !CzySynchr(idKH) then
			EndProcessInt(czykh)
			Exit
		endif
		rozr.SubjectType = KonwSubTyp(basKH.GetField("typi"))
		rozr.SubjectPoz = khidfk
	endif

	if !czykh then popup(1,"adowanie rozrachunkw FK")

	rozr.Load

	err = rozr.MoveFirst
	While !err
		strPow = using "%l", rozr.Value("idTrans")
		if czykh then
			Powiazania.Set(strPow,0)
			count+=1
		else
			if idkh&KonwTyp(KonwSubTyp(rozr.Value("subTyp"))) then
				Powiazania.Set(strPow,0)
				count+=1
			else
				Powiazania.Set(strPow,1)
			endif
		endif
		err = rozr.MoveNext
	Wend

	progress.Reset(count)
	if !czykh then popup(1,"Sprawdzanie patnoci Handlu")

	SprawdzPlatnosciHandlu(NAL, idKH, 0)	//w pierwszej kolejnoci ptla po rozrachunkach handlowych
	SprawdzPlatnosciHandlu(NAL, idKH, 1)	//nastpnie dopiero po rozrachunkach pochodzcych z FK (Rozrachunek FK)
	SprawdzPlatnosciHandlu(PLAT, idKH, -1)

	if !czykh then popup(1,"Sprawdzanie rozrachunkw FK")

	SprawdzRozrachunkiFK(czykh)

	EndProcessInt(czykh)
EndSub