//"Mig_SQL.sc","Weryfikacja przed migracj",12004,0,1.0.2,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// Weryfikacja przed migracj
// Mig_SQL.sc
////////////////////////////

int errors = 0
int warnings = 0
int unapproved = 0
int userbreak = 0
int fromarchive = 0
int pos

string par_arg0 = ""
string par_arg1 = ""
string par_arg2 = ""
string par_arg3 = ""

int pdfGen = 0
string pdfPath = ""

int runrap = 0

// Uruchomiony z menu "Weryfikacja bazy przed migracj"
// arg4 - gdy tryb zapisu do PDF przekazywany katalog
runrap = 1
par_arg1 = "1"
par_arg2 = "1"

// nazwa katalogu dla generowanych plikw PDF
if len(arg4) > 0 then
	pdfGen = 1
	pdfPath = arg4
	par_arg3 = "1"
endif

Int    logEnable = 1
Int    typWydruku = 0
Int    wide = 0
String nazwaRaportu
String nazwaRaportu2
Date   DataSystemowa
Int    bFirst = 1
Int    logDefaultHandle

#include "Weryfikacja przed migracj - include"
#include "Diagnostyka - funkcje"

SetStrona( 1900, 1900, 2300)
strona 70, 170, 70, 100
setFont( copyFont( "tekst", -1, 30 ) )
nazwaRaportu = "Test bazy przed migracj danych do SQL"
nazwaRaportu += " - SPRAWDZENIE"

string sVer = prgVersionSelf()
if sVer then nazwaRaportu2 = "Wersja " + sVer

record DiagReport
	string diag_file[256]
	string diag_name[256] 
endrec

int DIAG_COUNT = 29

record DiagnostykaReports
	DiagReport reports(DIAG_COUNT)

	int sub AddReport(int pos, string diag_file, string diag_name)
		reports(pos).diag_file = diag_file
		reports(pos).diag_name = diag_name
	endsub

	int sub InitReports()
		AddReport(  1, "dokbuf.sc",   "Dokumenty w buforze")
		AddReport(  2, "diag_ck.sc",  "51ck : diagnostyka promocji okresowych")
		AddReport(  3, "diag_dk.sc",  "51dk : diagnostyka dokumentw handlowych")
		AddReport(  4, "diag_dp.sc",  "51dp : diagnostyka pozycji handlowych")
		AddReport(  5, "diag_dt.sc",  "51dt : diagnostyka danych dostawcw towaru")
		AddReport(  6, "diag_dw.sc",  "51dw : diagnostyka dostaw towarw")
		AddReport(  7, "diag_fp.sc",  "51fp : diagnostyka wpat na FPR")
		AddReport(  8, "diag_kh.sc",  "51kh : diagnostyka danych kontrahentw")
		AddReport(  9, "diag_mg.sc",  "51mg : diagnostyka dokumentw magazynowych")
		AddReport( 10, "diag_mm.sc",  "51mm : diagnostyka danych stanw min. i maks.")
		AddReport( 11, "diag_mz.sc",  "51mz : diagnostyka pozycji magazynowych")
		AddReport( 12, "diag_nt.sc",  "51nt : diagnostyka danych notatek")
		AddReport( 13, "diag_od.sc",  "51od : diagnostyka bazy ochrony danych")
		AddReport( 14, "diag_pn.sc",  "51pn : diagnostyka patnoci i rozrachunkw")
		AddReport( 15, "diag_pw.sc",  "51pw : diagnostyka rozlicze magazynowych")
		AddReport( 16, "diag_rb.sc",  "51rb : diagnostyka rachunkw bankowych podmiotw")
		AddReport( 17, "diag_ru.sc",  "51ru : diagnostyka bazy rejestracji udostpnie")
		AddReport( 18, "diag_rv.sc",  "51rv : diagnostyka rejestrw VAT")
		AddReport( 19, "diag_sm.sc",  "51sm : diagnostyka stanw magazynowych")
		AddReport( 20, "diag_tw.sc",  "51tw : diagnostyka danych towarw")
		AddReport( 21, "diag_xt.sc",  "51xt : diagnostyka ustawie firmy")
		AddReport( 22, "diag_zn.sc",  "51zn : diagnostyka danych zapotrzebowania")
		AddReport( 23, "diag_zz.sc",  "51zz : diagnostyka zwizkw")
		AddReport( 24, "diag_idk.sc", "5idk : diagnostyka indeksw dok. handlowych")
		AddReport( 25, "diag_idp.sc", "5idp : diagnostyka indeksw pozycji handlowych")
		AddReport( 26, "diag_img.sc", "5img : diagnostyka indeksw dok. magazynowych")
		AddReport( 27, "diag_imz.sc", "5imz : diagnostyka indeksw pozycji magazynowych")
		AddReport( 28, "diag_ipn.sc", "5ipn : diagnostyka indeksw patnoci i rozrach.")
		AddReport( 29, "diag_dos.sc", "Diagnostyka dostaw i stanw magazynowych")
		//AddReport( 30, "dokarch.sc",  "Dokumenty z archiwum")
		// #######################################################
		// ##########          vide DIAG_COUNT          ##########
		// #######################################################
	endsub

	string sub DiagFile(int pos)
		DiagFile = reports(pos).diag_file
	endsub

	string sub DiagName(int pos)
		DiagName = reports(pos).diag_name
	endsub

endrec

DiagnostykaReports reports
reports.InitReports()

int sub Opis( int pie)
endsub

int sub Podsumowanie( int last)
endsub

Header(1)

int sub RunSingleReport(int pos)
	string retvalue 
	string diag_name = reports.DiagName(pos)

	// sub, kolejnych raportw nie wykonujemy po przerwaniu ktregokolwiek
	if userbreak != 0 then exit 

	if pdfGen then
		retvalue = Run( diag_name, -2, pdfPath, par_arg0, par_arg1, par_arg2, par_arg3, pdfPath, GetVMarker() )
	else
		retvalue = Run( diag_name, par_arg0, par_arg1, par_arg2, par_arg3, "", "", GetVMarker() )
	endif

	if mid( retvalue, 1, 2 ) == "0:" then
		close
		error using "Niepoprawnie wykonany raport: \"%s\" (%s)", diag_name, reports.DiagFile(pos)
	endif

	string sStatus 
	if mid( retvalue, 1, 2 ) == "1:" then
		userbreak = 1
	else
		print using "Wykonanie raportu \"%s\".\n", diag_name
		if mid( retvalue, 3, 10 ) == "unapproved" then
			unapproved = 1
			sStatus = "false"
		else
			if mid( retvalue, 3, 6 ) == "errors" then
				errors = 1
				sStatus = "false"
			else
				if mid( retvalue, 3, 8 ) == "warnings" then
					warnings = 1
				else			
					if mid( retvalue, 3, 11 ) == "fromArchive" then
						fromarchive = 1
					else			
					endif
				endif
				sStatus = "true"
			endif
		endif
	endif
	
endsub

rexParser rp
rp.init( " " )
int rpc = rp.parse( getResourceString( "AboutComponent" ) )

for pos = 1 to pos > DIAG_COUNT
	RunSingleReport(pos)
next pos

buf = ""
if userbreak != 0 then 
	print "\nUWAGA: Weryfikacja zostaa przerwana.\n"
	buf = "errors"
endif
if buf == "" && ( unapproved != 0 || errors != 0) then
	if unapproved != 0 then
		print "\nUWAGA:\nW bazie danych znaleziono dokumenty w buforze.\nPrzed wykonaniem migracji naley je usun.\n"
		buf = "unapproved"
	endif
	if errors != 0 then
		print "\nUWAGA:\nDiagnostyka bazy przed migracj wykazaa bdy.\nPrzed wykonaniem migracji baza wymaga naprawy.\n"
		if buf == "" then buf = "errors"
	endif
	if pdfGen != 0 then print using "Szczegowe informacje weryfikacji przed migracj zapisano w katalogu:\n%s\n", pdfPath
	message "Przed wykonaniem migracji naley wykona operacje wskazane w podsumowaniu zbiorczego raportu."
endif
if buf == "" && fromarchive != 0 then
	print "\nUWAGA:\nW bazie danych znaleziono dokumenty zaimportowane z archiwum.\nMoliwa tylko migracja dokumentw pieninych i stanw magazynowych.\n"
	buf = "fromarchive"
	if pdfGen != 0 then print using "Szczegowe informacje weryfikacji przed migracj zapisano w katalogu:\n%s\n", pdfPath
	message "W bazie danych znaleziono dokumenty zaimportowane z archiwum.\nMoliwa tylko migracja dokumentw pieninych i stanw magazynowych."
endif
if buf == "" then
	if warnings == 1 then
		message "Nie wykryto bdw blokujcych migracj."
		buf = "warnings"
	else
		message "Nie wykryto bdw."
	endif
endif

Footer(1)

close
