//"diag_dp.sc","51dp : diagnostyka pozycji handlowych",12004,0,1.0.4,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// 51dp : diagnostyka pozycji handlowych
// diag_dp.sc
////////////////////////////
// Napisa: Sebastian Nowak
// data:    98.07.10


#ifdef HM
#define HMHL
#endif
#ifdef HL
#define HMHL
#endif
#define NAZWA_PLIKU "DIAG_DP.TXT"

// anulowane
#define ANUL     0
#define WZANUL   1
#define ARCH	 2
#define PARANUL	 3

// dokumenty sprzeday
#define FVS      40    
#define FKS      41    
#define RUS      42    
#define RKS      43    
#define PAR		 50	
#define PRK 	 51				
#define FVW		101		
#define FKW		102		
#define FVM		106	
#define FKM		107		
#define FZS		108	
#define KZS		109	
#define ZKS		112		
#define WDT		114		
#define FWS		116		
#define WKS		118		
#define WDK		120		
#define FVT		124	
#define FTK		125		
#define REX		126		
#define RXK		127		
#define DXK      45    
#define DEX      46     
#ifdef HM
// dokumenty zakupu

#define DIM      72      
#define DKM      73      
#define WNT		115		
#define WNK		121	
#define	ZVW		138		
#define	ZWK		139	

#endif

#ifdef HMHL
#define FVZ      68      
#define FKZ      69     
#define RUZ      70     
#define RKZ      71      
#define FZZ		110	
#define KZZ		111		
#define ZKZ		113		
#define FWZ		117		
#define FVR      99     
#define FKR      100     
#define WKZ		119	
#endif

#define UPDATE_ROZLICZ_HANDL 0
// 1 - aktualizacja rozliczen handlowych dla wszystkich dokumentow zakupu koerkt badz korygowanych
// 0 - aktualizacja rozliczen handlowych dla wybranych przez diagnopstyke dokumentow zakupu koerkt badz korygowanych

#define VAT_NP 255
MapValue mRozlK
mrozlK.Clear() 

record rPozKomp
	int jest
	float ilosc
	float iloscWP
	float cena
	float wartosc
	float vat
int sub Zeruj()
	jest=ilosc=iloscWp=cena=wartosc=vat=0
endsub
endrec
record rKomp
	int lp
	long id
	float wartTow
	float iloscdorozl
	float iloscWp
	float cena
	float wartosc
	float vat
	
	rPozKomp pozycje(1)
int sub Zeruj()
	lp=id=wartTow=iloscDoRozl=cena=wartosc=vat=0
	shrink pozycje,-1
	pozycje(1).Zeruj()
	mRozlK.Clear()
endsub
int sub DodajPozycje(float il,float ilWp,float c, float w, float v)
	if pozycje(1).jest then grow pozycje,1
	pozycje(size(pozycje)).jest=1
	pozycje(size(pozycje)).ilosc = il
	pozycje(size(pozycje)).iloscWp = ilWp
	pozycje(size(pozycje)).cena = c
	pozycje(size(pozycje)).wartosc = w
	pozycje(size(pozycje)).vat = v
endsub
int sub IlePoz()
	IlePoz = size(pozycje)
endsub
endrec
rKomp rRozlK(1)
int i
float fTmp						


string sRaportDescription

#include "Diagnostyka - funkcje"
UsunRekord_0("DP")

sDialogTitle += "pozycji dokumentw handlowych"

StageAddDesc("Raport porwnuje sum wartoci NETTO, BRUTTO oraz VAT z pozycji dokumentw z")
StageAddDesc("wartociami zapisanymi w dokumentach oraz porwnuje zawartoci baz DP")
StageAddDesc("oraz IDP.")
StageAddStage("Sprawdzenie integralnoci bazy DP oraz IDP")
StageAddStage("Sprawdzenie poprawnoci pozycji")
StageAddStage("Porwnanie sumy pozycji z dokumentem")
StageAddStage("Sprawdzenie dugich nazw")
ChooseStages(400)

BaseDK dk
BaseDK dko
BaseAll nt
BaseAll nt2
BaseAll dp
BaseAll dp2
BaseAll dpnew
BaseAll xt
BaseTW tw
BaseZZ zz
#ifdef HMHL
BaseMZ mz
#endif

BaseAll bp
long idp
int byly, err2, bylyFlag
int typ, bKorekta, TypPozComm, lpTypPozComm, iCzyAktualiz, subtyp
int nStVat3 = -1

MapValue mvKomplet
mvKomplet.Type(long)
string strKomplet

float vat,netto,vatdk,nettodk,fKurs, walNetto, walNettoDk, walBrutto, walBruttoDk, wartPrzychod, wartPrzychodDk
long id, curr_lp,idrenum,last_dok, lSuper, idBazow,curr_lp_NP
string sRej, sTmp

#include "Diagnostyka pozycji handlowych - include"


OpenBaseB(dp,"DP")
OpenBaseB(dpnew, "DP")
OpenBaseB(dp2,"DP")
OpenBaseB(nt,"NT")
OpenBaseB(nt2,"NT")
OpenBaseB(xt,"XT")
OpenBaseB(bp,"BP")
dk.Open()
dko.Open()

TextOut("Podsumowanie sprawdzania poprawnoci bazy pozycji dokumentw handlowych\n\n")


if StageT(1) then SprawdzIDP()
StageSummary(1)


PopUp(1,"Sprawdzanie dowiza pozycji do dokumentw")

nt.SetKey("super")
nt2.SetKey("id")
dk.SetKey("id")
dp.SetKey("super")
dp.SetKeySeg("super",0)
dp.SetKeySeg("lp",0)

#ifdef HMHL
dp2.SetKey("idpozkoryg")
mz.SetKey("idhandl")
#endif

last_dok=0
err=dp.GetRec(GE)
progress.Reset(dp.GetRecordCount())

if !StageT(2) then err=1

MapValue mW2N
mW2N.Clear()
mW2N.Type(int)
MapValue mN2RR
mN2RR.Clear()
mN2RR.Type(int)
#define N2S using "%d"

int sub SetW2N(int w, int n)
	mW2N.Set(( N2S , w), n)
endsub
int sub CheckW2N(int w)
	CheckW2N  = mW2N.Index( N2S ,w)
endsub
int sub GetN4W(int w)
	if(GetN4W = CheckW2N(w)) then GetN4W = mW2N.Get(GetN4W)
endsub
int sub SetN2RR(int n, int rr)
	mN2RR.Set(( N2S , n), rr)
endsub
int sub CheckN2RR(int n)
	CheckN2RR  = mN2RR.Index( N2S ,n)
endsub
int sub GetRR4N(int n)
	if(GetRR4N = CheckN2RR(n)) then GetRR4N = mN2RR.Get(GetRR4N)
endsub


int rr
int wstv
xt.SetKey("super")
xt.SetKeySeg("super",10000)
xt.SetKeySeg("kod","")
err2 = xt.GetRec(GE)
while !err2 && xt.GetField("super") == 10000
	wstv = 10000.0 * xt.GetField("wartosc")
	rr = ((0x100 & xt.GetField("flag")) == 0x100) 
	if wstv > 0 then//omijamy zerowe
		SetW2N(wstv, xt.GetField("subtypi"))
		SetN2RR(xt.Getfield("subtypi"), rr)
	endif
	err2 = xt.GetRec(NX)
wend
if CheckW2N(300) then
	nStVat3 = GetN4W(300)
else
	nStVat3 = -1
endif

int ntypi

while !err
	progress.NextOne()
	dk.SetKeySeg("id",dp.GetField("super"))

#ifdef HMHL
	if (!dk.GetRec(EQ) && !(dk.GetField("exp_fki") & 0x20)) && !(dp.GetField("typi") & 0x10) && dp.GetField("flag")&0x0200 && !(dp.GetField("flag")&0x2000) && !(dp.GetField("typi") & 0x01)  then
		// sprawd wart iloscdorozl i wartTowaru
		if (dp.GetField("flag") & 0x0100) != (dk.GetField("flag") & 0x0100) then 
			if (dk.GetField("flag") & 0x0100) then
				dp.SetField("flag",dp.GetField("flag")|0x0100)
			else
				dp.SetField("flag",dp.GetField("flag")^0x0100)
			endif
			UpdateRecB(dp)
		endif
		dp2.SetKey("idpozkoryg")
		dp2.SetKeySeg("idpozkoryg",dp.GetField("id"))
		if !dp2.GetRec(EQ) then
			iCzyAktualiz = 1
			if !dp.GetField("idpozkoryg") then
				idBazow = dp.GetField("id")
			else
				idBazow = dp.GetField("idpozkoryg")
					
				while !dp2.GetRecById(idBazow) && dp2.GetField("idpozkoryg")
					idBazow = dp2.GetField("idpozkoryg")
				wend
			endif
		else		
			if dp.GetField("idpozkoryg") then
				iCzyAktualiz = 1
				idBazow = dp.GetField("idpozkoryg")
				while !dp2.GetRecById(idBazow) && dp2.GetField("idpozkoryg")
					idBazow = dp2.GetField("idpozkoryg")
				wend
			else
				iCzyAktualiz = 0
				idBazow = dp.GetField("id")
			endif
		endif
		netto = vat = 0
		mz.SetKeySeg("idhandl",dp.GetField("id"))
		mz.SetKeySeg("data","")
		err=mz.GetRec(GE)
		while !err && mz.GetField("idhandl")==dp.GetField("id")
			netto += mz.GetField("wartNetto") + mz.GetField("wartk")
			vat += mz.GetField("ilosc")
			err=mz.GetRec(NX)
		wend
		if dp.GetField("idpozkoryg") then
			dp2.SetKey("super")
			dp2.SetKeySeg("super",dp.GetField("super"))
			dp2.SetKeySeg("lp",dp.GetField("lp"))
			err2 = dp2.GetRec(EQ)
			while !err2 && dp2.GetField("super")==dp.GetField("super") && dp2.GetField("lp")==dp.GetField("lp") && !(dp2.GetField("typi") & 0x10)
				err2 = dp2.GetRec(NX)
			wend
			if dp2.GetField("super")==dp.GetField("super") && dp2.GetField("lp")==dp.GetField("lp") && dp2.GetField("id")!=dp.GetField("id") && (dp2.GetField("typi") & 0x10) then
				vat = ((-1)*dp2.GetField("ilosc"))+vat
				netto = ((-1)*dp2.GetField("wartTowaru"))+netto
				if dp2.GetField("iloscDoRozl") then
					TextOut(using "Pozycja wyrwnujca '%s' id=%l posiada ilo do rozliczenia",dp2.GetField("kod"),dp2.GetField("id"))
					dp2.SetField("iloscDoRozl",0)
					UpdateRecB(dp2)
				endif
			endif
		endif

		if (((dp.GetField("flag") & 0x0100) && iCzyAktualiz && UPDATE_ROZLICZ_HANDL) || ((dp.GetField("flag") & 0x0100) && iCzyAktualiz && CzyWartOK(idBazow))) then
			if TextOutAndAsk3(13,(using "Nie zgadza si warto towaru rozliczonego magazynowo w pozycji '%s' id=%l",dp.GetField("kod"),dp.GetField("id"))) then
				UstawWszytskie(idBazow,2) 
				UpdateRozliczHandl(dp.GetField("id"),(idBazow == dp.GetField("id")))
			else
				TextOut(sNoRepair)
			endif
		endif
		if (Sign(dp.GetField("wartTowaru")-(iif(dp.GetField("flag") & 0x0100,dp.GetField("cenaBaza"),0))-netto)) then
			if TextOutAndAsk(13,(using "Nie zgadza si warto towaru rozliczonego magazynowo w pozycji '%s' id=%l",dp.GetField("kod"),dp.GetField("id")),(using "\njest:%.2f  powinno by:%.2f\nCzy naprawi?",(dp.GetField("wartTowaru")-(iif(dp.GetField("flag")&0x0100,dp.GetField("cenaBaza"),0))),netto)) then
				if (dp.GetField("flag") & 0x0100) && iCzyAktualiz then
					UstawWszytskie(idBazow,1)
					UpdateRozliczHandl(dp.GetField("id"),(idBazow == dp.GetField("id")))
				else							
					dp.SetField("wartTowaru",netto)
					UpdateRecB(dp)					
				endif
			else
				TextOut(sNoRepair)
			endif
		endif
		if Sign(dp.GetField("ilosc")-dp.GetField("iloscDoRozl")-dp.GetField("rozlhandl")-vat,4) then
			if TextOutAndAsk(14,(using "Nie zgadza si ilo towaru rozliczonego magazynowo w pozycji '%s' id=%l",dp.GetField("kod"),dp.GetField("id")),(using "\njest:%.2f  powinno by:%.2f\nCzy naprawi?",dp.GetField("iloscDoRozl"),dp.GetField("ilosc")-dp.GetField("rozlhandl")-vat)) then
				if iCzyAktualiz then
					UstawWszytskie(idBazow,0)
					UpdateRozliczHandl(dp.GetField("id"),(idBazow == dp.GetField("id")))
				else
					dp.SetField("iloscDoRozl",dp.GetField("ilosc")-vat)
					UpdateRecB(dp)				
				endif	
			else
				TextOut(sNoRepair)
			endif
		endif
		if (dp.GetField("flag") & 0x0100) then //dla zakupu sprawdz czy koszt w poz nie jest mniejszy od wart pz-tw
			dpnew.GetRecById(dp.GetField("id"))
			if (idBazow==dpnew.GetField("id") && Sign(dpnew.GetField("cenabaztow")-dpnew.GetField("cenaBaza")-netto ) > 0) || (idBazow!=dpnew.GetField("id") && Sign(iif(Sign(dpnew.GetField("cenabaztow"))>0,-1,1)*(dpnew.GetField("cenabaztow")-dpnew.GetField("cenaBaza")-netto )) > 0) then
				if TextOutAndAsk(15,(using "Koszt zakupu jest mniejszy od faktycznej wartoci towaru w pozycji '%s' id=%l",dpnew.GetField("kod"),dpnew.GetField("id")),(using "\njest:%.2f  powinno by:%.2f\nCzy naprawi?",dpnew.GetField("cenabaztow")-(iif(dpnew.GetField("flag") & 0x0100,dpnew.GetField("cenaBaza"),0)),netto)) then
					dpnew.SetField("cenabaztow",netto)
					UpdateRecB(dpnew)
					if iCzyAktualiz then
						UpdateRozliczHandl(dpnew.GetField("id"),(idBazow == dpnew.GetField("id")))
					endif	
				else
					TextOut(sNoRepair)
				endif
			endif
		endif
	endif		
#endif
	// sprawdz st vat
#ifdef HMHL
	// dla pozycji ktore nie posiadaja rejestrw nalenych -> zerujemy wartosci na pozycji rejestrVAT2
	subtyp = dk.GetField("subtypi")
	if ( subtyp == WNT || subtyp == WNK || subtyp == ZVW || subtyp == ZWK || subtyp == RUZ || subtyp == RKZ || subtyp == FZZ || subtyp == KZZ || subtyp == ZKZ || subtyp == FVR || subtyp == FKR) then
		if dp.GetField("rejestrVAT2") != 255 then
			dp.SetField("rejestrVAT2",255)
			if dp.Update() then
				TextOut(using "Nie zgadza si rejestr naleny na pozycji '%s' dokumentu '%s' - NIE NAPRAWIONO - bd zapisu do bazy DP\n",dp.GetField("kod"),dk.GetField("kod"))
			else
				TextOut(using "Nie zgadza si rejestr naleny na pozycji '%s' dokumentu '%s' - NAPRAWIONO\n",dp.GetField("kod"),dk.GetField("kod"))
			endif
		endif
	endif

	if ((dk.GetField("subtypi") == FVR || dk.GetField("subtypi") == FKR)) then
		if (dk.GetField("datasp")>="2004-05-01") then
			if (!GetRR4N(dp.GetField("stvati"))) then
				TextOut(using "Pozycja '%s' id=%l ma niewaciwie okrelon stawk VAT",dp.GetField("kod"),dp.GetField("id"))
				fTmp = dp.GetField("wartstvat")
				fTmp/=100.0
				if(!CheckW2N(dp.GetField("wartstvat"))) then
					TextOut(using " - NIE NAPRAWIONO: Brak stawki o wartoci %.2f%%\n", fTmp)
				else
					rr = GetN4W(dp.GetField("wartstvat"))
					if !GetRR4N(rr) then
						TextOut(using " - NIE NAPRAWIONO: Stawka o wartoci %.2f%% nie jest stawk RR\n", fTmp)
					else
						dpnew.GetRecById(dp.GetField("id"))
						dpnew.SetField("stvati", rr)
						UpdateRecB(dpnew)
					endif
				endif  				
			endif
		else
			if (nStVat3!=-1 && dp.GetField("stvati")!=nStVat3) then
				TextOut(using "Pozycja '%s' id=%l ma niewaciwie okrelon stawk VAT",dp.GetField("kod"),dp.GetField("id"))
				dpnew.GetRecById(dp.GetField("id"))
				dpnew.SetField("stvati", nStVat3) //3% Stawka dla faktur VAT RR
				UpdateRecB(dpnew)
			endif
		endif
	else
#endif
		
		if (dp.GetField("stvati")<0) then
			TextOut(using "Pozycja '%s' id=%l ma niewaciwie okrelon stawk VAT",dp.GetField("kod"),dp.GetField("id"))
			if dp.GetField("wartstvat") > 0 then
				fTmp = dp.GetField("wartstvat")
				fTmp/=100.0
				if(!CheckW2N(dp.GetField("wartstvat"))) then
					TextOut(using " - NIE NAPRAWIONO: Brak stawki o wartoci %.2f%%\n", fTmp)
				else
					rr = GetN4W(dp.GetField("wartstvat"))
					dpnew.GetRecById(dp.GetField("id"))
					dpnew.SetField("stvati",rr)
					UpdateRecB(dpnew)
				endif
			else
				TextOut(using "- NIE NAPRAWIONO:Pozycja '%s' id=%l ma ustawiona warto stawki 0.00. Moliwe trzy stawki(0, ZW, NP).",dp.GetField("kod"),dp.GetField("id"))
			endif
		endif
#ifdef HMHL
	endif
#endif

	//sprawdz flagi przejcia do bazy indekso
#ifndef HMHL
	if (!dk.GetRec(EQ)) then
#endif
		select case dk.GetField("subtypi")
#ifdef HMHL
			case ANUL, WZANUL, ARCH, PARANUL, FWS, WKS, FWZ, WKZ
#else		
			case ANUL, WZANUL, ARCH, PARANUL, FWS, WKS
#endif
				if (!(dp.GetField("typi") & 0x01)) then
					TextOut(using "Pozycja '%s' id=%l ma bdnie (0x01) okrelon flag przejcia do bazy indeksowej",dp.GetField("kod"),dp.GetField("id"))
					ntypi = dp.GetField("typi")
					ntypi = ntypi | 0x01
					dp.SetField("typi", ntypi)
					if dp.Update() then
						TextOut(" - NIE NAPRAWIONO: Bd zapisu do bazy DP\n")
					else
						TextOut(sRepaired)
					endif
				Endif
		EndSelect
#ifndef HMHL
	Endif
#endif

	// sprawdz poprawnoci rezerwacji
	if ((firma.code == "HM") || (firma.code == "HL")) && dp.GetField("rezerwacja") then
		if zz.GetRecById(dp.GetField("rezerwacja")) || zz.GetField("typi")!=96 || zz.GetField("baza3")!=16 || zz.GetField("id3pos")!=dp.GetField("id") then
			if TextOutAndAsk3(7,using "Pozycja '%s' id=%l wskazuje na nieprawidow rezerwacje",dp.GetField("kod"),dp.GetField("id")) then
				dp.SetField("rezerwacja",0)
				UpdateRecB(dp)
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
	// czy istnieje dokument
	if !dp.GetField("super") then
		TextOut(using "Pozycja '%s' id=%l jest dowizana do dokumentu id=0",dp.GetField("kod"),dp.GetField("id"))
		Usun_notatke(dp.GetField("id"))
		DeleteRecB(dp)
	else
		if dp.GetField("super")!=last_dok then last_dok=0
		if !last_dok then
			dk.SetKeySeg("id",dp.GetField("super"))
			if dk.GetKey(EQ) then
				if TextOutAndAsk2(3,(using "Pozycja '%s' id=%l jest dowizana do dokumentu, ktry nie istnieje (id=%l)",dp.GetField("kod"),dp.GetField("id"),dp.GetField("super")),". Zalecane jest uruchomienie raportu diagnostycznego bazy dokumentw.","[&Nie usuwaj pozycji:p](&Usu pozycje:o)(&Przerwij:a)") then
					Usun_notatke(dp.GetField("id"))
					DeleteRecB(dp)
				else
					TextOut(" - NIE USUNITO - uruchom raport diagnostyczny bazy dokumentw\n")
				endif
			else
				last_dok=dp.GetField("super")
			endif			
		endif
	endif
	//sprawdz jednoznacznoci pl kod i idtw
	SprawdzKodTw()
	err=dp.GetRec(NX)
wend

StageSummary(2)

WriteStatusBar("Sprawdzanie pozycji dokumentw")
PopUp(1,"Sprawdzanie pozycji dokumentu:")
PopUp(2,"")

dk.SetKey("id")
dp.SetKey("super")
err=dk.GetRec(FS)
progress.Reset(dk.GetRecordCount())
int CzyKorDoARch

if !StageT(3) then err=1

while !err
	progress.NextOne()
	czyKorDoArch=KorektaDoArchiwum(dk.GetField("iddokkoryg"))
	typ=dk.GetField("typi")
	if (!typ || typ==201 || typ==202 || typ==100 || typ==111 || typ==112) && dk.GetField("subtypi")!=0 && dk.GetField("subtypi")!=1 && dk.GetField("subtypi")!=2 && dk.GetField("subtypi")!=3 then
		// nalicz netto i vat
		PopUp(2,dk.GetField("kod"))
		id=dk.GetKeySeg("id")
		dp.SetKey("super")
		dp.SetKeySeg("super",id)
		dp.SetKeySeg("lp",-32768)
		netto=vat=walNetto=walBrutto=wartPrzychod=0
		err=dp.GetRec(GE)
		bKorekta = !!dk.GetField("iddokkoryg")
		curr_lp = 0
		curr_lp_NP = 10000
		idrenum=0
		lpTypPozComm = 0
		TypPozComm = -1
		mvKomplet.Clear()
		shrink rRozlK,-1
		rRozlK(1).Zeruj()
		while !err && dp.GetKeySeg("super")==id
		
			if !bKorekta then
				if dp.GetField("flag")&0x5000 then	RozlKomplet()
				if (dp.GetField("lp")<=0) || (!(dp.GetField("flag")&0x4000) && dp.GetField("lp")-iif(CzyNumerNP(dp.GetField("stvati"), dk.GetField("subtypi"), dp.GetField("lp")),curr_lp_NP,curr_lp)!=1) then idrenum=id
				if ( dp.GetField("flag")&0x4000 && (dp.GetField("lp")-iif(CzyNumerNP(dp.GetField("stvati"), dk.GetField("subtypi"), dp.GetField("lp")),curr_lp_NP,curr_lp))) then
					dp2.SetKey("super")
					dp2.SetKeySeg("super",dp.GetField("super"))
					dp2.SetKeySeg("lp",dp.GetField("lp"))
					err2 = dp2.GetRec(EQ)
					while !err2 && dp2.GetField("super")==dp.GetField("super") && dp2.GetField("lp")==dp.GetField("lp") && !(dp2.GetField("flag")&0x1000)
						err2 = dp2.GetRec(NX)
					wend
					if dp2.GetField("super")!=dp.GetField("super") || dp2.GetField("lp")!=dp.GetField("lp") || !(dp2.GetField("flag")&0x1000) then
						idrenum=id
					endif
				endif
			endif
			if !(dp.GetField("flag")&0x4000) then
				if CzyNumerNP(dp.GetField("stvati"), dk.GetField("subtypi"), dp.GetField("lp")) then
					curr_lp_NP=dp.GetField("lp")
				else
					curr_lp=dp.GetField("lp")
				endif
			endif
			if  !CzyFaktWew(dk.GetField("subtypi")) && !(dp.GetField("flag")&0x2000) then
				if (dp.GetField("flag")&0x1000) || (dp.GetField("flag")&0x4000) then
					if !dp.GetField("idpozkoryg") then
						if dp.GetField("lp") != lpTypPozComm then
							lpTypPozComm = dp.GetField("lp")
							if (dp.GetField("flag")&0x1000) then
								TypPozComm =  dp.GetField("typi")&0x01
								if TypPozComm then
									strKomplet = using "%d",lpTypPozComm
									mvKomplet.Set(strKomplet,dp.GetField("id"))
								endif
							else
								dp2.SetKey("super")
								dp2.SetKeySeg("super",dp.GetField("super"))
								dp2.SetKeySeg("lp",dp.GetField("lp"))
								err2 = dp2.GetRec(EQ)
								while !err2 && dp2.GetField("super")==dp.GetField("super") && dp2.GetField("lp")==dp.GetField("lp") && !(dp2.GetField("flag")&0x1000)
									err2 = dp2.GetRec(NX)
								wend
								if dp2.GetField("super")==dp.GetField("super") && dp2.GetField("lp")==dp.GetField("lp") && (dp2.GetField("flag")&0x1000) then
									TypPozComm =  dp2.GetField("typi")&0x01
								else
									TypPozComm = 1
								endif
							endif
						endif
						if (dp.GetField("flag")&0x4000) then
							strKomplet = using "%d",lpTypPozComm
							if mvKomplet.Index(strKomplet) then
								mvKomplet.Del(strKomplet)
							endif							
						endif
						if (dp.GetField("flag")&0x4000) && (!(dp.GetField("typi")&0x01) != TypPozComm) then
							if dp.GetField("typi")&0x01 then
								dp.SetField("typi",dp.GetField("typi")^0x01)
							else
								dp.SetField("typi",dp.GetField("typi")|0x01)
							endif
							UpdateRecB(dp)
						endif
					else
						//tak jak bazowy
						idp = dp.GetField("idpozkoryg")
						if (dp.GetField("flag")&0x1000) && czyKorDoArch then
							strKomplet = using "%d",dp.GetField("lp")
							mvKomplet.Set(strKomplet,dp.GetField("id"))
						else
						do
							dp2.SetKey("id")
							dp2.SetKeySeg("id",idp)
							err2 = dp2.GetRec(EQ)
							if !err2 && dp2.GetField("idpozkoryg") then
								idp = dp2.GetField("idpozkoryg")
							else
								idp = dp2.GetField("typi")&0x01
							endif
						loop while !err2 && dp2.GetField("idpozkoryg")
						if !err2 && (dp.GetField("typi")&0x01) != idp then
							if dp.GetField("typi")&0x01 then
								dp.SetField("typi",dp.GetField("typi")^0x01)
							else
								dp.SetField("typi",dp.GetField("typi")|0x01)
							endif
							UpdateRecB(dp)
						endif
						endif						
					endif
				else
					if dp.GetField("typi")&0x01 then
						dp.SetField("typi",dp.GetField("typi")^0x01)
						UpdateRecB(dp)
					endif
				endif
			else
				if !(dp.GetField("typi")&0x01) then
					dp.SetField("typi",dp.GetField("typi")|0x01)
					UpdateRecB(dp)
				endif
			endif

			if !(dp.GetField("typi") & 1) || (CzyFaktWew(dk.GetField("subtypi")) && !(dp.GetField("flag")&0x1000)) then				// 1=komplet lub anulowana
				CheckWalBrutto(dk, dp)
				netto+=dp.GetField("wartNetto")
				vat+=dp.GetField("wartVat")
				walNetto+=dp.GetField("walNetto")
				walBrutto+=dp.GetField("walBrutto")
				wartPrzychod+=dp.GetField("wartPrzychod")
			endif

#ifdef HMHL
			if (!CzyFaktWew(dk.GetField("subtypi")) && (dp.GetField("magazyn")!=dk.GetField("magazyn"))) then
				if TextOutAndAsk3(12,(using "Nie zgadza si magazyn pozycji '%s' dokumentu '%s'",dp.GetField("kod"),dk.GetField("kod"))) then
					dp.SetField("magazyn",dk.GetField("magazyn"))
					UpdateRecB(dp)
				else
					TextOut(sNoRepair)
				endif
			endif
#endif

			sRej = (using "%d",dp.GetField("rejestrVati"))
			lSuper = iif(dp.GetField("flag")&0x0100,10700,10500)  // 10700 dla zak 10500 dla sprz
			xt.SetKey("super")
			xt.SetKeySeg("super", lSuper)
			xt.SetKeySeg("kod", "")
			err = xt.GetRec(GE)
			while !err && xt.GetKeySeg("super") == lSuper					
				sTmp = Using "%l", xt.GetField("long")							
				if sRej == sTmp then
					exit // OK wyjcie z ptli
				endif
				err = xt.GetRec(NX)
			wend

			if !(dp.GetField("typi")&0x10) then
				if ((dp.GetField("rejestrVati")!= dk.GetField("rejestrVati")) && (sRej != sTmp)) || dp.GetField("data")!= dk.GetField("data") || dp.GetField("datarej")!= dk.GetField("datarej")then 
					dp.SetField("data",dk.GetField("data"))
					if ((dp.GetField("rejestrVati")!= dk.GetField("rejestrVati")) && (sRej != sTmp))  then dp.SetField("rejestrVati",dk.GetField("rejestrVati"))
					dp.SetField("datarej",dk.GetField("datarej"))

					if dp.Update() then
						TextOut(using "Nie zgadza si rejestr VAT oraz data na pozycji '%s' dokumentu '%s' - NIE NAPRAWIONO - bd zapisu do bazy DP\n",dp.GetField("kod"),dk.GetField("kod"))
					else
						TextOut(using "Nie zgadza si rejestr VAT oraz data na pozycji '%s' dokumentu '%s' - NAPRAWIONO\n",dp.GetField("kod"),dk.GetField("kod"))
					endif
				endif
			endif
			if dp.GetField("subtypi")!=dk.GetField("typi") then
				if TextOutAndAsk3(8,using "Pozycja '%s' id=%l dokumentu '%s' ma subtyp niezgodny z typem dokumentu",dp.GetField("kod"),dp.GetField("id"),dk.GetField("kod")) then
					dp.SetField("subtypi",dk.GetField("typi"))
					UpdateRecB(dp)
				else
					TextOut(sNoRepair)
				endif
			endif
			// czy istnieje dok zamwienia
			if dp.GetField("idhandl") then
				if bp.GetRecById(dp.GetField("idhandl")) then
					if TextOutAndAsk3(16,using "Pozycja '%s' id=%l wskazuje na nieistniejc pozycj dokumentu zamwienia",dp.GetField("kod"),dp.GetField("id")) then
						dp.SetField("idhandl",0)
						UpdateRecB(dp)
					else
						TextOut(sNoRepair)
					endif
				endif
			endif

			err=dp.GetRec(NX)
		wend
		if mRozlK.Size() then
			for i=1 to i>size(rRozlK)
				if sign(rRozlK(i).warttow,6) then
					if TextOutAndAsk(12,(using "Nie zgadza si warto pola 'wartTowaru' w pozycji id='%l'",rRozlK(i).id),". Czy naprawi") then	
						dp.GetRecById(rRozlK(i).id)
						dp.SetField("wartTowaru",dp.GetField("wartTowaru")+rRozlK(i).warttow)
						UpdateRecB(dp)
					else
						TextOut(sNoRepair)
					endif
				endif
				if sign(rRozlK(i).iloscdorozl,6) then
					if TextOutAndAsk(13,(using "Nie zgadza si warto pola 'iloscdorozl' w pozycji id='%l'",rRozlK(i).id),". Czy naprawi") then	
						dp.GetRecById(rRozlK(i).id)
						dp.SetField("iloscdorozl",dp.GetField("iloscdorozl")+rRozlK(i).iloscdorozl)
						UpdateRecB(dp)
					else
						TextOut(sNoRepair)
					endif
				endif
				//if CheckCenyKompletu(i) then
				//	TextOut(using "Wystepuje rznica miedzy cen w nagwku kompletu, a cen jego elementw skadowych. Pozycja nagowka: id='%l'",rRozlK(i).id)
				//endif
				if CheckWartosciKompletu(i) then
					TextOut(using "Wystepuje rznica miedzy wartosci w pozycji nagwka kompletu id='%l', a wartoci jego elementw skadowych."+lf,rRozlK(i).id)
				endif
			next i
		endif
		
						


		if idrenum then
			if TextOutAndAsk(1,(using "Pozycje dokumentu '%s' maj nieuporzdkowane numery",dk.GetField("kod")),". Czy uporzdkowa numery pozycji dokumentu") then
				Przenumeruj(idrenum,(using "%d",dk.GetField("subtypi")))
			else
				TextOut(sNoRepair)
			endif
		else
			while mvKomplet.Size()
				dp.GetRecById(mvKomplet.Get(mvKomplet.Size()))
				if !czyKorDoArch then 
					dp.SetField("typi",dp.GetField("typi")^0x01)
					UpdateRecB(dp)
				endif
				netto+=dp.GetField("wartNetto")
				vat+=dp.GetField("wartVat")
				walNetto+=dp.GetField("walNetto")
				walBrutto+=dp.GetField("walBrutto")
				wartPrzychod+=dp.GetField("wartPrzychod")
				mvKomplet.Del(mvKomplet.GetKey(mvKomplet.Size()))
			wend
		endif
		fKurs=dk.GetField("kurs")
		if !sign(fKurs,4) then fKurs=1
		nettodk=dk.GetField("netto")/fKurs
		vatdk=dk.GetField("vat")/fKurs
		netto/=fKurs
		vat/=fKurs
		walNettoDk=dk.GetField("walNetto")
		walBruttoDk=dk.GetField("walBrutto")
		wartPrzychodDk=dk.GetField("wartPrzychod")
		bylyFlag = 0

		if Sign(nettodk-netto,2)				then bylyFlag += 1
		if Sign(vatdk-vat,2)					then bylyFlag += 2
		if Sign(walNettoDk-walNetto,2)			then bylyFlag += 4
		if Sign(walBruttoDk-walBrutto,2)		then bylyFlag += 8
		if Sign(wartPrzychodDk-wartPrzychod,2)	then bylyFlag += 16

		if bylyFlag then
			byly = 1
			TextOut("Nie zgadza si warto")
			if bylyFlag&1 then
				TextOut(" NETTO")
			endif
			if bylyFlag&2 then 
				if bylyFlag&1 && bylyFlag >=4 then TextOut(",")
				if bylyFlag&1 && bylyFlag <4 then TextOut(" oraz")
				TextOut(" VAT")
			endif
			if bylyFlag&4 then 
				if bylyFlag&3 && bylyFlag >=8 then TextOut(",")
				if bylyFlag&3 && bylyFlag <8 then TextOut(" oraz")
				TextOut(" WALNETTO")
			endif
			if bylyFlag&8 then 
				if bylyFlag&7 && bylyFlag >=16 then TextOut(",")
				if bylyFlag&7 && bylyFlag <16 then TextOut(" oraz")
				TextOut(" WALBRUTTO")
			endif
			if bylyFlag&16 then 
				if bylyFlag&15 then TextOut(" oraz")
				TextOut(" WARTPRZYCHOD")
			endif

			TextOut(using " w dokumencie '%s'\n",dk.GetField("kod"))
		endif
	endif

	err=dk.GetRec(NX)
wend

StageSummary(3)

PopUp(1,"Sprawdzanie notatek do pozycji")
PopUp(2,"")
WriteStatusBar("Sprawdzanie notatek do pozycji")


if StageT(4) then

dp.SetKey("id")
nt.SetKey("id")
nt2.SetKey("super")
nt2.SetKeySeg("typi",16)
nt2.SetKeySeg("baza",18)
err=dp.GetRec(FS)
progress.Reset(dp.GetRecordCount())
while !err
	progress.NextOne()
  if dp.GetField("idlongname") then
		nt.SetKeySeg("id",dp.GetField("idlongname"))
    if nt.GetRec(EQ) || nt.GetField("typi")!=16 || nt.GetField("baza")!= 18 || nt.GetFIeld("super")!=dp.GetField("id") then
			nt2.SetKeySeg("super",dp.GetField("id"))
			id = 0
			if !nt2.GetRec(EQ) then id=nt2.GetField("id")
      if TextOutAndAsk3(9,(using "Pozycja '%s' id=%l ma niewaciwie powizan dug nazw",dp.GetField("kod"),dp.GetField("id"))) then
	 	    dp.SetField("idlongname",id)
  	 	  UpdateRecB(dp)
			else
				TextOut(sNoRepair)
			endif
		endif
  endif	
	err=dp.GetRec(NX)
wend

nt.SetKey("super")
nt.SetKeySeg("typi",16)
nt.SetKeySeg("baza",18)
dp.SetKey("id")
err=nt.GetRec(GE)
while !err && nt.GetField("typi")==16 && nt.GetField("baza")==18
	dp.SetKeySeg("id",nt.GetField("super"))
	if dp.GetRec(EQ) then
		if TextOutAndAsk3(10,(using "W bazie notatek znajduje si rekord o numerze %d odwoujcy si do nieistniejcej pozycji",nt.GetField("id"))) then
			DeleteRecB(nt)
		else
			TextOut(sNoRepair)
		endif
	else
		if dp.GetField("idlongname")!=nt.GetField("id") then
      if TextOutAndAsk3(11,(using "Pozycja '%s' id=%l ma niewaciwie powizan dug nazw",dp.GetField("kod"),dp.GetField("id"))) then
	 	    dp.SetField("idlongname",nt.GetField("id"))
  	 	  UpdateRecB(dp)
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
	err=nt.GetRec(NX)
wend

StageSummary(4)

endif	

TextOut("\nZakoczono.")

print using "\n\nPowysze podsumowanie zostao zapisane w katalogu %s do pliku %s\n",KatalogLog(),sFileName
if byly then
	TextOut("\nUWAGA!!! W wymienionych wyej dokumentach nie zgadza si suma wartoci NETTO, WALNETTO, WALBRUTTO, WARTPRZYCHOD lub VAT z pozycji dokumentw z wartoci zapisan w dokumencie.\n")
	TextOut("Prosz odszuka wymienione dokumenty w programie i porwna ich zawarto z wczeniejszymi wydrukami tych dokumentw.\nPo stwierdzeniu niezgodnoci z orginaem naley przej do edycji i poprawi wszystkie zauwaone bdy.")
endif

close

buf = IIF( GetVError() == 0 , "" , "warnings" )