//"diag_pn.sc","51pn : diagnostyka patnoci i rozrachunkw",12004,0,1.0.5,SYSTEM
//"Diagnostyka",12001,14,16
//
// 51pn : diagnostyka patnoci i rozrachunkw
// diag_pn.sc
/////////////////////////////


#ifdef HM
#define HMHL
#endif
#ifdef HL
#define HMHL
#endif
//rejestr naliczony FWZ
#define REJ_NAL_FWZ 103
#define TYPzzDKFW	0x97
///////////////////////////////////////////////////////////////////////////
// dokumenty sprzeday
#define ANUL    0
#define ARCH	2
#define PARANUL	3
#define FWS		116		//Faktura wewnetrzna sprzedaz
#define WKS		118		//Faktura korygujca wewntrzna (sprzeday)
//...
#ifdef HMHL
///////////////////////////////////////////////////////////////////////////
// dokumenty zakupu
#define FWZ		117		//Faktura wewnetrzna zakupu
#define WKZ		119		//Faktura korygujca wewntrzna (zakupu)
//...
#endif
Record InfoRL
	float wartosc
	float wartrozl1
	float wartrozl2
int sub Zeruj()
	wartosc=wartrozl1=wartrozl2=0
endsub
endrec
InfoRL wynikRL
	 
int sub CzySprawdzacRek( BaseAll b )
	int iTyp = b.GetField("typi")

	CzySprawdzacRek = 1
	if iTyp != 0 && iTyp != 202 then
		CzySprawdzacRek=0
	else
		select case b.GetField("subtypi")
			case ANUL, ARCH, PARANUL, FWS, WKS
				CzySprawdzacRek=0
#ifdef HMHL
			case FWZ, WKZ
				CzySprawdzacRek=0
#endif // HM
		endselect
	endif
endsub
string sFirma = KatalogFirmy() + "firma."+firma.code
string sNrArch = GetIni("Firma", "Ilo archiwizacji:", sFirma)
string 	sDataPrzeciecia = Mid( GetIni( "Archiwizacja Nr " + sNrArch, "Data Przecicia:", sFirma ) ,1,10)
string NAZWA_PLIKU = "DIAG_PN.TXT"
string sRaportDescription
#include "Diagnostyka - funkcje"
UsunRekord_0("PN")


sDialogTitle += "patnoci"
StageAddDesc("Raport porwnuje dane zapisane w bazie patnoci z danymi zapisanymi w")
StageAddDesc("dokumentach, informuje o ewentualnych rozbienociach, sprawdza obecno")
StageAddDesc("i poprawno raportw kasowych oraz odtwarza je na podstawie dokumentw")
StageAddDesc("patnoci.")
if (firma.code == "HM") || (firma.code == "HL") then
	StageAddStage("Sprawdzenie integralnoci bazy PN oraz IPN")
else
	StageAddStage("X")
endif
StageAddStage("Sprawdzanie rozlicze")
StageAddStage("Sprawdzanie zapisw patnoci/rozrachunkw")
StageAddStage("Sprawdzanie kwot w dokumentach")
StageAddStage("Sprawdzanie raportw rejestrw pieninych")
StageAddStage("Zliczanie dokumentw w rejestrach")
ChooseStages(400)

BaseAll pn
BaseAll pn2
BaseAll pn3
BaseDK  dkb
BaseAll dk2
BaseAll dk
BaseAll xt
BaseAll kh
BaseAll rp
BaseAll sr

BaseDP dp
BAseDP dp2
BaseZZ zz

BaseAll xt4
String  kodRejestru

int err2,stGw,bylyGw,typ,pierwszy,stanVal,jestDok,ans, subtyp
int rl,rl2, ipn
long kh1, kh2, dkid
long khid
string khKod
long nextPnId,nextSeriaNr,lTemp,rejestr
float stan,stanRozr,kwotaRZ
float fKwota,kwotaRozl,kwotaDok,kwotaRozlWal
string sBezNapr,sTemp, sDataTmp
float fTemp,fKwotaZmiana,fKwotaZmianaWal
MapValue mPlatnSubtyp

// dodany ze wzgldu na rozmiar pliku diag_pn.sc
#include "Diagnostyka patnoci i rozrachunkw - include"



//main
stGw = CopyFont ( "tytu", 1, 50 )

OpenBaseB(dk,"DK")
OpenBaseB(dk2,"DK")
OpenBaseB(pn,"PN")
OpenBaseB(pn2,"PN")
OpenBaseB(pn3,"PN")
rl=OpenBase("rl")
rl2=OpenBase("rl")
OpenBaseB(xt,"XT")
OpenBaseB(xt4,"XT")
OpenBaseB(kh,"KH")
OpenBaseB(rp,"RP")
OpenBaseB(sr,"SR")
zz.Open()
zz.SetKey("cross1")
dp2.Open()
TextOut("Podsumowanie sprawdzania poprawnoci bazy patnoci\n\n")

mPlatnSubtyp.Type(STRING)
xt.SetKey("super")
xt.SetKeySeg("super",7006)
xt.SetKeySeg("kod","")
err=xt.GetRec(GE)
while !err && xt.GetField("super")==7006
	mPlatnSubtyp.Set(xt.GetField("kod"),(using "%d",xt.GetField("long")))
	err=xt.GetRec(NX)
wend

if StageT(1) then SprawdzIPN()
StageSummary(1)

if StageT(2) then

// przegldanie bazy RL
PopUp(1,"Sprawdzanie rozlicze")
SetKey(rl,"id")
pn.SetKey("id")
pn2.SetKey("id")
dk.SetKey("seria")
xt.SetKey("id")
kh.SetKey("id")
progress.Reset(GetRecordCount(rl))
err=GetRec(rl,FS)

while !err
	progress.NextOne()

	kh1 = 0
	kh2 = 0
	if GetField(rl,"id1") then 
		kh1 = Sprawdz("1","2")
	endif
	
	if (kh1 != -1) then //nie usunito
	
		if GetField(rl,"id2") then 
			kh2 = Sprawdz("2","1")
		endif
	
		if (kh1 != -1) then//nie usunito
		
			if kh1 && kh2 && kh1 != kh2 then
				if TextOutAndAsk(20,(using "Rozliczenie o id=%l czy rozrachunki dla rnych kontrahentw. Program usunie to rozliczenie.",GetField(rl,"id")),sAskRepair ) then
					pn.SetKey("id")
					pn.SetKeySeg("id",GetField(rl,"id1"))
					if !pn.GetRec(EQ) then //zobowiazanie lub wplata

						if (pn.GetField("typi")&0x2) then //wplata						
							pn.SetField("kwotarozl",pn.GetField("kwotarozl")-GetField(rl,"wartosc"))
							pn.SetField("kwotarozlwal",pn.GetField("kwotarozlwal")-GetField(rl,"wartrozl1"))
						else //zobowiazanie
							pn.SetField("kwotarozl",pn.GetField("kwotarozl")+GetField(rl,"wartosc"))
							pn.SetField("kwotarozlwal",pn.GetField("kwotarozlwal")+GetField(rl,"wartrozl1"))
						endif

						if !(pn.GetField("typi")&0x2) then  //aktualizacja kwoty rozrachunku i stanu naleznosci rejestru
							sTemp = pn.GetField("waluta")
							if(""==sTemp) then sTemp = "PLN"
							fKwotaZmiana = pn.GetField("kwota")
							fKwotaZmianaWal= pn.GetField("kwotawal")
							//--
							pn.SetField("kwotawal",pn.GetField("kwotawal")-GetField(rl,"wartrozl1"))
							pn.SetField("kwota",round(pn.GetField("kwotawal")*IIF(sign(pn.GetField("kurs"),4),pn.GetField("kurs"),1),2))
							//--
							fKwotaZmiana = pn.GetField("kwota") - fKwotaZmiana
							fKwotaZmianaWal = pn.GetField("kwotawal") - fKwotaZmianaWal
							sr.SetKey("salda")
							sr.SetKeySeg("idrj",pn.GetField("rejestr"))
							sr.SetKeySeg("waluta",sTemp)
							if !sr.GetRec(EQ) then	
								sr.SetField("stannl",fKwotaZmiana + sr.GetField("stannl"))
								sr.SetField("stannlwal",fKwotaZmianaWal + sr.GetField("stannlwal"))
								if 0.0==sr.GetField("stannl") && 0.0==sr.GetField("stanpl") && 0.0==sr.GetField("stannlwal") && 0.0==sr.GetField("stanplwal") then
									DeleteRecB(sr)
								else
									UpdateRecB(sr)
								endif
							else
								sr.Clear()
								sr.SetField("idrj",pn.GetField("rejestr"))
								sr.SetField("waluta",sTemp)
								sr.SetField("stanpl",0.0)
								sr.SetField("stannl",fKwotaZmiana)
								sr.SetField("stanplwal",0.0)
								sr.SetField("stannlwal",fKwotaZmianaWal)
								xt4.SetKey("id")
								xt4.SetKeySeg("id", pn.GetField("rejestr"))
								kodRejestru = IIF(xt4.GetRec(EQ), "", "'" + xt4.GetField("kod") + "'") 
								If TextOutAndAsk(xt.GetField("klient")+6,("Brak salda rejestru " + kodRejestru),"\nCzy naprawi ?") then
									InsertRecB(sr)
								EndIf
							endif
						endif
						if pn.Getfield("typi")&0x01 then pn.SetField("typi",pn.GetField("typi")^0x1)
						UpdateRecB(pn)
						if !(pn.GetField("typi")&0x2) then
							dk.SetKey("id")
							dk.SetKeySeg("id",pn.GetField("dkid"))
							if !dk.GetRec(EQ) then
								dk.SetField("wplaty",dk.GetField("wplaty")+GetField(rl,"wartosc"))
								dk.SetField("oki",0)
								UpdateRecB(dk)
							endif
						endif
					endif
					pn.SetKey("id")
					pn.SetKeySeg("id",GetField(rl,"id2"))
					if !pn.GetRec(EQ) then //naleznosc lub wyplata
						if (pn.GetField("typi")&0x2) then //wyplata
							pn.SetField("kwotarozl",pn.GetField("kwotarozl")+GetField(rl,"wartosc"))
							pn.SetField("kwotarozlwal",pn.GetField("kwotarozlwal")+GetField(rl,"wartrozl2"))
						else		//naleznosc
							pn.SetField("kwotarozl",pn.GetField("kwotarozl")-GetField(rl,"wartosc"))
							pn.SetField("kwotarozlwal",pn.GetField("kwotarozlwal")-GetField(rl,"wartrozl2"))
						endif

						if !(pn.GetField("typi")&0x2) then //aktualizacja kwoty rozrachunku i stanu naleznosci rejestru
							sTemp = pn.GetField("waluta")
							if(""==sTemp) then sTemp = "PLN"
							fKwotaZmiana = pn.GetField("kwota")
							fKwotaZmianaWal= pn.GetField("kwotawal")
							//--	
							pn.SetField("kwotawal",pn.GetField("kwotawal")+GetField(rl,"wartrozl2"))
							pn.SetField("kwota",round(pn.GetField("kwotawal")*IIF(sign(pn.GetField("kurs"),4),pn.GetField("kurs"),1),2))
							//--	
							fKwotaZmiana = pn.GetField("kwota") - fKwotaZmiana
							fKwotaZmianaWal = pn.GetField("kwotawal") - fKwotaZmianaWal
							sr.SetKey("salda")
							sr.SetKeySeg("idrj",pn.GetField("rejestr"))
							sr.SetKeySeg("waluta",sTemp)
							if !sr.GetRec(EQ) then	
								sr.SetField("stannl",fKwotaZmiana + sr.GetField("stannl"))
								sr.SetField("stannlwal",fKwotaZmianaWal + sr.GetField("stannlwal"))
								if 0.0==sr.GetField("stannl") && 0.0==sr.GetField("stanpl") && 0.0==sr.GetField("stannlwal") && 0.0==sr.GetField("stanplwal") then
									DeleteRecB(sr)
								else
									UpdateRecB(sr)
								endif
							else
								sr.Clear()
								sr.SetField("idrj",pn.GetField("rejestr"))
								sr.SetField("waluta",sTemp)
								sr.SetField("stanpl",0.0)
								sr.SetField("stannl",fKwotaZmiana)
								sr.SetField("stanplwal",0.0)
								sr.SetField("stannlwal",fKwotaZmianaWal)
								xt4.SetKey("id")
								xt4.SetKeySeg("id", pn.GetField("rejestr"))
								kodRejestru = IIF(xt4.GetRec(EQ), "", "'" + xt4.GetField("kod") + "'") 
								If TextOutAndAsk(xt.GetField("klient")+6,("Brak salda rejestru " + kodRejestru),"\nCzy naprawi ?") then
									InsertRecB(sr)
								EndIf
							endif
						endif
						if pn.Getfield("typi")&0x01 then pn.SetField("typi",pn.GetField("typi")^0x1)
						UpdateRecB(pn)
						if !(pn.GetField("typi")&0x2) then
							dk.SetKey("id")
							dk.SetKeySeg("id",pn.GetField("dkid"))
							if !dk.GetRec(EQ) then
								dk.SetField("wplaty",dk.GetField("wplaty")-GetField(rl,"wartosc"))
								dk.SetField("oki",0)
								UpdateRecB(dk)
							endif
						endif
					endif
					DelRec(rl)
				endif	
			endif
		endif
	endif

	err=GetRec(rl,NX)
wend

StageSummary(2)

endif //stage

if StageT(3) then

PopUp(1,"Sprawdzanie zapisw patnoci/rozrachunkw")
PopUp(2," w dokumencie:")

pn.SetKey("id")
nextPnId=1
if !pn.GetRec(LS) then nextPnId=pn.GetKeySeg("id")+1


// przegldanie dokumentw handlowych i sprawdzanie, czy s rekordy rozrachunkw dla nich
dp.Open()
dp.SetKey("super")
pn.SetKey("dkid")
pn2.SetKey("seria")
dk.SetKey("id")
err=dk.GetRec(FS)
progress.Reset(dk.GetRecordCount())
while !err
	progress.NextOne()
	if CzySprawdzacRek(dk) then
		PopUp(3,dk.GetField("kod"))
		pn.SetKeySeg("dkid",dk.GetKeySeg("id"))
		if pn.GetRec(EQ) then
			if dk.GetField("subtypi") > 2 then
				// czy moe jest tylko le podczepiony pod ze dkid -> sprawdzam po kluczu seria
				pn2.SetKeySeg("seria",dk.GetField("seria"))
				pn2.SetKeySeg("okres",dk.GetField("okres"))
				pn2.SetKeySeg("serianr",dk.GetField("serianr"))
				if pn2.GetRec(EQ) then
					// nie ma rekordu w bazie PN -> odtwarzam
					if TextOutAndAsk(8,(using "Brak danych o nalenociach dla dokumentu '%s'",dk.GetField("kod")),sAskRepair) then
						pn.Clear()
						PrzepiszPola()
						pn.SetField("kwotarozlwal",round(pn.GetField("kwotarozl")/pn.GetField("kurs"),2))
						pn.SetField("kwotawal",pn.GetField("kwotawal")-pn.GetField("kwotarozlwal"))
						pn.SetField("kwota",round(pn.GEtField("kwotawal")*pn.GetField("kurs"),2))
						pn.SetField("id",nextPnId)
						nextPnId+=1
						InsertRecB(pn)
					else
						TextOut(sNoRepair)
					endif
				else
					// jest ze zym dowizaniem w dkid
					if TextOutAndAsk(9,(using "Rekord patnoci w bazie PN o id=%l jest nieprawidowo dowizany do rekordu dokumentu '%s'", pn2.GetField("id"), dk.GetField("kod")),sAskRepair) then
						pn2.SetField("dkid",dk.GetField("id"))
						UpdateRecB(pn2)
					else
						TextOut(sNoRepair)
					endif
					SprawdzWartRozr()
				endif
			endif
		else
			if pn.GetField("seria") != dk.GetField("seria") || pn.GetField("okres") != dk.GetField("okres") || pn.GetField("serianr") != dk.GetField("serianr") || pn.GetField("dzial") != dk.GetField("dzial") then
					//pn.GetField("kod") != dk.GetField("kod") then

				pn2.SetKeySeg("seria",dk.GetField("seria"))
				pn2.SetKeySeg("dzial",dk.GetField("dzial"))
				pn2.SetKeySeg("okres",dk.GetField("okres"))
				pn2.SetKeySeg("serianr",dk.GetField("serianr"))

				if pn2.GetRec(EQ) then	//sprawdzamy czy istnieje rozrachunek o takim samym numerze
					if TextOutAndAsk(14,(using "Rozrachunek o id=%l i kodzie '%s' ma niepoprawny numer w serii - inny ni dokument handlowy o id=%l i kodzie '%s'",pn.GetField("id"), pn.GetField("kod"), dk.GetField("id"), dk.GetField("kod")),sAskRepair) then
						pn.SetField("seria", dk.GetField("seria"))
						pn.SetField("okres", dk.GetField("okres"))
						pn.SetField("serianr", dk.GetField("serianr"))
						pn.SetField("dzial", dk.GetField("dzial"))
						UpdateRecB(pn)
					else
						TextOut(sNoRepair)
					endif
				else
					//TextOut(using "Dokument handlowy o id=%l i kodzie '%s' ma taki sam numer w serii jak rozrachunek o id=%l i kodzie '%s' ale dokumenty te nie s ze sob zwizane.",dk.GetField("id"), dk.GetField("kod"), pn2.GetField("id"), pn2.GetField("kod"))
				endif
			endif
			if dk.GetField("subtypi") > 1 then	//do dok w archiwum moze istnie rozrachunek
				SprawdzWartRozr()
			else
				if TextOutAndAsk(16,(using "Do anulowanego dokumentu '%s' istnieje rozrachunek. Czy unsun rozrachunek",dk.GetField("kod")),sAskRepair) then
					DeleteRec(pn, "PN")
				endif
			endif
		endif
	endif
	err=dk.GetRec(NX)
wend
dp.Close()

StageSummary(3)

endif	// stage

// sprawdzenie, czy zgadza si kwota w rekordzie PN z sum kwot w RL lub/i w dokumencie
PopUp(1,"Sprawdzanie kwot w dokumentach patnoci")
PopUp(2,"")
PopUp(3,"")
pn.SetKey("id")
pn2.SetKey("id")
pn.SetKeySeg("id",0)
dk.SetKey("id")
err=pn.GetRec(FS)
progress.Reset(pn.GetRecordCount())

if !StageT(4) then err=1

while !err
	progress.NextOne()

	PopUp(2,pn.GetField("kod"))
	if !(pn.GetField("flag")&16384) then
		typ=pn.GetField("typi")
		buf=using "%d",pn.GetField("wyplatai")
		if  ( typ&2 && buf=="0" ) || ( !(typ&2) && buf=="1" ) then
			fKwota=ZliczKwote("1","2",pn.GetField("id"))
		else
			fKwota=ZliczKwote("2","1",pn.GetField("id"))
		endif
		jestDok=0
		if pn.GetField("dkid") then
			dkid = pn.GetField("dkid")
			if pn.GetField("flag")&0x8000 then
				if dkid < 0 then dkid = -dkid

				err = pn2.GetRecById(dkid)
			else
				err = dkb.GetRecById(dkid)
			endif
			if err then
				if TextOutAndAsk(10,(using "Rekord patnoci '%s' doczony jest do dokumentu, ktry nie istnieje",pn.GetField("kod")),". Uruchom raport diagnostyczny dla bazy dokumentw lub wcinij 'Napraw' aby platno nie bya powizana z adnym rekordem.") then
					pn.SetField("dkid",0)
					UpdateRecB(pn)
				else
					TextOut(sNoRepair)
				endif
			else
				jestDok=1
				kwotaDok=dkb.GetField("wplaty")
			endif
		endif
		kwotarozl = pn.GetField("kwotarozl")
		kwotarozlWal = pn.GetField("kwotarozlWal")
		if pn.GetField("wyplatai")==1 then kwotarozl = -kwotarozl : kwotaDok = -kwotaDok:kwotarozlWal = -kwotarozlWal 
		if (!(pn.GetField("flag")&0x8000) && (Sign(fKwota-kwotaRozl) || Sign(wynikRL.wartRozl1-kwotarozlWal) || (jestDok && Sign(kwotaDok-kwotaRozl)) ) && !(pn.GetField("exp_fki")&0x20))then
			if Sign(fKwota-kwotaRozl) && jestDok && Sign(kwotaDok-kwotaRozl) then
				ans=TextOutAndAsk(11,(using"Nie zgadzaj si wartoci kwoty rozliczonej dokumentu '%s', odpowiadajcemu mu rekordowi bazy PN oraz rekordw bazy RL",pn.GetField("kod")),(using "\nwarto z dokumentu: %.2f\nwarto z rekordu PN: %.2f\nwarto z rekordw RL: %.2f\nCzy uy wartoci z rekordw RL?",kwotaDok,kwotarozl,fKwota))
			else
				if Sign(fKwota-kwotaRozl) then
					ans=TextOutAndAsk(12,(using"Nie zgadzaj si wartoci kwoty rozliczonej patnoci '%s' oraz rekordw bazy RL",pn.GetField("kod")),(using "\nwarto rozliczonej patnoci PN: %.2f\nwarto z rekordw RL: %.2f\nCzy uy wartoci z rekordw RL?",kwotaRozl,fKwota))
				else
					if jestDok && Sign(kwotaDok-kwotaRozl) then
						ans=TextOutAndAsk(13,(using"Nie zgadzaj si wartoci kwoty rozliczonej dokumentu '%s' oraz odpowiadajcemu mu rekordowi bazy PN",pn.GetField("kod")),(using "\nwarto z dokumentu: %.2f\nwarto z rekordu PN: %.2f\nCzy uy wartoci z rekordu PN?",kwotaDok,fKwota))
						if pn.GetField("wyplatai")==1 then fKwota=-fKwota
					else
						if Sign(wynikRL.wartRozl1-kwotarozlWal) then
							ans=TextOutAndAsk(12,(using"Nie zgadzaj si wartoci kwoty rozliczonej patnoci '%s' oraz rekordw bazy RL",pn.GetField("kod")),(using "\nwarto rozliczonej patnoci PN: %.2f %s\nwarto z rekordw RL: %.2f %s\nCzy uy wartoci z rekordw RL?",kwotaRozlWal,pn.GetField("waluta"),wynikRL.wartRozl1,pn.GetField("waluta")))
						endif
					endif
				endif
			endif
			if ans then
				if pn.GetField("wyplatai")==1 then fKwota=-fKwota:wynikRl.wartrozl1=-wynikRL.wartrozl1
				pn.SetField("kwotarozl",fKwota)
				pn.SetField("kwotarozlwal",wynikRL.wartrozl1)
				if jestDok then
					dkb.SetField("wplaty",fKwota)
					if dkb.Update() then
						if pn.Update() then
							TextOut(" -  NIE NAPRAWIONO - bd zapisu do bazu PN oraz DK\n")
						else
							TextOut(" - CZʌCIOWO NAPRAWIONO - wystpi bd zapisu do bazy DK\n")
						endif
					else
						UpdateRecB(pn)
					endif
				else
					UpdateRecB(pn)
				endif
			else
				TextOut(sNoRepair)
			endif
		endif

		if !(pn.GetField("exp_fki") & 0x20) then
			select case pn.GetField("typi")
			case 0,1
				if pn.GetField("subtypi") != 2 then
					if pn.GetField("dkid") && !dk.GetRecById(pn.GetField("dkid")) then
						kwotaRZ=DajWartoscRozr()
						if ((Sign(kwotaRZ)>0 && pn.GetField("wyplatai")) || (Sign(kwotaRZ)<0 && !pn.GetField("wyplatai"))) then
							if TextOutAndAsk2(21,(using "Nie zgadza si pole wyplatai rekordu rozrachunku dokumentu '%s'.",pn.GetFIeld("kod")),(" Czy naprawi?"),"(N&apraw:o)[&Nie naprawiaj:p](&Przerwij:a)") then
								pn.SetField("wyplatai",!pn.GetField("wyplatai"))
								UpdateRecB(pn)
							else
								TextOut(sNoRepair)
							endif
						endif
					endif
					if !pn.GetField("wyplatai") then
						sTemp="58" : buf ="naleno"
					else
						sTemp="59" : buf ="zobowizanie"
					endif
					if pn.GetField("subtypi")!=val(sTemp) then
						if TextOutAndAsk(17,(using "Rozrachunek '%s' id=%l ma niewaciwie okrelony subtyp",pn.GetField("kod"),pn.GetField("id")),(using ".\nCzy zapisa warto okrelajc ten rozrachunek jako %s ?",buf)) then
							pn.SetField("subtypi",val(sTemp))
							UpdateRecB(pn)
						else
							TextOut(sNoRepair)
						endif
					endif
					if (Sign(pn.GetField("kwota"))>0 && pn.GetField("wyplatai")) || (Sign(pn.GetField("kwota"))<0 && !pn.GetField("wyplatai")) then
						if TextOutAndAsk2(21,(using "Nie zgadza si znak wartoci pola kwota rekordu rozrachunku dokumentu '%s'.",pn.GetFIeld("kod")),(" Czy naprawi?"),"(N&apraw:o)[&Nie naprawiaj:p](&Przerwij:a)") then
							pn.SetField("kwota",-pn.GetField("kwota"))
							UpdateRecB(pn)
						else
							TextOut(sNoRepair)
						endif
					endif
					if (Sign(pn.GetField("kwotarozl"))>0 && pn.GetField("wyplatai")) || (Sign(pn.GetField("kwotarozl"))<0 && !pn.GetField("wyplatai")) then
						if TextOutAndAsk2(21,(using "Nie zgadza si znak wartoci pola kwotarozl rekordu rozrachunku dokumentu '%s'.",pn.GetFIeld("kod")),(" Czy naprawi?"),"(N&apraw:o)[&Nie naprawiaj:p](&Przerwij:a)") then
							pn.SetField("kwotarozl",-pn.GetField("kwotarozl"))
							UpdateRecB(pn)
						else
							TextOut(sNoRepair)
						endif
					endif
					if (Sign(pn.GetField("kwotawal"))>0 && pn.GetField("wyplatai")) || (Sign(pn.GetField("kwotawal"))<0 && !pn.GetField("wyplatai")) then
						if TextOutAndAsk2(21,(using "Nie zgadza si znak wartoci pola kwotawal rekordu rozrachunku dokumentu '%s'.",pn.GetFIeld("kod")),(" Czy naprawi?"),"(N&apraw:o)[&Nie naprawiaj:p](&Przerwij:a)") then
							pn.SetField("kwotawal",-pn.GetField("kwotawal"))
							UpdateRecB(pn)
						else
							TextOut(sNoRepair)
						endif
					endif
					if (Sign(pn.GetField("kwotarozlwal"))>0 && pn.GetField("wyplatai")) || (Sign(pn.GetField("kwotarozlwal"))<0 && !pn.GetField("wyplatai")) then
						if TextOutAndAsk2(21,(using "Nie zgadza si znak wartoci pola kwotarozlwal rekordu rozrachunku dokumentu '%s'.",pn.GetFIeld("kod")),(" Czy naprawi?"),"(N&apraw:o)[&Nie naprawiaj:p](&Przerwij:a)") then
							pn.SetField("kwotarozlwal",-pn.GetField("kwotarozlwal"))
							UpdateRecB(pn)
						else
							TextOut(sNoRepair)
						endif
					endif
				endif
			case 2,3
				if mPlatnSubtyp.Index( pn.GetFIeld("typdk") ) then
					if mPlatnSubtyp.Get(pn.GetField("typdk"))!=(using "%d",pn.GetField("subtypi")) then
						if TextOutAndAsk(18, (using"Patno '%s' id=%l ma niewaciwie okrelony subtyp",pn.GetField("kod"),pn.GetField("id")),(using ".\nAktualna warto to '%d'\nPoprawna warto to '%s'\nCzy naprawi?",pn.GetField("subtypi"),mPlatnSubtyp.Get(pn.GetField("typdk")))) then
							pn.SetField("subtypi",val(mPlatnSubtyp.Get(pn.GetField("typdk"))))
							UpdateRecB(pn)					
						else
							TextOut(sNoRepair)
						endif
					endif
				else
					TextOut( using "Patno '%s' id=%l ma typ dokumentu '%s' nieokrelony w katalogu dokumentw patnoci\n",pn.GetField("kod"),pn.GetField("id"),pn.GetField("typdk") )
				endif
			endselect
		endif
		if (!pn.GetField("typi") && !Sign(pn.GetField("kwota"))) then
			pn.SetField("typi",1)
			UpdateRecB(pn)					
		endif
	endif
	err=pn.GetRec(NX)
wend

StageSummary(4)
// sprawdzanie patnoci i raportw
PopUp(1,"Sprawdzanie raportw rejestrw pieninych")
PopUp(2,"")
PopUp(3,"")

kh.SetKey("id")
xt.SetKey("super")
xt.SetKeySeg("super", 3400)

err=xt.GetRec(GE)

if !StageT(5) then err=1


int j
MapValue mwalutyAll
string sWalTmp
long temppn
long temprp
while !err && xt.GetKeySeg("super")==3400		// petla po wszystkich rejestrach

	PopUp(2,(using "rejestr '%s'",xt.GetField("kod")))

	// ustalenie nextSeriaNr
	sTemp=using "@%c%d",0xa0,xt.GetField("klient")
	rp.SetKey("seria")
	rp.SetKeySeg("seria",sTemp)
	nextSeriaNr=1
	err=rp.GetKey(GE)
	while !err && rp.GetKeySeg("seria")==sTemp
		nextSeriaNr=rp.GetKeySeg("serianr")+1
		err=rp.GetKey(NX)
	wend

	pn.SetKey("rejestr")	// po patnociach
	pn.SetKeySeg("rejestr",xt.GetField("klient"))
	pn.SetKeySeg("termin","")
	pn.SetKeySeg("typi",0)
	pn.SetKeySeg("id",0)
	rp.SetKey("data")		// po raportach wedug dat
	rp.SetKeySeg("idrj",xt.GetField("klient"))
	rp.SetKeySeg("data", "")
	
	rpierwszy.ClearValue()
	rstanval.ClearValue()

	err=pn.GetRec(GE)
	err2=rp.GetRec(GE)
	//SRRP//stan = stanRozr=0
	rStan.ClearValue()
	rStanRozr.ClearValue()
	while !(err && err2)
		//pomi gdy typ patnoci 0 lub kwota=0
		while !err && pn.GetField("rejestr")==xt.GetField("klient") && (pn.GetField("typi")==0 || pn.GetField("kwota")==0)
			//SRRP//stanRozr+=pn.GetField("kwota")
			rStanRozr.AddValue(pn.GetField("waluta"), pn.GetField("kwota"), pn.GetField("kwotawal"))
			err=pn.GetRec(NX)
		wend
		temppn = pn.GetField("id")
		temprp = rp.GetField("id")
		if !err && pn.GetField("rejestr")!=xt.GetField("klient") then err=1
		if !err2 && (rp.GetField("idrj")!=xt.GetField("klient"))then err2=1
		if !(err && err2) then
			// jest raport albo patno
			if !err then PopUp(3,pn.GetField("termin"))
			if !(err || err2) then
				// jest raport i patno
				if pn.GetField("termin")==rp.GetField("data")then
					// z tego samego dnia -> sprawd
					ZbierzKwotyPlatnosci()
					SprawdzRaporty()
				else	
					if pn.GetField("termin")<rp.GetField("data") then
						// wypad raport dla tych patnoci
						sDataTmp = pn.GetField("termin")
						ZbierzKwotyPlatnosci()
						OdtworzRaporty(sDataTmp)
					else
						wypadly_platnosci()
					endif
				endif
			else
				if err then
					// jest tylko raport
					wypadly_platnosci()
				else
					sDataTmp = pn.GetField("termin")
					// sa tylko patnoci
					ZbierzKwotyPlatnosci()
					OdtworzRaporty(sDataTmp)
				endif
			endif
		endif
	wend
	sr.SetKey("salda")
	kh.SetKeySeg("id",xt.GetField("klient"))
	if kh.GetRec(EQ) then
		TextOutAskOkEnd(16, using "Brak rekordu w bazie KH dla rejestru '%s'. Uruchom raport diagnostyczny dla bazy KH",xt.GetField("kod"))
	else
		mWalutyAll.Clear()
		mWalutyAll.Type(int)
		
		for j = 1 to j > rStan.mKwotaPln.Size()
			mWalutyAll.Set(rStan.mKwotaPln.GetKey(j),0)
		next j
		for j = 1 to j > rStanRozr.mKwotaPln.Size()
			mWalutyAll.Set(rStanRozr.mKwotaPln.GetKey(j),0)
		next j
		for j = 1 to j > mWalutyAll.Size()
			//wczytanie Salda Rejestru:
			sWalTmp = mWalutyAll.GetKey(j)
			sr.SetKeySeg("idrj", xt.GetField("klient"))
			sr.SetKeySeg("waluta", sWalTmp)
			if !sr.GetRec(EQ) then
				// jeli nie byo adnego raportu to w saldach jest kwota pocztkowa 
				if(rpierwszy.IsWalutaExist(sWalTmp)) then
					if !rStan.IsEqualPln(sWalTmp, sr.GetField("stanpl")) || !rStan.IsEqualWal(sWalTmp, sr.GetField("stanplwal")) then
						if TextOutAndAsk(xt.GetField("klient")+2,(using"Nie zgadza si aktualna warto stanu patnoci rejestru '%s'",xt.GetField("kod")),".\nCzy skorygowa raporty kasowe na podstawie aktualnego stanu rejestru?") then
							UstawRaporty(sr.GetField("stanpl"), sr.GetField("stanplwal"), sWalTmp)
						else
							TextOut(sNoRepair)
							sTemp=""
							if !rStanVal.IsWalutaExist(sWalTmp) then sTemp = "\nUWAGA: Nowa warto moe nie by poprawna ze wzgldu na nieodtworzone raporty"
							if TextOutAndAsk(xt.GetField("klient"),(using"Nie zgadza si aktualna warto stanu oraz stan walutowy patnoci rejestru '%s'",xt.GetField("kod")),(using "\nstan - jest: %.2f   powinno by: %.2f\nstan w walucie - jest: %.2f   powinno by: %.2f\nCzy naprawi?",sr.GetField("stanpl"),rstan.GetPln(sWalTmp),sr.GetField("stanplwal"),rstan.GetWal(sWalTmp))) then
								sr.SetField("stanpl",rstan.Getpln(sWalTmp))
								sr.SetField("stanplwal",rstan.GetWal(sWalTmp))
								UpdateRecB(sr)
							else
								TextOut(sNoRepair)
							endif
						endif
					endif					
				endif	
				// nie ma stanu pocztkowego rozrachunkw -> sprawdzamy nawet przy braku raportw
				if !rStanRozr.IsEqualPln(sWalTmp, sr.GetField("stannl")) || !rStanRozr.IsEqualWal(sWalTmp, sr.GetField("stannlwal")) then
					sTemp=""
					if !rStanVal.IsWalutaExist(sWalTmp) then sTemp = "\nUWAGA: Nowa warto moe nie by poprawna ze wzgldu na nieodtworzone raporty"
					if TextOutAndAsk(xt.GetField("klient")+1,(using"Nie zgadza si aktualna warto stanu oraz stanu walutowego rozrachunkw rejestru '%s'",xt.GetField("kod")),(using "\nstan - jest: %.2f   powinno by: %.2f\nstan w walucie - jest: %.2f   powinno by: %.2f\nCzy naprawi?",sr.GetField("stannl"),rstanRozr.GetPln(sWalTmp),sr.GetField("stannlwal"),rstanRozr.GetWal(sWalTmp))) then
						sr.SetField("stannl",rstanRozr.Getpln(sWalTmp))
						sr.SetField("stannlwal",rstanRozr.GetWal(sWalTmp))
						UpdateRecB(sr)
					else
						TextOut(sNoRepair)
					endif
				endif					
			
			else
				//brak rekordu salda - odtwarzamy
				sr.Clear()
				sr.SetField("idrj", xt.GetField("klient"))
				sr.SetField("stanpl", rstan.GetPln(sWalTmp))
				sr.SetField("stanplwal", rstan.GetWal(sWalTmp))
				sr.SetField("stannl", rStanRozr.GetPln(sWalTmp))
				sr.SetField("stannlwal", rStanRozr.GetWal(sWalTmp))
				sr.SetField("waluta", sWalTmp)
				xt4.SetKey("id")
				xt4.SetKeySeg("id", xt.GetField("klient"))
				kodRejestru = IIF(xt4.GetRec(EQ), "", "'" + xt4.GetField("kod") + "'") 
				If TextOutAndAsk(xt.GetField("klient")+6,("Brak salda rejestru " + kodRejestru),"\nCzy naprawi ?") then
					InsertRecB(sr)
				EndIf
			endif	
		next j	
	endif
	err=xt.GetRec(NX)
wend

StageSummary(5)

// uaktualnienie pl 'zawarto' w rejestrach pieninych w bazie XT

PopUp(1,"Zliczanie dokumentw w rejestrach pieninych")
PopUp(2,"")
PopUp(3,"")

xt.SetKey("kod")
xt.SetKeySeg("typi",8)

err=xt.GetRec(GE)

if !StageT(6) then err=1

while !err && xt.GetKeySeg("typi")==8		// petla po wszystkich rejestrach
	pn.SetKey("rejestr")
	rejestr=xt.GetField("id")
	pn.SetKeySeg("rejestr",rejestr)
	lTemp=0
	err=pn.GetKey(GE)
	while !err && pn.GetKeySeg("rejestr")==rejestr
		lTemp+=1
		err=pn.GetKey(NX)
	wend
	if xt.GetField("zawartosc")!=lTemp then
		xt.SetField("zawartosc",lTemp)
		if xt.Update() then
			TextOut(using "Nie poprawiono iloci dokumentw w rejestrze '%s' - Bd zapisu do bazy XT.\n",xt.GetField("kod"))
		else
			TextOut(using "Poprawiono iloci dokumentw w rejestrze '%s'.\n",xt.GetField("kod"))
		endif
	endif
	err=xt.GetRec(NX)
wend

StageSummary(6)

TextOut("\nZakoczono.")



ShowFileInfo()

buf = IIF( GetVError() == 0 , "" , "warnings" )