//"diag_pn.sci","Diagnostyka patnoci i rozrachunkw - include",12001,0,1.0.1,SYSTEM
//"System",2400,14,62
//////////////////////////////////////////////////////////////////////
// Diagnostyka patnoci i rozrachunkw - include
// diag_pn.sci
// 
// dodany ze wzgldu na rozmiar pliku diag_pn.sc

record InfoKwota
	MapValue mkwotaPln
	MapValue mkwotaWal
	MapValue mCheckList
	float sumaPln
	
	int sub ClearValue()
		mkwotaPln.Clear()
		mkwotaPln.Type(float)
		mkwotaWal.Clear()
		mkwotaWal.Type(float)
		sumaPln = 0.0
		mCheckList.Clear()
		mCheckList.Type(int)
	endsub 	

	int sub SetCheckList()
		int i
		for i = 1 to i>mkwotaPln.Size()
			mChecklist.Set(mKwotaPln.GetKey(i), 0)
		next i
	endsub

	int sub RemoveFromCheckList(string waluta)
		if waluta == "" then waluta = "PLN"
		if ( mChecklist.Index(waluta)) then mChecklist.Del(waluta)
	endsub

	int sub SetValue(string waluta, float kwotaPln, float kwotaWal)
		if waluta == "" then waluta = "PLN"
		mkwotaPln.Set(waluta, kwotaPln)
		mkwotaWal.Set(waluta, kwotaWal) 
	endsub
	
	int sub RemoveValue(string waluta)
		if waluta == "" then waluta = "PLN"
		if(mkwotaPln.Index(waluta)) then
			mkwotapln.Del(waluta)
			mkwotawal.Del(waluta)
		endif	
	endsub


	int sub AddValue(string waluta, float kwotaPln, float kwotaWal)
		if waluta == "" then waluta = "PLN"
		int idx = mkwotaPln.Index(waluta)
		if(!idx) then
			mkwotaPln.Set(waluta, kwotaPln)
			mkwotaWal.Set(waluta, kwotaWal) 
		else
			mKwotaPln.Set(idx, mKwotaPln.Get(idx)+kwotaPln)
			mKwotaWal.Set(idx, mKwotaWal.Get(idx)+kwotaWal)
		endif 
	endsub

	int sub IsWalutaExist(string waluta)
		if waluta == "" then waluta = "PLN"
		IsWalutaExist = mkwotaPln.Index(waluta)
	endsub

	int sub IsEqualPln(string waluta, float fval)
		if waluta == "" then waluta = "PLN"
		float kw = 0.0
		if(mkwotaPln.Index(waluta)) then kw = mkwotaPln.Get(waluta)
		IsEqualPln = !sign(fval - kw)		
	endsub

	float sub GetPln(string waluta)
		if waluta == "" then waluta = "PLN"
		if(mkwotaPln.Index(waluta)) then GetPln = mkwotaPln.Get(waluta)
	endsub

	int sub IsEqualWal(string waluta, float fval)
		if waluta == "" then waluta = "PLN"
		float kw = 0.0
		if(mkwotaWal.Index(waluta)) then kw = mkwotaWal.Get(waluta)
		IsEqualWal = !sign(fval - kw)		
	endsub

	float sub GetWal(string waluta)
		if waluta == "" then waluta = "PLN"
		if(mkwotaWal.Index(waluta)) then GetWal = mkwotaWal.Get(waluta)
	endsub

endrec

InfoKwota rStan
InfoKwota rStanRozr
InfoKwota rpierwszy
InfoKwota rstanval
InfoKwota rkwot
InfoKwota rkwotRozl

int rozlwwal
record RecPozycja
	int czyWNT
	float cena
	float kurs
	float cenawal
	float netto
	float ilosc
	float iloscWP
	float przel
	float akcyza
	float clo
int sub zeruj()
	cena=kurs=cenawal=netto=ilosc=iloscWP=przel=akcyza=clo=czyWNT=0
endsub
int sub Wczytaj()
	cenawal+=dp2.GetField("cenawal")
	netto+=dp2.GetField("wartNetto")
	ilosc+=dp2.GetField("ilosc")
	iloscwp+=dp2.GetField("iloscWP")
	clo+=dp2.GetField("cenaBazaPl")
	akcyza+=dp2.GetField("iloscjedn")
endsub
endrec
RecPozycja dkoryg(1)
RecPozycja dok	
int sub AddPoz(RecPozycja poz)
	float netto
	if sign(poz.kurs) then dok.kurs=poz.kurs
	dok.ilosc+=poz.ilosc
	dok.iloscwp+=poz.iloscwp
	dok.cenawal+=poz.cenawal
	dok.netto+=poz.netto
	dok.clo+=poz.clo
	dok.akcyza+=poz.akcyza
	if sign(dok.iloscWP,6) then dok.przel=dok.ilosc/dok.iloscWP
	if sign(dok.cenawal,6) && sign(dok.Ilosc,6) then 
		dok.cena=round(dok.cenawal*dok.IloscWP,2)/dok.Ilosc
		if !pn.GetField("waluta") then dok.Cena*=dok.kurs
	else
		if sign(dok.netto,3) && sign(dok.ilosc,6) then
			netto=dok.netto-dok.akcyza-IIF(dok.czyWNT,0,dok.clo)
			dok.cena=netto/dok.ilosc
			if pn.GetField("waluta") then dok.cena/=dok.kurs
		endif
	endif  
endsub	
int sub GetPoz()
int err
long super=dp2.GetField("super") 
int lp=dp2.GetField("lp")
	dp2.SetKey("super")
	dp2.SetKeySeg("super",super)
	dp2.SetKeySeg("lp",lp)
	err = dp2.GetRec(GE)
	if !dk2.GetRecByID(dp2.GetField("super")) then dkoryg(size(dkoryg)).kurs=dk2.GetField("kursdoch")
	while !err && dp2.GetField("lp")==lp && dp2.GetField("super")==super 
		dkoryg(size(dkoryg)).Wczytaj()
		err=dp2.GetRec(NX)
	wend
endsub
float sub zbierzAll()
	int i,bazowy,err
	long idpk
	long idpoz=dp.GetField("id")
		shrink dkoryg,-1
		dkoryg(1).Zeruj()
		dok.Zeruj()
		dok.czyWNT=!!(dk.GetField("subtypi")==115 || dk.GetField("subtypi")==121) 
		//zebranie wczeniejszych
		dp2.GetRecById(idpoz)
		do
			idpk=dp2.GetField("idpozkoryg")	
			if i then grow dkoryg,1
			GetPoz()
			i+=1
			if idpk then
				err=dp2.GetRecById(idpk)
			else
				err=1
			endif
		loop until err
		bazowy=i
	for i=bazowy to i<2 step -1
		AddPoz(dkoryg(i))
	next i
	if bazowy>1 then ZbierzAll=dok.cena*dok.Ilosc
	AddPoz(dkoryg(1))
	ZbierzAll=((dok.cena*dok.Ilosc)-ZbierzAll)*IIF(pn.getfield("waluta")!="",dok.kurs,1)
endsub


Record DaneRozrachunku
	float kwotaPln
	float kwotaWal
	float kursDoch
	int czy_imp
	float fWartWNT
EndRec

float sub DajWartoscRozrExt(DaneRozrachunku daneRoz)
	float fWart
	int err, czyDokOO
	daneRoz.czy_imp=0
	daneRoz.fWartWNT=0

	if dk.GetField("subtypi")==68|| dk.GetField("subtypi")==69 then	//dla f-ry zakupu (FVZ) bardziej wiarygodne s kwoty zotwkowe
		daneRoz.kwotaWal = round(dk.GetField("netto") + dk.GetField("vat"), 2)
		daneRoz.kursDoch = 1
		daneRoz.kwotaPln = daneRoz.kwotaWal
	else
		daneRoz.kwotaWal = dk.GetField("walBrutto")
		daneRoz.kursDoch = dk.GetField("kursdoch")
		daneRoz.kwotaPln = round(daneRoz.kwotaWal * daneRoz.kursDoch,2)
	endif

	if dk.GetField("subtypi")==72 || dk.GetField("subtypi")==115 || dk.GetField("subtypi")==73 || dk.GetField("subtypi")==121 then 	// gdy dok importowy "72" lub WNT "115"
		daneRoz.czy_imp=1
		dp.SetKey("super")
		dp.SetKeySeg("super",dk.GetField("id"))
		dp.SetKeySeg("lp",0)
		err=dp.GetRec(GE)
		fWart=0
		daneRoz.kwotaPln = 0
		while !err && dp.GetFIeld("super")==dk.GetField("id")
			if !(dp.GetField("typi") & 0x10) then 
				fWart=ZbierzAll() 
				daneRoz.kwotaPln+=fWart
				daneRoz.fWartWNT+=round(fWart/daneRoz.kursDoch,2)*daneRoz.kursDoch
			endif
			err=dp.GetRec(NX)
		wend

		daneRoz.kwotaWal = round(daneRoz.kwotaPln/daneRoz.kursDoch,2)
	else
		if dk.GetField("subtypi")==68|| dk.GetField("subtypi")==69 then
			dp.SetKey("super")
			dp.SetKeySeg("super",dk.GetField("id"))
			dp.SetKeySeg("lp",0)
			err=dp.GetRec(GE)
			fWart=0
			czyDokOO = 0

			while !err && dp.GetFIeld("super")==dk.GetField("id")

				if(dp.GetField("rejestrVAT2") != 255 && dp.GetField("rejestrVAT2") != 254) then	//pozycja OO
					czyDokOO = 1
					fWart += dp.GetField("wartNetto")
				else
					fWart += dp.GetField("wartNetto") + dp.GetField("wartVat")
				endif

				err=dp.GetRec(NX)
			wend

			if czyDokOO == 1 then	//o ile dokument ma pozycje OO to bieemy warto rozrachunku z pozycji
				daneRoz.kwotaPln = fWart
				daneRoz.kwotaWal = round(daneRoz.kwotaPln/daneRoz.kursDoch,2)
			endif
		endif
	endif
	#ifdef HM	
	dispatch xWpl = xFactory.NewObject("BWplataFPR")
	if (68 == dk.GetField("subtypi")) || (69 == dk.GetField("subtypi")) || (99 == dk.GetField("subtypi")) || (100 == dk.GetField("subtypi")) || (110 == dk.GetField("subtypi")) || (113 == dk.GetField("subtypi")) then
		xWpl.Load(Using "id=%l", dk.GetField("id"))
		daneRoz.kwotaPln += xWpl.wplata
		daneRoz.kwotaWal = round(daneRoz.kwotaPln/daneRoz.kursDoch,2)
	endif
#endif	
	DajWartoscRozrExt=daneRoz.kwotaPln
endsub

float sub DajWartoscRozr()
	DaneRozrachunku daneRoz
	DajWartoscRozrExt(daneRoz)
	DajWartoscRozr = daneRoz.kwotaPln
endsub

int sub CzyRozrWalutowy(string kod)
xt.SetKey("kod")
xt.SetKeySeg("typi",32)
xt.SetKeySeg("kod",kod)
xt.SetKeySeg("super",0)
if !xt.GetRec(GE) && xt.GetField("typi")==32 && xt.GetField("kod")==kod then	CzyRozrWalutowy = xt.GetField("flag") & 0x10
endsub
	
int sub ZapiszGwiazdki()
	int temp
	bylyGw=1
	temp=SetFont(stGw)
	TextOut(" *** ")
	SetFont(temp)
endsub
int sub CopyIPNtoPN(int ipnbase, BaseAll pnbase)
	pnbase.Clear()
	pnbase.SetField("id",GetField(ipnbase,"id"))
	pnbase.SetField("typi",GetField(ipnbase,"typi"))
	pnbase.SetField("subtypi",GetField(ipnbase,"subtypi"))
	pnbase.SetField("znaczniki",GetField(ipnbase,"znaczniki"))
	pnbase.SetField("osoba",GetField(ipnbase,"osoba"))
	pnbase.SetField("kod",GetField(ipnbase,"kod"))
	pnbase.SetField("rejestr",GetField(ipnbase,"rejestr"))
	pnbase.SetField("typdk",GetField(ipnbase,"typdk"))
	pnbase.SetField("seria",GetField(ipnbase,"seria"))
	pnbase.SetField("data",GetField(ipnbase,"data"))
	pnbase.SetField("termin",GetField(ipnbase,"termin"))
	pnbase.SetField("khid",GetField(ipnbase,"khid"))
	pnbase.SetField("khkod",GetField(ipnbase,"khkod"))
	pnbase.SetField("kwota",GetField(ipnbase,"kwota"))
	pnbase.SetField("kwotawal",GetField(ipnbase,"kwotawal"))
	pnbase.SetField("kurs",GetField(ipnbase,"kurs"))
	pnbase.SetField("waluta",GetField(ipnbase,"waluta"))
	pnbase.SetField("wyplatai",GetField(ipnbase,"wyplatai"))
	pnbase.SetField("typkhi",GetField(ipnbase,"typkhi"))
	pnbase.SetField("dzial",GetField(ipnbase,"dzial"))
	pnbase.SetField("okres",GetField(ipnbase,"okres"))
	pnbase.SetField("serianr",GetField(ipnbase,"serianr"))
	pnbase.SetField("opis",GetField(ipnbase,"opis"))
endsub

long sub FindDkid( int typ )
	FindDkid = 0
	dkb.SetKeySeg("typi",typ)
	dkb.SetKeySeg("kod",pn.GetField("kod"))
	if !dkb.GetRec(EQ) then FindDkid=dkb.GetField("id")
endsub

int sub SprawdzIPN()
	int ipn,errpom
	ipn=open KatalogFirmy()+"5ipn.dat" for base "IPN"
	BaseError(ipn,4)
	long pom
	dkb.Open()
	dkb.SetKey("numer")

	PopUp(1,"Sprawdzanie integralnoci bazy PN oraz IPN")
	PopUp(2,"")
	PopUp(3,"")
	pn.SetKey("id")
	SetKey(ipn,"id")
	err2=GetRec(ipn,FS)
	err=pn.GetRec(FS)
	progress.Reset(pn.GetRecordCount())
	while !err || !err2
		progress.NextOne()
		while !err2 && (err || GetField(ipn,"id")<pn.GetField("id"))
			if err || pn2.GetRecById(GetField(ipn,"id")) then
				if TextOutAndAsk(4,(using "Znaleziono rekord w bazie IPN id=%l ktry nie ma swojego odpowiednika w bazie PN",GetField(ipn,"id")),sAskRepair) then
					// odtwarzanie rekordu w bazie PN na podstawie rekordu w bazie IPN
					CopyIPNtoPN(ipn,pn)
					if pn.GetField("typi")&1 then pn.SetField("datarozl",pn.GetField("data"))
					pom = FindDkid(0)
					if !pom then pom = FindDkid(202)
					if !pom then pom = FindDkid(100)
					if !pom then pom = FindDkid(112)
					pn.SetField("dkid",pom)

					if !InsertRecB(pn) then err=pn.GetRec(NX)

				else
					TextOut(sNoRepair)
				endif			
			endif		
			err2=GetRec(ipn,NX)
		wend

		if err && err2 then exit

		pom = err2 || GetField(ipn,"id")!=pn.GetField("id")
		//if pn.GetField("typi")!=1 then
			if pom then
				if TextOutAndAsk(5,(using "Pozycja '%s' id=%l nie posiada swojego odpowiednika w bazie IPN",pn.GetField("kod"),pn.GetField("id")),sAskRepair) then
					UpdateRecB(pn)
				else
					TextOut(sNoRepair)
				endif
			endif
//		else
//			if !pom then
//				if TextOutAndAsk(6,(using "Znaleziono rekord w bazie IPN odpowiadajcy pozycji dokumentu anulowanego '%s' id=%l",pn.GetField("kod"),pn.GetField("id")),".\nCzy usun rekord z bazy IPN") then
//					DeleteRec(ipn,"IPN")
//				else
//					TextOut(sNoRepair)
//				endif
//			endif
//		endif

		pom = GetFIeld(ipn,"id")
		if (!err2 && GetField(ipn,"id")==pn.GetField("id")) || err then err2=GetRec(ipn,NX)
		if (!err && pom>=pn.GetField("id")) || err2 then err=pn.GetRec(NX)
	wend

	close ipn
	dkb.Close()
	WriteStatusBar("")
endsub

int sub PodajDzienRoku(string dat)
	int d
	buf=dat
	select case Val(find regular ":5??")
		case 1
			d=0
		case 2
			d=31
		case 3
			d=59
		case 4
			d=90
		case 5
			d=120
		case 6
			d=151
		case 7
			d=181
		case 8
			d=212
		case 9
			d=243
		case 10
			d=273
		case 11
			d=304
		case 12
			d=334
	endselect	
	d+=Val(find regular ":8??")
	move to 0
	if (Val(find regular ":0????")%4)==0 then d+=1
	PodajDzienRoku=d
endsub

string sub RozwinKod(string kod, string dat, long id, string user)
	int temp,dzien,miesiac,rok,dzienroku
	buf=data()
	rok=Val(find regular ":0????")
	miesiac=Val(find regular ":5??")
	dzien=Val(find regular ":8??")
	dzienroku=PodajDzienRoku(dat)

	buf=kod

	temp=1
	while temp
		temp=0
		move to 0
		temp+=(replace "#n",(using "%l",id))
		move to 0
		temp+=(replace "#d",(using "%d",dzien))
		move to 0
		temp+=(replace "#D",(using "%02d",dzien))
		move to 0
		temp+=(replace "#m",(using "%d",miesiac))
		move to 0
		temp+=(replace "#M",(using "%02d",miesiac))
		move to 0
		temp+=(replace "#r",(using "%d",rok%100))
		move to 0
		temp+=(replace "#R",(using "%04d",rok))
		move to 0
		temp+=(replace "#u",user)
		move to 0
		temp+=(replace "#q",(using "%d",dzienroku))
		move to 0
		temp+=(replace "#Q",(using "%03d",dzienroku))
	wend
	RozwinKod=Buf
endsub
float sub ZliczKwote( string k1,string k2, long id )
	rozlwwal=0
	wynikRL.Zeruj()
	khid=0 : khkod=""
	ZliczKwote=0
	SetKey(rl2,"cross"+k1)
	buf="id"+k1
	SetKeySeg(rl2,buf,id)
	SetKeySeg(rl2,"id"+k2,0)
	err=GetRec(rl2,GE)
	while !err && GetField(rl2,buf)==id
		WynikRL.wartosc+=GetField(rl2,"wartosc")
		WynikRL.wartrozl1+=GetField(rl2,"wartrozl"+k1)
		if !khId then
			pn3.SetKey("id")
			pn3.SetKeySeg("id",GetField(rl,"id"+k2))
			if !pn3.GetRec(EQ) then khid=pn3.GetField("khid") : khkod=pn3.GetField("khkod")
		endif
		err=GetRec(rl2,NX)
	wend
	rozlwwal=!!(sign(WynikRL.wartosc-wynikRL.wartrozl1,2))
	ZliczKwote=WynikRL.wartosc
endsub

int sub PrzepiszPola()
	float fkurs
	pn.SetField("dkid",dk.GetField("id"))
	pn.SetField("khid",dk.GetField("khid"))
	pn.SetField("khkod",dk.GetField("khkod"))
	pn.SetField("data",dk.GetField("data"))
	pn.SetField("termin",dk.GetField("plattermin"))
	pn.SetField("rejestr",dk.GetField("plattypi"))
	pn.SetField("osoba",dk.GetField("osoba"))
	pn.SetField("kod",dk.GetField("kod"))
	pn.SetField("typdk",dk.GetField("typ_dk"))
	pn.SetField("seria",dk.GetField("seria"))
	pn.SetField("serianr",dk.GetField("serianr"))
	pn.SetField("okres",dk.GetField("okres"))
	pn.SetField("dzial",dk.GetField("dzial"))
	pn.SetField("kwotarozl",dk.GetField("wplaty"))
	fkurs=IIF(sign(dk.GetField("kursdoch"),6),dk.GetField("kursdoch"),1)
	if !CzyRozrWalutowy(dk.GetField("typ_dk")) then
		 fKurs=1
	else
		pn.SetField("waluta",dk.GetField("waluta"))
	endif	
	pn.SetField("kurs",fKurs)
	pn.SetField("typi",0)//zakadam e nierozliczony
	pn.SetField("kwotawal",round((dk.GetField("netto")+dk.GetField("vat"))/fkurs,2))//nie uwzgldniam kwot rozliczonych(trzeba zliczy RL-ki
//	if !Sign(pn.GetField("kwotarozl")-pn.GetField("kwota")) then pn.SetField("typi",1)
	if Sign(dk.GetField("netto"))<0 then pn.SetField("wyplatai",1)
endsub


#include  "Diagnostyka patnoci i rozrachunkw - include 2"

